'BREADAMP_v05_REUmaker
'-------------------------
'This program was coded by daddlerTL in 2019-2020 and is used to create REU files for the Commodore 64 program BREADAMP v03 and
'later, a sample music player that uses the REU of the 1541ultimate or Turbo Chameleon 64 as a storage device for the music files.
'
'This program is written with QB64 and can be compiled with it.
'
'The program and code is freeware. If you publish an altered version of this program please provide the altered source code
'and keep my name daddlerTL in the program and source code
'
'-------------------------------------------------------------------------------------------------------------------------------
'
'Dieses Programm wurde in den Jahren 2019-2020 von daddlerTL erstellt und erstellt REU-Dateien fuer das Commodore 64-Programm
'BREADAMP v03 und hoeher, ein Samplemusikplayer der die REU der 1541ultimate oder des Turbo Chameleons 64 als Datentraeger
'fuer die Musikdateien nutzt.
'
'Dieses Programm wurde in QB64 geschrieben und kann damit kompiliert werden.
'
'Das Programm und der Code ist Freeware. Wenn du eine geaenderte Version veroeffentlichst, bitte den geaenderten Quellcode
'beilegen und meinen Name daddlerTL im Code und Programm belassen.

'-- PAL --
samplerate_1 = 15638
samplerate_2 = 11728
samplerate_3 = 7819
samplerate_4 = 5864
c64typ = 0

'-- NTSC --
samplerate_5 = 15734
samplerate_6 = 7867

'-- Ultimate Audio --
samplerate_ua_1 = 22050
samplerate_ua_2 = 32000
samplerate_ua_3 = 44100
samplerate_ua_4 = 48000

_TITLE "BREADAMP v05 REUmaker - erstellt von daddlerTL (2020)"

DIM leer AS STRING * 16777216 'REU-Groesse
DIM tracklist$(14)
DIM tracklaenge(14), tracklaenge$(14), trackname$(14), wavsamples(14), wavsamplerate(14), wavbits(14), endung$(14), wavkanaele(15), wav_mit_wahlmoeglichkeit(14), zielformat(14), sid$(14), lup$(14)
DIM wave AS STRING * 50000 'Speicher fuer Wave-Datei
DIM wave16 AS STRING * 16777216 '16 MiB fuer Direktkopie von 16-Bit-Tracks
DIM freierspeicher AS LONG, dateipos AS LONG, x AS LONG, wavlen1 AS LONG, wavlen2 AS LONG, speicherbedarf AS LONG, speicherbedarf(14) AS LONG, trackbytes(14) AS LONG, minbytes AS LONG 'verhindert x.xxE0y-Darstellung der Zahlen und Ungenauigkeiten
DIM lup(1, 255)
DIM block AS LONG
infozeile1$ = CHR$(107): FOR i = 1 TO 38: infozeile1$ = infozeile1$ + CHR$(64): NEXT: infozeile1$ = infozeile1$ + CHR$(115) + CHR$(93)

CLS
PRINT "              BREADAMP v05 REUmaker - erstellt von daddlerTL"
PRINT "-+--------------------------------------------------------------------------+-"


'Wavedateien parsen
a$ = COMMAND$
IF COMMAND$ = "" THEN PRINT "Bitte die zu konvertierende(n) wav-Datei(en)": PRINT "auf die BREADAMP_v05_REUmaker.exe per Drag & Drop ziehen !": END
trackanzahl = 0

p = 0 'p = Position in a$
pfad$ = ""
parsen:
DO
    p = p + 1
LOOP UNTIL MID$(a$, p, 1) = "." OR MID$(a$, p + 3, 1) = ":" OR p = LEN(a$)
pos1 = p
pos2 = p


DO
    pos2 = pos2 + 1
LOOP UNTIL MID$(a$, pos2, 1) = " " OR pos2 = LEN(a$)
DO
    pos1 = pos1 - 1
LOOP UNTIL MID$(a$, pos1, 1) = "\"
IF pfad$ = "" THEN pfad$ = LEFT$(a$, pos1)
IF MID$(a$, pos2, 1) = " " THEN l = 1 ELSE l = 0
datei$ = MID$(a$, pos1 + 1, p - pos1 - 1)
endung$(trackanzahl + 1) = MID$(a$, p, pos2 - p + 1 - l)
trackanzahl = trackanzahl + 1: tracklist$(trackanzahl) = datei$
trackname$(trackanzahl) = datei$
IF LEFT$(datei$, 1) >= "0" AND LEFT$(datei$, 1) <= "9" AND MID$(datei$, 2, 1) >= "0" AND MID$(datei$, 2, 1) <= "9" AND MID$(datei$, 3, 1) = " " THEN trackname$(trackanzahl) = RIGHT$(datei$, LEN(datei$) - 3) 'fuehrende Tracknummer entfernen, falls vorhanden
trackname$(trackanzahl) = LEFT$(trackname$(trackanzahl) + "                            ", 29)
'END IF
IF trackanzahl < 14 AND pos2 < LEN(a$) THEN p = pos2: GOTO parsen


'Waveheader
tracklaengegesamt = 0
nicht_ua = 0
wavs_mit_wahlmoeglichkeit = 0
minbytes = 0
maxbytes = 0
PAL_NTSC_Mix = 0
PAL_Tracks = 0
NTSC_Tracks = 0
FOR wavnr = 1 TO trackanzahl
    wavstart = 44
    'PRINT "Wavedatei "; RIGHT$(STR$(wavnr + 100), 2); ": ";
    'PRINT pfad$ + tracklist$(wavnr) + endung$(wavnr)
    OPEN pfad$ + tracklist$(wavnr) + endung$(wavnr) FOR INPUT AS #1
    wavlen1 = LOF(1)
    CLOSE 1
    OPEN pfad$ + tracklist$(wavnr) + endung$(wavnr) FOR BINARY AS #1
    GET #1, 1, wave
    dateilaenge = LOF(1)
    CLOSE 1
    IF LEFT$(wave, 4) <> "RIFF" THEN CLS: PRINT "Eingabedatei ist keine Standard-Wave-Datei !": GOTO wavfehler
    kein_data_feld:
    wavlen2 = 256 * 256 * 256 * ASC(MID$(wave, wavstart, 1)) + 256 * 256 * ASC(MID$(wave, wavstart - 1, 1)) + 256 * ASC(MID$(wave, wavstart - 2, 1)) + ASC(MID$(wave, wavstart - 3, 1)) 'Laenge des Datenblocks
    IF MID$(wave, wavstart - 7, 4) <> "data" THEN
        wavstart = wavstart + wavlen2 + 8 'wenn Feld nicht "data" ist, addiere die ermittelte Laenge zum wavstart und lese den naechsten Feldname
        IF wavstart >= dateilaenge THEN PRINT "Fehler: data-Feld nicht gefunden in der Datei": PRINT tracklist$(wavnr); endung$(wavnr): GOTO wavfehler
        GOTO kein_data_feld
    END IF
    'PRINT "Groesse: "; wavlen2; "Bytes, ";
    IF MID$(wave, 9, 8) <> "WAVEfmt " THEN CLS: PRINT "Eingabedatei ist keine Standard-Wave-Datei !": GOTO wavfehler
    IF ASC(MID$(wave, 17, 1)) <> 16 THEN CLS: PRINT "Eingabedatei ist keine Standard-Wave-Datei !": GOTO wavfehler
    IF ASC(MID$(wave, 21, 1)) + 256 * ASC(MID$(wave, 22, 1)) <> 1 THEN CLS: PRINT "Wavedatei ist komprimiert und kann von diesem Programm": PRINT "nicht verarbeitet werden !": GOTO wavfehler
    wavkanaele(wavnr) = ASC(MID$(wave, 23, 1)) + 256 * ASC(MID$(wave, 24, 1)): IF wavkanaele(wavnr) > 2 THEN CLS: PRINT "Wavedatei hat mehr als 2 Kanaele und kann von diesem": PRINT "Programm nicht verarbeitet werden !": GOTO wavfehler
    wavsamplerate(wavnr) = ASC(MID$(wave, 25, 1)) + 256 * ASC(MID$(wave, 26, 1)) + 256 * 256 * ASC(MID$(wave, 27, 1)) + 256 * 256 * 256 * ASC(MID$(wave, 28, 1))
    IF wavsamplerate(wavnr) = samplerate_ua_1 OR wavsamplerate(wavnr) = samplerate_ua_2 OR wavsamplerate(wavnr) = samplerate_ua_3 OR wavsamplerate(wavnr) = samplerate_ua_4 OR ((wavsamplerate(wavnr) = samplerate_1 OR wavsamplerate(wavnr) = samplerate_5) AND wavkanaele(wavnr) = 2) THEN ultimate_audio = 1: ultimate_audio(wavnr) = 1: GOTO ua_skip
    IF wavsamplerate(wavnr) = samplerate_1 OR wavsamplerate(wavnr) = samplerate_2 OR wavsamplerate(wavnr) = samplerate_3 OR wavsamplerate(wavnr) = samplerate_4 THEN PAL_Tracks = 1
    IF wavsamplerate(wavnr) = samplerate_5 OR wavsamplerate(wavnr) = samplerate_6 THEN NTSC_Tracks = 1: c64typ = 1
    IF wavsamplerate(wavnr) <> samplerate_1 AND wavsamplerate(wavnr) <> samplerate_2 AND wavsamplerate(wavnr) <> samplerate_3 AND wavsamplerate(wavnr) <> samplerate_4 AND wavsamplerate(wavnr) <> samplerate_5 AND wavsamplerate(wavnr) <> samplerate_6 THEN CLS: PRINT "Es werden nur folgende Sampleraten unterstuetzt:": PRINT "PAL: "; samplerate_1; "/"; samplerate_2; "/"; samplerate_3; "/"; samplerate_4; "Hz": PRINT "NTSC:"; samplerate_5; "/"; samplerate_6; "Hz": PRINT "Ultimate Audio: wie PAL / NTSC und"; samplerate_ua_1; "/"; samplerate_ua_2; "/"; samplerate_ua_3; "/"; samplerate_ua_4; "Hz": GOTO wavfehler
    ua_skip:
    wavbits(wavnr) = ASC(MID$(wave, 35, 1)) + 256 * ASC(MID$(wave, 36, 1))
    IF wavbits(wavnr) = 16 THEN
        ultimate_audio = 1: ultimate_audio(wavnr) = 1
    ELSE IF wavbits(wavnr) <> 8 THEN CLS: PRINT "Es werden nur Wavedateien mit 8 oder 16 Bits/Sample unterstuetzt !": GOTO wavfehler
    END IF
    tracklaenge(wavnr) = INT(wavlen2 / wavkanaele(wavnr) / wavsamplerate(wavnr)):
    tracklaenge$(wavnr) = RIGHT$(STR$(INT(tracklaenge(wavnr) / 60) + 100), 2) + ":" + RIGHT$(STR$(tracklaenge(wavnr) - (INT(tracklaenge(wavnr) / 60) * 60) + 100), 2)
    wavsamples(wavnr) = wavlen2 * 8 / wavbits(wavnr)
    tracklaengegesamt = tracklaengegesamt + tracklaenge(wavnr)
    zielformat(wavnr) = 1 '8 Bit, 15638 Hz
    'pruefen, ob Format mit Wahlmoeglichkeit (Mono, samplerate_3 oder _4) und berechnen, wieviel Platz mindestens noetig ist
    IF wavkanaele(wavnr) = 1 AND (wavsamplerate(wavnr) = samplerate_3 OR wavsamplerate(wavnr) = samplerate_4 OR wavsamplerate(wavnr) = samplerate_6) THEN
        minbytes = minbytes + INT(wavlen2 / 2 + 0.6) 'sorgt dafuer dass fuer 4 Bit ein angefangenes Byte als Ganzes gerechnet wird
        maxbytes = maxbytes + wavlen2
        wavs_mit_wahlmoeglichkeit = wavs_mit_wahlmoeglichkeit + 1
        wav_mit_wahlmoeglichkeit(wavnr) = 1
    ELSE
        minbytes = minbytes + wavlen2
        maxbytes = maxbytes + wavlen2
        wav_mit_wahlmoeglichkeit(wavnr) = 0
    END IF
NEXT
gesamtminuten = INT(tracklaengegesamt / 60)
gesamtsekunden = INT(tracklaengegesamt - 60 * gesamtminuten)

freierspeicher = 16777216 - 704 '256 Bytes fuer "Inhaltsverzeichnis" + 448 Bytes fuer Tracknamen

IF minbytes > freierspeicher OR (PAL_Tracks = 1 AND NTSC_Tracks = 1 AND maxbytes > freierspeicher) THEN CLS: PRINT "Gewaehlte wav-Datei(en) sind zu lang, Konvertierung nicht moeglich.": PRINT "Bitte weniger bzw. kuerzere wav-Datei(en) waehlen.": END



'Tracks auflisten
IF wavs_mit_wahlmoeglichkeit = 0 THEN cursorpos = -1: GOTO listtracks
cursorpos = 1
DO UNTIL wav_mit_wahlmoeglichkeit(cursorpos) = 1
    cursorpos = cursorpos + 1
LOOP
listtracks:
LOCATE 3, 1
speicherbedarf = 0
FOR i = 1 TO trackanzahl
    IF i = cursorpos THEN PRINT ">"; ELSE PRINT " ";
    IF wavkanaele(i) = 1 THEN format$ = "Mono  " ELSE format$ = "Stereo"
    format$ = format$ + RIGHT$("  " + STR$(wavbits(i)), 3) + " Bit, " + RIGHT$(STR$(wavsamplerate(i)), 5) + " Hz"
    speicherbedarf(i) = INT(wavsamples(i) * wavbits(i) / 8 + 0.6)
    trackbytes(i) = speicherbedarf(i)
    IF (wavkanaele(i + 1) = 2 OR wavbits(i + 1) = 16) AND (speicherbedarf + speicherbedarf(i)) / 2 <> INT((speicherbedarf + speicherbedarf(i)) / 2) THEN speicherbedarf(i) = speicherbedarf(i) + 1 'auf geraden Bytewert aufrunden, damit ein Stereosamplepaar oder 16 Bit-Sample nicht uber eine Pagegrenze geht
    IF (wavkanaele(i + 1) = 2 AND wavbits(i + 1) = 16) AND (speicherbedarf + speicherbedarf(i)) / 4 <> INT((speicherbedarf + speicherbedarf(i)) / 4) THEN speicherbedarf(i) = speicherbedarf(i) + 2 'bei Tracks mit Stereo und 16 Bit auf durch 4 teilbare Adresse aufrunden, um Probleme an Pagegrenzen zu vermeiden
    PRINT RIGHT$(STR$(i + 100), 2); " "; trackname$(i); "  "; tracklaenge$(i); " "; format$; " "; RIGHT$("        " + STR$(speicherbedarf(i)), 8); " Bytes";
    IF i = cursorpos THEN PRINT "<" ELSE PRINT " "
    speicherbedarf = speicherbedarf + speicherbedarf(i)
NEXT
PRINT TAB(66); "--------"
IF speicherbedarf > freierspeicher THEN COLOR 12
PRINT TAB(66); RIGHT$("        " + STR$(speicherbedarf), 8); " Bytes"
COLOR 7
'Tastatureingabe zwecks Formateinstellung (wird uebersprungen, wenn es keine Wahlmoeglichkeiten gibt)
IF wavs_mit_wahlmoeglichkeit = 0 THEN GOTO skip1
PRINT: PRINT "Mit Cursor hoch/runter zum naechsten einstellbaren Track springen"
PRINT "Mit Cursor links/rechts zwischen 8 und 4 Bit wechseln"
IF speicherbedarf <= freierspeicher THEN PRINT "Mit Enter Einstellung beenden und mit Konvertierung fortfahren" ELSE PRINT "                                                                               "
DO
    a$ = INKEY$
LOOP UNTIL a$ = CHR$(0) + CHR$(72) OR a$ = CHR$(0) + CHR$(75) OR a$ = CHR$(0) + CHR$(77) OR a$ = CHR$(0) + CHR$(80) OR a$ = CHR$(13)
IF a$ = CHR$(0) + CHR$(72) THEN
    wdh1:
    cursorpos = cursorpos - 1: IF cursorpos = 0 THEN cursorpos = trackanzahl 'Cursor hoch
    IF wav_mit_wahlmoeglichkeit(cursorpos) = 0 THEN GOTO wdh1
END IF
IF a$ = CHR$(0) + CHR$(80) THEN
    wdh2:
    cursorpos = cursorpos + 1: IF cursorpos > trackanzahl THEN cursorpos = 1 'Cursor runter
    IF wav_mit_wahlmoeglichkeit(cursorpos) = 0 THEN GOTO wdh2
END IF
IF a$ = CHR$(0) + CHR$(75) THEN IF wavbits(cursorpos) = 8 THEN wavbits(cursorpos) = 4 ELSE wavbits(cursorpos) = 8 'Cursor links
IF a$ = CHR$(0) + CHR$(77) THEN IF wavbits(cursorpos) = 8 THEN wavbits(cursorpos) = 4 ELSE wavbits(cursorpos) = 8 'Cursor rechts (gleiche Funktion wie Cursor links)
IF a$ <> CHR$(13) OR speicherbedarf > freierspeicher THEN GOTO listtracks
skip1:


'Abfrage welches Format verwendet werden soll
achtbit = 0
sechzehnbit = 0
wavsmit8bit = 0
stereo = 0
dateisuffix$ = ""
digimaxabfrage = 0
anzahl_ua_tracks = 0
sid$ = ""

FOR i = 1 TO trackanzahl
    IF wavbits(i) = 8 THEN achtbit = 1: wavsmit8bit = wavsmit8bit + 1
    IF wavbits(i) = 16 THEN sechzehnbit = 1
    IF wavkanaele(i) = 2 AND ultimate_audio(i) = 0 THEN stereo = 1
    IF PAL_Tracks = 1 AND NTSC_Tracks = 1 THEN PAL_NTSC_Mix = 1: ultimate_audio = 1: ultimate_audio(i) = 1
    IF ultimate_audio(i) = 1 THEN anzahl_ua_tracks = anzahl_ua_tracks + 1
NEXT

IF sechzehnbit = 1 AND anzahl_ua_tracks < trackanzahl THEN PRINT: PRINT "16 Bit-Tracks werden ins Ultimate Audio - Format konvertiert."
IF PAL_NTSC_Mix = 1 THEN PRINT "PAL- und NTSC-Sampleraten in den wav-Dateien entdeckt.": PRINT "Diese Mischung wird nur von Ultimate Audio unterstuetzt.": sid$ = "7"
IF anzahl_ua_tracks = trackanzahl THEN PRINT "Alle Tracks werden ins Ultimate Audio - Format konvertiert.": sid$ = "7"
IF achtbit = 1 AND anzahl_ua_tracks < trackanzahl THEN
    PRINT: PRINT "In welches Format sollen die 8 Bit-Tracks konvertiert werden ?"
    IF anzahl_ua_tracks < trackanzahl THEN
        PRINT "  1  Mahoney fuer SID 6581"
        PRINT "  2  Mahoney fuer SID 8580"
        PRINT "  3  Linear  fuer FPGASID"
        IF stereo = 0 THEN PRINT "  4  Digimax"
        IF stereo = 1 THEN
            PRINT "  5  Mahoney fuer SID 6581 + 8580 (nur bei Stereotracks, bei Mono nur 6581)"
            PRINT "  6  Mahoney fuer SID 8580 + 6581 (nur bei Stereotracks, bei Mono nur 8580)"
        END IF
    END IF
    PRINT "  7  Ultimate Audio"
    IF wavsmit8bit > 1 THEN PRINT "  8  fuer jeden 8 Bit-Track individuell festlegen (zum Testen)"

    DO
        sid$ = INKEY$
    LOOP UNTIL sid$ = "1" OR sid$ = "2" OR sid$ = "3" OR (sid$ = "4" AND stereo = 0) OR (sid$ = "5" AND stereo = 1) OR (sid$ = "6" AND stereo = 1) OR sid$ = "7" OR (sid$ = "8" AND wavsmit8bit > 1)

    IF sid$ = "4" THEN digimaxabfrage = 1
    IF sid$ = "8" THEN GOTO sideinstellung_individuell

END IF

FOR i = 1 TO trackanzahl 'wenn keine individuelle Einstellung pro Track, dann alle Einstellungsspeicher mit gewaehlten Werten fuellen
    sid$(i) = sid$
    IF ultimate_audio(i) = 1 THEN sid$(i) = "7"
    lup$(i) = "1"
NEXT

IF sid$ = "1" THEN dateisuffix$ = "_6581"
IF sid$ = "2" THEN dateisuffix$ = "_8580"
IF sid$ = "3" THEN dateisuffix$ = "_FPGA"
IF sid$ = "4" THEN dateisuffix$ = "_Digimax"
IF sid$ = "5" THEN dateisuffix$ = "_6581+8580"
IF sid$ = "6" THEN dateisuffix$ = "_8580+6581"
IF sid$ = "7" THEN dateisuffix$ = "_UA"
IF sid$ <> "7" AND anzahl_ua_tracks < trackanzahl AND anzahl_ua_tracks > 0 THEN dateisuffix$ = ""

sideinstellung_individuell_ende:

IF digimaxabfrage = 1 THEN
    PRINT: PRINT "Welcher Digimax-Typ ? u = Userport, c = Cartridge (Modul)"
    DO
        a$ = INKEY$
    LOOP UNTIL a$ = "u" OR a$ = "c"
    IF a$ = "u" THEN digimaxtyp = 0 ELSE digimaxtyp = 1
END IF


'BREADAMP-Datei vorbereiten
dateiname$ = "BREADAMP" + dateisuffix$ + ".reu"
OPEN pfad$ + dateiname$ FOR BINARY AS #1
PUT #1, 1, leer

'Header schreiben
a$ = "BREADAMP05REUFS" + CHR$(15)
PUT #1, 1, a$
a$ = "reserved entry  "
FOR i = 1 TO 14: PUT #1, 16 * i + 1, a$: NEXT
dateipos = 705 'Position des ersten Tracks in der Datei
x = dateipos - 1
'Trackverzeichnis und Trackinfos
FOR i = 1 TO trackanzahl
    d1 = INT(x / 65536): d2 = INT((x - d1 * 65536) / 256): d3 = x - d1 * 65536 - d2 * 256
    s1 = INT(trackbytes(i) / 65536): s2 = INT((trackbytes(i) - s1 * 65536) / 256): s3 = trackbytes(i) - s1 * 65536 - s2 * 256
    a$ = "TRACK " + RIGHT$(STR$(i + 100), 2) + "  " + CHR$(d1) + CHR$(d2) + CHR$(d3) + CHR$(s1) + CHR$(s2) + CHR$(s3)
    PUT #1, 16 * i + 1, a$

    'Metadaten fuer die Tracks:
    'meta1: Bit 7: 0=PAL, 1=NTSC; Bit 6: 0=Mono, 1=Stereo; Bit 4+3+2: 0=unbekannt, 1=6581, 2=8580, 3=FPGASID, 4=Digimax, 5=6581+8580, 6=8580+6581, 7=Ultimate Audio; Bit 1+0: 1=Mahoney, 2=Classic packed, 3=linear fuer FPGASID
    'meta2: Bits 7-6: zusaetzliche Formatinformationen fuer Mahoney und Digimax, Bits 4-0 Bits/sample: 4, 8 oder 16
    'meta3 = Samplerate: linkes Halbbyte kHz, rechtes Halbbyte Zehntel-kHz
    c64typ = 0: IF wavsamplerate(i) = samplerate_5 OR wavsamplerate(wavnr) = samplerate_6 THEN c64typ = 1
    meta1 = 128 * c64typ + 64 * (wavkanaele(i) - 1) 'PAL/NTSC + Mono/Stereo
    IF wavbits(i) = 16 THEN
        meta1 = meta1 + 7 * 4 + 3 'bei 16 Bit nur Ultimate Audio, Linear
        meta2 = 16
    END IF
    IF wavbits(i) = 8 THEN
        meta1 = meta1 + VAL(sid$(i)) * 4 'SID/Ausgabe-Typ
        IF sid$(i) = "3" OR sid$(i) = "7" THEN
            meta1 = meta1 + 3 'Format "Linear fuer FPGASID/Ultimate Audio"
        ELSEIF sid$(i) = "4" THEN 'nichts machen fuer Format "linear fuer Digimax" (Bit 1+0 bleibt 00)
        ELSE meta1 = meta1 + 1 'Format "Mahoney"
        END IF
        meta2 = 8
    END IF
    IF wavbits(i) = 4 THEN
        meta1 = meta1 + 2 'Format "Classic packed"
        meta2 = 4
    END IF
    IF sid$(i) = "4" THEN meta2 = meta2 + digimaxtyp * 64 'Bit 6 in meta2 setzen bei Digimax-Track und wenn als Digimax-Typ die Cartridge gewaehlt wurde
    IF sid$(i) = "1" OR sid$(i) = "2" OR sid$(i) = "5" OR sid$(i) = "6" THEN meta2 = meta2 + VAL(lup$(i)) * 64 'bei Mahoney-Tracks die verwendete Lookuptabelle in die Bits 6 und 7 in meta2 eintragen (01 = 256, 10 = 128, 11 = 64 lineare Werte)

    IF wavsamplerate(i) < 16000 THEN
        kHz = INT(wavsamplerate(i) / 1000): hundertHz = INT((wavsamplerate(i) - 1000 * kHz) / 100): meta3 = kHz * 16 + hundertHz 'bei <16 kHz: kHz + Hunderter Hz -> 15638 Hz ergibt $F6
    ELSE kHzZ = INT(wavsamplerate(i) / 10000): kHzE = INT(wavsamplerate(i) / 1000) - kHzZ * 10: meta3 = 16 * kHzZ + kHzE 'bei >=16 kHz: Zehner kHz + Einer kHz -> 44100 Hz ergibt $44
    END IF
    a$ = ascii2screencode$(trackname$(i), 29) + CHR$(meta1) + CHR$(meta2) + CHR$(meta3)
    PUT #1, 14 * 16 + 1 + i * 32, a$ 'Trackinfo fuer Track 1 beginnt bei Pos 257 = $000100 in der REU
    x = x + speicherbedarf(i)
NEXT
'Dir-Eintrag fuer Trackinfos
a$ = "TRACKINFOS" + CHR$(0) + CHR$(1) + CHR$(0) + CHR$(0) + CHR$(1) + CHR$(192) '448 Bytes fuer Trackinfos in Inhaltsverzeichnis
PUT #1, 241, a$



'konvertieren
PRINT
FOR wavnr = 1 TO trackanzahl
    '...Lookuptabelle waehlen
    kanal = 0
    IF wavbits(wavnr) = 8 THEN
        IF sid$(wavnr) = "1" THEN
            IF lup$(wavnr) = "1" THEN GOSUB lookup_m_6581_256: kanal = 1: GOSUB lookup_m_6581_256
            IF lup$(wavnr) = "2" THEN GOSUB lookup_m_6581_128: kanal = 1: GOSUB lookup_m_6581_128
            IF lup$(wavnr) = "3" THEN GOSUB lookup_m_6581_64: kanal = 1: GOSUB lookup_m_6581_64
        END IF
        IF sid$(wavnr) = "2" THEN
            IF lup$(wavnr) = "1" THEN GOSUB lookup_m_8580_256: kanal = 1: GOSUB lookup_m_8580_256
            IF lup$(wavnr) = "2" THEN GOSUB lookup_m_8580_128: kanal = 1: GOSUB lookup_m_8580_128
            IF lup$(wavnr) = "3" THEN GOSUB lookup_m_8580_64: kanal = 1: GOSUB lookup_m_8580_64
        END IF
        IF sid$(wavnr) = "3" OR sid$(wavnr) = "7" THEN GOSUB lookup_fpgasid: kanal = 1: GOSUB lookup_fpgasid
        IF sid$(wavnr) = "5" THEN
            IF lup$(wavnr) = "1" THEN GOSUB lookup_m_6581_256: kanal = 1: GOSUB lookup_m_8580_256
            IF lup$(wavnr) = "2" THEN GOSUB lookup_m_6581_128: kanal = 1: GOSUB lookup_m_8580_128
            IF lup$(wavnr) = "3" THEN GOSUB lookup_m_6581_64: kanal = 1: GOSUB lookup_m_8580_64
        END IF
        IF sid$(wavnr) = "6" THEN
            IF lup$(wavnr) = "1" THEN GOSUB lookup_m_8580_256: kanal = 1: GOSUB lookup_m_6581_256
            IF lup$(wavnr) = "2" THEN GOSUB lookup_m_8580_128: kanal = 1: GOSUB lookup_m_6581_128
            IF lup$(wavnr) = "3" THEN GOSUB lookup_m_8580_64: kanal = 1: GOSUB lookup_m_6581_64
        END IF
    ELSE
        GOSUB lookup_4_bit
    END IF

    PRINT "konvertiere Track"; wavnr; "..."
    zeile = CSRLIN - 1
    OPEN pfad$ + tracklist$(wavnr) + endung$(wavnr) FOR BINARY AS #2
    newwave$ = ""
    IF wavbits(wavnr) = 16 THEN
        GET #2, 1 + wavstart, wave16 'Sampledaten komplett laden
        newwave$ = LEFT$(wave16, trackbytes(wavnr))
    END IF

    IF wavbits(wavnr) = 8 THEN
        IF sid$(wavnr) = "4" THEN 'Digimax
            GET #2, 1 + wavstart, wave16
            newwave$ = LEFT$(wave16, trackbytes(wavnr))
        ELSE

            FOR j = 0 TO INT(trackbytes(wavnr) / 10000) 'Standard-SID oder FPGASID
                newwavepart$ = ""
                block = 10000 * j
                LOCATE zeile, 25
                PRINT block; "Bytes konvertiert"
                GET #2, block + 1 + wavstart, wave '44 Byte (ggf. anderer Wert bei nichtstandart-wav) Waveheader ueberspringen
                IF wavkanaele(wavnr) = 1 THEN 'Mono
                    IF block + 10000 <= trackbytes THEN
                        FOR i = 1 TO 10000
                            sample = ASC(MID$(wave, i, 1))
                            newwavepart$ = newwavepart$ + CHR$(lup(0, sample))
                        NEXT
                    ELSE
                        FOR i = 1 TO 10000
                            IF block + i <= LOF(2) THEN sample = ASC(MID$(wave, i, 1)) ELSE sample = 128 'bringt Samples nach Dateiende auf 128 (=Stille) und verhindert dadurch zusaetzliches Knacken beim Trackwechsel
                            newwavepart$ = newwavepart$ + CHR$(lup(0, sample))
                        NEXT
                    END IF
                ELSE 'Stereo
                    IF block + 10000 <= trackbytes THEN
                        FOR i = 1 TO 5000
                            sample = ASC(MID$(wave, 2 * i - 1, 1))
                            newwavepart$ = newwavepart$ + CHR$(lup(0, sample))
                            sample = ASC(MID$(wave, 2 * i, 1))
                            newwavepart$ = newwavepart$ + CHR$(lup(1, sample))
                        NEXT
                    ELSE
                        FOR i = 1 TO 5000
                            IF block + 2 * i - 1 <= LOF(2) THEN sample = ASC(MID$(wave, 2 * i - 1, 1)) ELSE sample = 128 'bringt Samples nach Dateiende auf 128 (=Stille) und verhindert dadurch zusaetzliches Knacken beim Trackwechsel
                            newwavepart$ = newwavepart$ + CHR$(lup(0, sample))
                            IF block + 2 * i <= LOF(2) THEN sample = ASC(MID$(wave, 2 * i, 1)) ELSE sample = 128
                            newwavepart$ = newwavepart$ + CHR$(lup(1, sample))
                        NEXT
                    END IF
                END IF

                newwave$ = newwave$ + newwavepart$
            NEXT
        END IF
    END IF
    IF wavbits(wavnr) = 4 THEN
        FOR j = 0 TO INT(speicherbedarf(wavnr) / 5000)
            newwavepart$ = ""
            block = 10000 * j
            LOCATE zeile, 25
            PRINT block / 2; "Bytes konvertiert"
            GET #2, block + 1 + wavstart, wave '44 Byte (ggf. anderer Wert bei nichtstandart-wav) Waveheader ueberspringen
            IF block + 10000 <= LOF(2) THEN
                FOR i = 1 TO 5000
                    sample1 = ASC(MID$(wave, 2 * i - 1, 1))
                    sample2 = ASC(MID$(wave, 2 * i, 1))
                    newwavepart$ = newwavepart$ + CHR$(lup(0, sample1) * 16 + lup(0, sample2)) 'zwei 4-Bit-Werte in ein Byte packen
                NEXT
            ELSE
                FOR i = 1 TO 5000
                    IF block + 2 * i - 1 <= LOF(2) THEN sample1 = ASC(MID$(wave, 2 * i - 1, 1)) ELSE sample = 128 'bringt Samples nach Dateiende auf 128 (=Stille) und verhindert dadurch Knacken beim Trackwechsel
                    IF block + 2 * i <= LOF(2) THEN sample2 = ASC(MID$(wave, 2 * i, 1)) ELSE sample = 128
                    newwavepart$ = newwavepart$ + CHR$(lup(0, sample1) * 16 + lup(0, sample2))
                NEXT
            END IF
            newwave$ = newwave$ + newwavepart$
        NEXT
    END IF

    LOCATE zeile, 25
    PRINT trackbytes(wavnr); "Bytes konvertiert"
    newwave$ = LEFT$(newwave$, speicherbedarf(wavnr))
    PUT #1, dateipos, newwave$
    CLOSE 2
    dateipos = dateipos + speicherbedarf(wavnr)
NEXT

CLOSE 1

PRINT
PRINT "Konvertieren beendet.": PRINT "Die Datei "; dateiname$: PRINT "kann nun mit BREADAMP v05 oder hoeher abgespielt werden."

END

sideinstellung_individuell:
FOR i = 1 TO trackanzahl
    IF wavbits(i) = 4 THEN GOTO skip_4bit
    PRINT: PRINT "In welches Format soll Track"; i; "konvertiert werden ?"
    IF ultimate_audio(i) = 0 THEN
        PRINT "  1  Mahoney fuer SID 6581"
        PRINT "  2  Mahoney fuer SID 8580"
        PRINT "  3  Linear  fuer FPGASID"
        IF wavkanaele(i) = 1 THEN PRINT "  4  Digimax"
        IF wavkanaele(i) = 2 THEN
            PRINT "  5  Mahoney fuer SID 6581 + 8580 (nur bei Stereotracks, bei Mono nur 6581)"
            PRINT "  6  Mahoney fuer SID 8580 + 6581 (nur bei Stereotracks, bei Mono nur 8580)"
        END IF
    END IF
    PRINT "  7  Ultimate Audio"

    DO
        sid$(i) = INKEY$
    LOOP UNTIL sid$(i) = "1" OR sid$(i) = "2" OR sid$(i) = "3" OR (sid$(i) = "4" AND wavkanaele(i) = 1) OR sid$(i) = "7" OR (sid$(i) = "5" AND wavkanaele(i) = 2) OR (sid$(i) = "6" AND wavkanaele(i) = 2)

    IF sid$(i) <> "3" AND sid$(i) <> "4" AND sid$(i) <> "7" THEN 'keine Abfrage der Mahoney-Tabelle bei Konvertierung fuer FPGASID
        PRINT: PRINT "Welche Mahoney-Tabelle soll fuer Track"; i; "verwendet werden ?"
        PRINT "  1  256 (von 256) lineare Werte"
        PRINT "  2  128 (von 256) lineare Werte"
        PRINT "  3   64 (von 256) lineare Werte"
        DO
            lup$(i) = INKEY$
        LOOP UNTIL lup$(i) = "1" OR lup$(i) = "2" OR lup$(i) = "3"
    END IF
    IF sid$ = "4" THEN digimaxabfrage = 1

    skip_4bit:
NEXT
GOTO sideinstellung_individuell_ende

wavfehler:
PRINT: PRINT "Fehlerhafte Datei: "; tracklist$(wavnr); endung$(wavnr)
END

'Lookuptables fuer Wavekonverter
lookup_m_6581_64:
lup(kanal, 0) = 159: lup(kanal, 1) = 159: lup(kanal, 2) = 159: lup(kanal, 3) = 159: lup(kanal, 4) = 159: lup(kanal, 5) = 159: lup(kanal, 6) = 159: lup(kanal, 7) = 159: lup(kanal, 8) = 159: lup(kanal, 9) = 159: lup(kanal, 10) = 159: lup(kanal, 11) = 159: lup(kanal, 12) = 159: lup(kanal, 13) = 159: lup(kanal, 14) = 159: lup(kanal, 15) = 159
lup(kanal, 16) = 159: lup(kanal, 17) = 159: lup(kanal, 18) = 159: lup(kanal, 19) = 159: lup(kanal, 20) = 159: lup(kanal, 21) = 159: lup(kanal, 22) = 159: lup(kanal, 23) = 159: lup(kanal, 24) = 159: lup(kanal, 25) = 159: lup(kanal, 26) = 159: lup(kanal, 27) = 159: lup(kanal, 28) = 159: lup(kanal, 29) = 159: lup(kanal, 30) = 159: lup(kanal, 31) = 159
lup(kanal, 32) = 159: lup(kanal, 33) = 159: lup(kanal, 34) = 159: lup(kanal, 35) = 159: lup(kanal, 36) = 159: lup(kanal, 37) = 159: lup(kanal, 38) = 159: lup(kanal, 39) = 159: lup(kanal, 40) = 159: lup(kanal, 41) = 159: lup(kanal, 42) = 159: lup(kanal, 43) = 159: lup(kanal, 44) = 159: lup(kanal, 45) = 159: lup(kanal, 46) = 159: lup(kanal, 47) = 159
lup(kanal, 48) = 159: lup(kanal, 49) = 159: lup(kanal, 50) = 159: lup(kanal, 51) = 159: lup(kanal, 52) = 159: lup(kanal, 53) = 159: lup(kanal, 54) = 159: lup(kanal, 55) = 159: lup(kanal, 56) = 159: lup(kanal, 57) = 159: lup(kanal, 58) = 159: lup(kanal, 59) = 159: lup(kanal, 60) = 159: lup(kanal, 61) = 159: lup(kanal, 62) = 159: lup(kanal, 63) = 159
lup(kanal, 64) = 159: lup(kanal, 65) = 159: lup(kanal, 66) = 159: lup(kanal, 67) = 159: lup(kanal, 68) = 159: lup(kanal, 69) = 159: lup(kanal, 70) = 159: lup(kanal, 71) = 159: lup(kanal, 72) = 159: lup(kanal, 73) = 159: lup(kanal, 74) = 159: lup(kanal, 75) = 159: lup(kanal, 76) = 159: lup(kanal, 77) = 159: lup(kanal, 78) = 159: lup(kanal, 79) = 159
lup(kanal, 80) = 159: lup(kanal, 81) = 159: lup(kanal, 82) = 159: lup(kanal, 83) = 159: lup(kanal, 84) = 159: lup(kanal, 85) = 159: lup(kanal, 86) = 159: lup(kanal, 87) = 159: lup(kanal, 88) = 159: lup(kanal, 89) = 159: lup(kanal, 90) = 159: lup(kanal, 91) = 159: lup(kanal, 92) = 159: lup(kanal, 93) = 159: lup(kanal, 94) = 159: lup(kanal, 95) = 159
lup(kanal, 96) = 159: lup(kanal, 97) = 159: lup(kanal, 98) = 159: lup(kanal, 99) = 159: lup(kanal, 100) = 159: lup(kanal, 101) = 158: lup(kanal, 102) = 157: lup(kanal, 103) = 156: lup(kanal, 104) = 156: lup(kanal, 105) = 155: lup(kanal, 106) = 220: lup(kanal, 107) = 154: lup(kanal, 108) = 153: lup(kanal, 109) = 153: lup(kanal, 110) = 152: lup(kanal, 111) = 186
lup(kanal, 112) = 151: lup(kanal, 113) = 151: lup(kanal, 114) = 150: lup(kanal, 115) = 214: lup(kanal, 116) = 149: lup(kanal, 117) = 213: lup(kanal, 118) = 148: lup(kanal, 119) = 212: lup(kanal, 120) = 180: lup(kanal, 121) = 211: lup(kanal, 122) = 243: lup(kanal, 123) = 210: lup(kanal, 124) = 242: lup(kanal, 125) = 209: lup(kanal, 126) = 82: lup(kanal, 127) = 49
lup(kanal, 128) = 162: lup(kanal, 129) = 165: lup(kanal, 130) = 33: lup(kanal, 131) = 66: lup(kanal, 132) = 98: lup(kanal, 133) = 67: lup(kanal, 134) = 99: lup(kanal, 135) = 35: lup(kanal, 136) = 100: lup(kanal, 137) = 36: lup(kanal, 138) = 101: lup(kanal, 139) = 70: lup(kanal, 140) = 37: lup(kanal, 141) = 103: lup(kanal, 142) = 38: lup(kanal, 143) = 72
lup(kanal, 144) = 39: lup(kanal, 145) = 105: lup(kanal, 146) = 74: lup(kanal, 147) = 40: lup(kanal, 148) = 41: lup(kanal, 149) = 41: lup(kanal, 150) = 42: lup(kanal, 151) = 42: lup(kanal, 152) = 43: lup(kanal, 153) = 43: lup(kanal, 154) = 44: lup(kanal, 155) = 44: lup(kanal, 156) = 45: lup(kanal, 157) = 46: lup(kanal, 158) = 46: lup(kanal, 159) = 47
lup(kanal, 160) = 15: lup(kanal, 161) = 15: lup(kanal, 162) = 15: lup(kanal, 163) = 15: lup(kanal, 164) = 15: lup(kanal, 165) = 15: lup(kanal, 166) = 15: lup(kanal, 167) = 15: lup(kanal, 168) = 15: lup(kanal, 169) = 15: lup(kanal, 170) = 15: lup(kanal, 171) = 15: lup(kanal, 172) = 15: lup(kanal, 173) = 15: lup(kanal, 174) = 15: lup(kanal, 175) = 15
lup(kanal, 176) = 15: lup(kanal, 177) = 15: lup(kanal, 178) = 15: lup(kanal, 179) = 15: lup(kanal, 180) = 15: lup(kanal, 181) = 15: lup(kanal, 182) = 15: lup(kanal, 183) = 15: lup(kanal, 184) = 15: lup(kanal, 185) = 15: lup(kanal, 186) = 15: lup(kanal, 187) = 15: lup(kanal, 188) = 15: lup(kanal, 189) = 15: lup(kanal, 190) = 15: lup(kanal, 191) = 15
lup(kanal, 192) = 15: lup(kanal, 193) = 15: lup(kanal, 194) = 15: lup(kanal, 195) = 15: lup(kanal, 196) = 15: lup(kanal, 197) = 15: lup(kanal, 198) = 15: lup(kanal, 199) = 15: lup(kanal, 200) = 15: lup(kanal, 201) = 15: lup(kanal, 202) = 15: lup(kanal, 203) = 15: lup(kanal, 204) = 15: lup(kanal, 205) = 15: lup(kanal, 206) = 15: lup(kanal, 207) = 15
lup(kanal, 208) = 15: lup(kanal, 209) = 15: lup(kanal, 210) = 15: lup(kanal, 211) = 15: lup(kanal, 212) = 15: lup(kanal, 213) = 15: lup(kanal, 214) = 15: lup(kanal, 215) = 15: lup(kanal, 216) = 15: lup(kanal, 217) = 15: lup(kanal, 218) = 15: lup(kanal, 219) = 15: lup(kanal, 220) = 15: lup(kanal, 221) = 15: lup(kanal, 222) = 15: lup(kanal, 223) = 15
lup(kanal, 224) = 15: lup(kanal, 225) = 15: lup(kanal, 226) = 15: lup(kanal, 227) = 15: lup(kanal, 228) = 15: lup(kanal, 229) = 15: lup(kanal, 230) = 15: lup(kanal, 231) = 15: lup(kanal, 232) = 15: lup(kanal, 233) = 15: lup(kanal, 234) = 15: lup(kanal, 235) = 15: lup(kanal, 236) = 15: lup(kanal, 237) = 15: lup(kanal, 238) = 15: lup(kanal, 239) = 15
lup(kanal, 240) = 15: lup(kanal, 241) = 15: lup(kanal, 242) = 15: lup(kanal, 243) = 15: lup(kanal, 244) = 15: lup(kanal, 245) = 15: lup(kanal, 246) = 15: lup(kanal, 247) = 15: lup(kanal, 248) = 15: lup(kanal, 249) = 15: lup(kanal, 250) = 15: lup(kanal, 251) = 15: lup(kanal, 252) = 15: lup(kanal, 253) = 15: lup(kanal, 254) = 15: lup(kanal, 255) = 15
RETURN

lookup_m_6581_128:
lup(kanal, 0) = 159: lup(kanal, 1) = 159: lup(kanal, 2) = 159: lup(kanal, 3) = 159: lup(kanal, 4) = 159: lup(kanal, 5) = 159: lup(kanal, 6) = 159: lup(kanal, 7) = 159: lup(kanal, 8) = 159: lup(kanal, 9) = 159: lup(kanal, 10) = 159: lup(kanal, 11) = 159: lup(kanal, 12) = 159: lup(kanal, 13) = 159: lup(kanal, 14) = 159: lup(kanal, 15) = 159
lup(kanal, 16) = 159: lup(kanal, 17) = 159: lup(kanal, 18) = 159: lup(kanal, 19) = 159: lup(kanal, 20) = 159: lup(kanal, 21) = 159: lup(kanal, 22) = 159: lup(kanal, 23) = 159: lup(kanal, 24) = 159: lup(kanal, 25) = 159: lup(kanal, 26) = 159: lup(kanal, 27) = 159: lup(kanal, 28) = 159: lup(kanal, 29) = 159: lup(kanal, 30) = 159: lup(kanal, 31) = 159
lup(kanal, 32) = 159: lup(kanal, 33) = 159: lup(kanal, 34) = 159: lup(kanal, 35) = 159: lup(kanal, 36) = 159: lup(kanal, 37) = 159: lup(kanal, 38) = 159: lup(kanal, 39) = 159: lup(kanal, 40) = 159: lup(kanal, 41) = 159: lup(kanal, 42) = 159: lup(kanal, 43) = 159: lup(kanal, 44) = 159: lup(kanal, 45) = 159: lup(kanal, 46) = 159: lup(kanal, 47) = 159
lup(kanal, 48) = 159: lup(kanal, 49) = 159: lup(kanal, 50) = 159: lup(kanal, 51) = 159: lup(kanal, 52) = 159: lup(kanal, 53) = 159: lup(kanal, 54) = 159: lup(kanal, 55) = 159: lup(kanal, 56) = 159: lup(kanal, 57) = 159: lup(kanal, 58) = 159: lup(kanal, 59) = 159: lup(kanal, 60) = 159: lup(kanal, 61) = 159: lup(kanal, 62) = 159: lup(kanal, 63) = 159
lup(kanal, 64) = 159: lup(kanal, 65) = 159: lup(kanal, 66) = 159: lup(kanal, 67) = 159: lup(kanal, 68) = 159: lup(kanal, 69) = 159: lup(kanal, 70) = 159: lup(kanal, 71) = 159: lup(kanal, 72) = 159: lup(kanal, 73) = 158: lup(kanal, 74) = 158: lup(kanal, 75) = 158: lup(kanal, 76) = 157: lup(kanal, 77) = 157: lup(kanal, 78) = 157: lup(kanal, 79) = 156
lup(kanal, 80) = 156: lup(kanal, 81) = 156: lup(kanal, 82) = 155: lup(kanal, 83) = 155: lup(kanal, 84) = 155: lup(kanal, 85) = 154: lup(kanal, 86) = 154: lup(kanal, 87) = 154: lup(kanal, 88) = 153: lup(kanal, 89) = 153: lup(kanal, 90) = 153: lup(kanal, 91) = 152: lup(kanal, 92) = 152: lup(kanal, 93) = 152: lup(kanal, 94) = 217: lup(kanal, 95) = 216
lup(kanal, 96) = 151: lup(kanal, 97) = 151: lup(kanal, 98) = 151: lup(kanal, 99) = 215: lup(kanal, 100) = 150: lup(kanal, 101) = 150: lup(kanal, 102) = 150: lup(kanal, 103) = 214: lup(kanal, 104) = 149: lup(kanal, 105) = 149: lup(kanal, 106) = 182: lup(kanal, 107) = 213: lup(kanal, 108) = 148: lup(kanal, 109) = 148: lup(kanal, 110) = 212: lup(kanal, 111) = 212
lup(kanal, 112) = 180: lup(kanal, 113) = 147: lup(kanal, 114) = 211: lup(kanal, 115) = 211: lup(kanal, 116) = 179: lup(kanal, 117) = 146: lup(kanal, 118) = 210: lup(kanal, 119) = 178: lup(kanal, 120) = 242: lup(kanal, 121) = 145: lup(kanal, 122) = 145: lup(kanal, 123) = 177: lup(kanal, 124) = 241: lup(kanal, 125) = 18: lup(kanal, 126) = 17: lup(kanal, 127) = 144
lup(kanal, 128) = 161: lup(kanal, 129) = 162: lup(kanal, 130) = 164: lup(kanal, 131) = 65: lup(kanal, 132) = 97: lup(kanal, 133) = 33: lup(kanal, 134) = 171: lup(kanal, 135) = 66: lup(kanal, 136) = 98: lup(kanal, 137) = 34: lup(kanal, 138) = 34: lup(kanal, 139) = 67: lup(kanal, 140) = 99: lup(kanal, 141) = 35: lup(kanal, 142) = 35: lup(kanal, 143) = 68
lup(kanal, 144) = 100: lup(kanal, 145) = 100: lup(kanal, 146) = 69: lup(kanal, 147) = 36: lup(kanal, 148) = 36: lup(kanal, 149) = 70: lup(kanal, 150) = 70: lup(kanal, 151) = 37: lup(kanal, 152) = 37: lup(kanal, 153) = 71: lup(kanal, 154) = 71: lup(kanal, 155) = 38: lup(kanal, 156) = 38: lup(kanal, 157) = 38: lup(kanal, 158) = 72: lup(kanal, 159) = 104
lup(kanal, 160) = 39: lup(kanal, 161) = 39: lup(kanal, 162) = 105: lup(kanal, 163) = 105: lup(kanal, 164) = 74: lup(kanal, 165) = 40: lup(kanal, 166) = 40: lup(kanal, 167) = 75: lup(kanal, 168) = 107: lup(kanal, 169) = 41: lup(kanal, 170) = 41: lup(kanal, 171) = 41: lup(kanal, 172) = 77: lup(kanal, 173) = 42: lup(kanal, 174) = 42: lup(kanal, 175) = 78
lup(kanal, 176) = 43: lup(kanal, 177) = 43: lup(kanal, 178) = 43: lup(kanal, 179) = 111: lup(kanal, 180) = 44: lup(kanal, 181) = 44: lup(kanal, 182) = 44: lup(kanal, 183) = 45: lup(kanal, 184) = 45: lup(kanal, 185) = 45: lup(kanal, 186) = 13: lup(kanal, 187) = 46: lup(kanal, 188) = 46: lup(kanal, 189) = 46: lup(kanal, 190) = 47: lup(kanal, 191) = 47
lup(kanal, 192) = 47: lup(kanal, 193) = 15: lup(kanal, 194) = 15: lup(kanal, 195) = 15: lup(kanal, 196) = 15: lup(kanal, 197) = 15: lup(kanal, 198) = 15: lup(kanal, 199) = 15: lup(kanal, 200) = 15: lup(kanal, 201) = 15: lup(kanal, 202) = 15: lup(kanal, 203) = 15: lup(kanal, 204) = 15: lup(kanal, 205) = 15: lup(kanal, 206) = 15: lup(kanal, 207) = 15
lup(kanal, 208) = 15: lup(kanal, 209) = 15: lup(kanal, 210) = 15: lup(kanal, 211) = 15: lup(kanal, 212) = 15: lup(kanal, 213) = 15: lup(kanal, 214) = 15: lup(kanal, 215) = 15: lup(kanal, 216) = 15: lup(kanal, 217) = 15: lup(kanal, 218) = 15: lup(kanal, 219) = 15: lup(kanal, 220) = 15: lup(kanal, 221) = 15: lup(kanal, 222) = 15: lup(kanal, 223) = 15
lup(kanal, 224) = 15: lup(kanal, 225) = 15: lup(kanal, 226) = 15: lup(kanal, 227) = 15: lup(kanal, 228) = 15: lup(kanal, 229) = 15: lup(kanal, 230) = 15: lup(kanal, 231) = 15: lup(kanal, 232) = 15: lup(kanal, 233) = 15: lup(kanal, 234) = 15: lup(kanal, 235) = 15: lup(kanal, 236) = 15: lup(kanal, 237) = 15: lup(kanal, 238) = 15: lup(kanal, 239) = 15
lup(kanal, 240) = 15: lup(kanal, 241) = 15: lup(kanal, 242) = 15: lup(kanal, 243) = 15: lup(kanal, 244) = 15: lup(kanal, 245) = 15: lup(kanal, 246) = 15: lup(kanal, 247) = 15: lup(kanal, 248) = 15: lup(kanal, 249) = 15: lup(kanal, 250) = 15: lup(kanal, 251) = 15: lup(kanal, 252) = 15: lup(kanal, 253) = 15: lup(kanal, 254) = 15: lup(kanal, 255) = 15
RETURN

lookup_m_6581_256:
lup(kanal, 0) = 159: lup(kanal, 1) = 159: lup(kanal, 2) = 159: lup(kanal, 3) = 159: lup(kanal, 4) = 159: lup(kanal, 5) = 159: lup(kanal, 6) = 159: lup(kanal, 7) = 159: lup(kanal, 8) = 159: lup(kanal, 9) = 159: lup(kanal, 10) = 159: lup(kanal, 11) = 159: lup(kanal, 12) = 159: lup(kanal, 13) = 159: lup(kanal, 14) = 159: lup(kanal, 15) = 159
lup(kanal, 16) = 159: lup(kanal, 17) = 159: lup(kanal, 18) = 159: lup(kanal, 19) = 158: lup(kanal, 20) = 158: lup(kanal, 21) = 158: lup(kanal, 22) = 158: lup(kanal, 23) = 158: lup(kanal, 24) = 157: lup(kanal, 25) = 157: lup(kanal, 26) = 157: lup(kanal, 27) = 157: lup(kanal, 28) = 157: lup(kanal, 29) = 157: lup(kanal, 30) = 156: lup(kanal, 31) = 156
lup(kanal, 32) = 156: lup(kanal, 33) = 156: lup(kanal, 34) = 156: lup(kanal, 35) = 156: lup(kanal, 36) = 155: lup(kanal, 37) = 155: lup(kanal, 38) = 155: lup(kanal, 39) = 155: lup(kanal, 40) = 155: lup(kanal, 41) = 220: lup(kanal, 42) = 220: lup(kanal, 43) = 154: lup(kanal, 44) = 154: lup(kanal, 45) = 154: lup(kanal, 46) = 154: lup(kanal, 47) = 219
lup(kanal, 48) = 153: lup(kanal, 49) = 153: lup(kanal, 50) = 153: lup(kanal, 51) = 153: lup(kanal, 52) = 153: lup(kanal, 53) = 153: lup(kanal, 54) = 218: lup(kanal, 55) = 152: lup(kanal, 56) = 152: lup(kanal, 57) = 152: lup(kanal, 58) = 152: lup(kanal, 59) = 152: lup(kanal, 60) = 217: lup(kanal, 61) = 186: lup(kanal, 62) = 186: lup(kanal, 63) = 151
lup(kanal, 64) = 151: lup(kanal, 65) = 151: lup(kanal, 66) = 151: lup(kanal, 67) = 151: lup(kanal, 68) = 151: lup(kanal, 69) = 151: lup(kanal, 70) = 151: lup(kanal, 71) = 215: lup(kanal, 72) = 215: lup(kanal, 73) = 150: lup(kanal, 74) = 150: lup(kanal, 75) = 150: lup(kanal, 76) = 150: lup(kanal, 77) = 214: lup(kanal, 78) = 214: lup(kanal, 79) = 214
lup(kanal, 80) = 149: lup(kanal, 81) = 149: lup(kanal, 82) = 149: lup(kanal, 83) = 149: lup(kanal, 84) = 149: lup(kanal, 85) = 213: lup(kanal, 86) = 213: lup(kanal, 87) = 213: lup(kanal, 88) = 148: lup(kanal, 89) = 148: lup(kanal, 90) = 148: lup(kanal, 91) = 148: lup(kanal, 92) = 181: lup(kanal, 93) = 212: lup(kanal, 94) = 212: lup(kanal, 95) = 212
lup(kanal, 96) = 180: lup(kanal, 97) = 180: lup(kanal, 98) = 147: lup(kanal, 99) = 147: lup(kanal, 100) = 244: lup(kanal, 101) = 211: lup(kanal, 102) = 211: lup(kanal, 103) = 179: lup(kanal, 104) = 179: lup(kanal, 105) = 179: lup(kanal, 106) = 146: lup(kanal, 107) = 146: lup(kanal, 108) = 146: lup(kanal, 109) = 210: lup(kanal, 110) = 210: lup(kanal, 111) = 178
lup(kanal, 112) = 178: lup(kanal, 113) = 242: lup(kanal, 114) = 242: lup(kanal, 115) = 145: lup(kanal, 116) = 145: lup(kanal, 117) = 145: lup(kanal, 118) = 209: lup(kanal, 119) = 177: lup(kanal, 120) = 241: lup(kanal, 121) = 241: lup(kanal, 122) = 18: lup(kanal, 123) = 81: lup(kanal, 124) = 81: lup(kanal, 125) = 113: lup(kanal, 126) = 144: lup(kanal, 127) = 48
lup(kanal, 128) = 0: lup(kanal, 129) = 161: lup(kanal, 130) = 162: lup(kanal, 131) = 163: lup(kanal, 132) = 164: lup(kanal, 133) = 164: lup(kanal, 134) = 165: lup(kanal, 135) = 65: lup(kanal, 136) = 97: lup(kanal, 137) = 33: lup(kanal, 138) = 33: lup(kanal, 139) = 1: lup(kanal, 140) = 1: lup(kanal, 141) = 66: lup(kanal, 142) = 66: lup(kanal, 143) = 66
lup(kanal, 144) = 98: lup(kanal, 145) = 98: lup(kanal, 146) = 34: lup(kanal, 147) = 34: lup(kanal, 148) = 34: lup(kanal, 149) = 34: lup(kanal, 150) = 67: lup(kanal, 151) = 67: lup(kanal, 152) = 99: lup(kanal, 153) = 99: lup(kanal, 154) = 99: lup(kanal, 155) = 35: lup(kanal, 156) = 35: lup(kanal, 157) = 35: lup(kanal, 158) = 35: lup(kanal, 159) = 68
lup(kanal, 160) = 100: lup(kanal, 161) = 100: lup(kanal, 162) = 100: lup(kanal, 163) = 69: lup(kanal, 164) = 69: lup(kanal, 165) = 69: lup(kanal, 166) = 36: lup(kanal, 167) = 36: lup(kanal, 168) = 36: lup(kanal, 169) = 36: lup(kanal, 170) = 101: lup(kanal, 171) = 70: lup(kanal, 172) = 70: lup(kanal, 173) = 70: lup(kanal, 174) = 70: lup(kanal, 175) = 37
lup(kanal, 176) = 37: lup(kanal, 177) = 37: lup(kanal, 178) = 71: lup(kanal, 179) = 71: lup(kanal, 180) = 71: lup(kanal, 181) = 103: lup(kanal, 182) = 103: lup(kanal, 183) = 38: lup(kanal, 184) = 38: lup(kanal, 185) = 38: lup(kanal, 186) = 38: lup(kanal, 187) = 72: lup(kanal, 188) = 72: lup(kanal, 189) = 72: lup(kanal, 190) = 104: lup(kanal, 191) = 104
lup(kanal, 192) = 39: lup(kanal, 193) = 39: lup(kanal, 194) = 39: lup(kanal, 195) = 73: lup(kanal, 196) = 73: lup(kanal, 197) = 105: lup(kanal, 198) = 105: lup(kanal, 199) = 74: lup(kanal, 200) = 74: lup(kanal, 201) = 74: lup(kanal, 202) = 74: lup(kanal, 203) = 40: lup(kanal, 204) = 40: lup(kanal, 205) = 40: lup(kanal, 206) = 40: lup(kanal, 207) = 75
lup(kanal, 208) = 75: lup(kanal, 209) = 107: lup(kanal, 210) = 41: lup(kanal, 211) = 41: lup(kanal, 212) = 41: lup(kanal, 213) = 41: lup(kanal, 214) = 41: lup(kanal, 215) = 108: lup(kanal, 216) = 108: lup(kanal, 217) = 42: lup(kanal, 218) = 42: lup(kanal, 219) = 42: lup(kanal, 220) = 42: lup(kanal, 221) = 42: lup(kanal, 222) = 42: lup(kanal, 223) = 78
lup(kanal, 224) = 78: lup(kanal, 225) = 43: lup(kanal, 226) = 43: lup(kanal, 227) = 43: lup(kanal, 228) = 43: lup(kanal, 229) = 43: lup(kanal, 230) = 43: lup(kanal, 231) = 44: lup(kanal, 232) = 44: lup(kanal, 233) = 44: lup(kanal, 234) = 44: lup(kanal, 235) = 44: lup(kanal, 236) = 44: lup(kanal, 237) = 44: lup(kanal, 238) = 45: lup(kanal, 239) = 45
lup(kanal, 240) = 45: lup(kanal, 241) = 45: lup(kanal, 242) = 45: lup(kanal, 243) = 45: lup(kanal, 244) = 45: lup(kanal, 245) = 46: lup(kanal, 246) = 46: lup(kanal, 247) = 46: lup(kanal, 248) = 46: lup(kanal, 249) = 46: lup(kanal, 250) = 46: lup(kanal, 251) = 14: lup(kanal, 252) = 47: lup(kanal, 253) = 47: lup(kanal, 254) = 47: lup(kanal, 255) = 47
RETURN

lookup_m_8580_64:
lup(kanal, 0) = 159: lup(kanal, 1) = 159: lup(kanal, 2) = 159: lup(kanal, 3) = 159: lup(kanal, 4) = 159: lup(kanal, 5) = 159: lup(kanal, 6) = 159: lup(kanal, 7) = 159: lup(kanal, 8) = 159: lup(kanal, 9) = 159: lup(kanal, 10) = 159: lup(kanal, 11) = 159: lup(kanal, 12) = 159: lup(kanal, 13) = 159: lup(kanal, 14) = 159: lup(kanal, 15) = 159
lup(kanal, 16) = 159: lup(kanal, 17) = 159: lup(kanal, 18) = 159: lup(kanal, 19) = 159: lup(kanal, 20) = 159: lup(kanal, 21) = 159: lup(kanal, 22) = 159: lup(kanal, 23) = 159: lup(kanal, 24) = 159: lup(kanal, 25) = 159: lup(kanal, 26) = 159: lup(kanal, 27) = 159: lup(kanal, 28) = 159: lup(kanal, 29) = 159: lup(kanal, 30) = 159: lup(kanal, 31) = 159
lup(kanal, 32) = 159: lup(kanal, 33) = 159: lup(kanal, 34) = 159: lup(kanal, 35) = 159: lup(kanal, 36) = 159: lup(kanal, 37) = 159: lup(kanal, 38) = 159: lup(kanal, 39) = 159: lup(kanal, 40) = 159: lup(kanal, 41) = 159: lup(kanal, 42) = 159: lup(kanal, 43) = 159: lup(kanal, 44) = 159: lup(kanal, 45) = 159: lup(kanal, 46) = 159: lup(kanal, 47) = 159
lup(kanal, 48) = 159: lup(kanal, 49) = 159: lup(kanal, 50) = 159: lup(kanal, 51) = 159: lup(kanal, 52) = 159: lup(kanal, 53) = 159: lup(kanal, 54) = 159: lup(kanal, 55) = 159: lup(kanal, 56) = 159: lup(kanal, 57) = 159: lup(kanal, 58) = 159: lup(kanal, 59) = 159: lup(kanal, 60) = 159: lup(kanal, 61) = 159: lup(kanal, 62) = 159: lup(kanal, 63) = 159
lup(kanal, 64) = 159: lup(kanal, 65) = 159: lup(kanal, 66) = 159: lup(kanal, 67) = 159: lup(kanal, 68) = 159: lup(kanal, 69) = 159: lup(kanal, 70) = 159: lup(kanal, 71) = 159: lup(kanal, 72) = 159: lup(kanal, 73) = 159: lup(kanal, 74) = 159: lup(kanal, 75) = 159: lup(kanal, 76) = 159: lup(kanal, 77) = 159: lup(kanal, 78) = 159: lup(kanal, 79) = 159
lup(kanal, 80) = 159: lup(kanal, 81) = 159: lup(kanal, 82) = 159: lup(kanal, 83) = 159: lup(kanal, 84) = 159: lup(kanal, 85) = 159: lup(kanal, 86) = 159: lup(kanal, 87) = 159: lup(kanal, 88) = 159: lup(kanal, 89) = 159: lup(kanal, 90) = 159: lup(kanal, 91) = 159: lup(kanal, 92) = 159: lup(kanal, 93) = 159: lup(kanal, 94) = 159: lup(kanal, 95) = 159
lup(kanal, 96) = 159: lup(kanal, 97) = 223: lup(kanal, 98) = 158: lup(kanal, 99) = 222: lup(kanal, 100) = 157: lup(kanal, 101) = 157: lup(kanal, 102) = 221: lup(kanal, 103) = 156: lup(kanal, 104) = 220: lup(kanal, 105) = 220: lup(kanal, 106) = 155: lup(kanal, 107) = 219: lup(kanal, 108) = 154: lup(kanal, 109) = 154: lup(kanal, 110) = 218: lup(kanal, 111) = 153
lup(kanal, 112) = 217: lup(kanal, 113) = 152: lup(kanal, 114) = 152: lup(kanal, 115) = 216: lup(kanal, 116) = 63: lup(kanal, 117) = 151: lup(kanal, 118) = 215: lup(kanal, 119) = 126: lup(kanal, 120) = 125: lup(kanal, 121) = 124: lup(kanal, 122) = 59: lup(kanal, 123) = 58: lup(kanal, 124) = 122: lup(kanal, 125) = 121: lup(kanal, 126) = 56: lup(kanal, 127) = 23
lup(kanal, 128) = 87: lup(kanal, 129) = 86: lup(kanal, 130) = 21: lup(kanal, 131) = 20: lup(kanal, 132) = 84: lup(kanal, 133) = 19: lup(kanal, 134) = 18: lup(kanal, 135) = 82: lup(kanal, 136) = 81: lup(kanal, 137) = 128: lup(kanal, 138) = 1: lup(kanal, 139) = 65: lup(kanal, 140) = 66: lup(kanal, 141) = 3: lup(kanal, 142) = 67: lup(kanal, 143) = 4
lup(kanal, 144) = 5: lup(kanal, 145) = 69: lup(kanal, 146) = 70: lup(kanal, 147) = 7: lup(kanal, 148) = 71: lup(kanal, 149) = 8: lup(kanal, 150) = 9: lup(kanal, 151) = 73: lup(kanal, 152) = 10: lup(kanal, 153) = 11: lup(kanal, 154) = 75: lup(kanal, 155) = 12: lup(kanal, 156) = 13: lup(kanal, 157) = 77: lup(kanal, 158) = 14: lup(kanal, 159) = 15
lup(kanal, 160) = 79: lup(kanal, 161) = 79: lup(kanal, 162) = 79: lup(kanal, 163) = 79: lup(kanal, 164) = 79: lup(kanal, 165) = 79: lup(kanal, 166) = 79: lup(kanal, 167) = 79: lup(kanal, 168) = 79: lup(kanal, 169) = 79: lup(kanal, 170) = 79: lup(kanal, 171) = 79: lup(kanal, 172) = 79: lup(kanal, 173) = 79: lup(kanal, 174) = 79: lup(kanal, 175) = 79
lup(kanal, 176) = 79: lup(kanal, 177) = 79: lup(kanal, 178) = 79: lup(kanal, 179) = 79: lup(kanal, 180) = 79: lup(kanal, 181) = 79: lup(kanal, 182) = 79: lup(kanal, 183) = 79: lup(kanal, 184) = 79: lup(kanal, 185) = 79: lup(kanal, 186) = 79: lup(kanal, 187) = 79: lup(kanal, 188) = 79: lup(kanal, 189) = 79: lup(kanal, 190) = 79: lup(kanal, 191) = 79
lup(kanal, 192) = 79: lup(kanal, 193) = 79: lup(kanal, 194) = 79: lup(kanal, 195) = 79: lup(kanal, 196) = 79: lup(kanal, 197) = 79: lup(kanal, 198) = 79: lup(kanal, 199) = 79: lup(kanal, 200) = 79: lup(kanal, 201) = 79: lup(kanal, 202) = 79: lup(kanal, 203) = 79: lup(kanal, 204) = 79: lup(kanal, 205) = 79: lup(kanal, 206) = 79: lup(kanal, 207) = 79
lup(kanal, 208) = 79: lup(kanal, 209) = 79: lup(kanal, 210) = 79: lup(kanal, 211) = 79: lup(kanal, 212) = 79: lup(kanal, 213) = 79: lup(kanal, 214) = 79: lup(kanal, 215) = 79: lup(kanal, 216) = 79: lup(kanal, 217) = 79: lup(kanal, 218) = 79: lup(kanal, 219) = 79: lup(kanal, 220) = 79: lup(kanal, 221) = 79: lup(kanal, 222) = 79: lup(kanal, 223) = 79
lup(kanal, 224) = 79: lup(kanal, 225) = 79: lup(kanal, 226) = 79: lup(kanal, 227) = 79: lup(kanal, 228) = 79: lup(kanal, 229) = 79: lup(kanal, 230) = 79: lup(kanal, 231) = 79: lup(kanal, 232) = 79: lup(kanal, 233) = 79: lup(kanal, 234) = 79: lup(kanal, 235) = 79: lup(kanal, 236) = 79: lup(kanal, 237) = 79: lup(kanal, 238) = 79: lup(kanal, 239) = 79
lup(kanal, 240) = 79: lup(kanal, 241) = 79: lup(kanal, 242) = 79: lup(kanal, 243) = 79: lup(kanal, 244) = 79: lup(kanal, 245) = 79: lup(kanal, 246) = 79: lup(kanal, 247) = 79: lup(kanal, 248) = 79: lup(kanal, 249) = 79: lup(kanal, 250) = 79: lup(kanal, 251) = 79: lup(kanal, 252) = 79: lup(kanal, 253) = 79: lup(kanal, 254) = 79: lup(kanal, 255) = 79
RETURN

lookup_m_8580_128:
lup(kanal, 0) = 159: lup(kanal, 1) = 159: lup(kanal, 2) = 159: lup(kanal, 3) = 159: lup(kanal, 4) = 159: lup(kanal, 5) = 159: lup(kanal, 6) = 159: lup(kanal, 7) = 159: lup(kanal, 8) = 159: lup(kanal, 9) = 159: lup(kanal, 10) = 159: lup(kanal, 11) = 159: lup(kanal, 12) = 159: lup(kanal, 13) = 159: lup(kanal, 14) = 159: lup(kanal, 15) = 159
lup(kanal, 16) = 159: lup(kanal, 17) = 159: lup(kanal, 18) = 159: lup(kanal, 19) = 159: lup(kanal, 20) = 159: lup(kanal, 21) = 159: lup(kanal, 22) = 159: lup(kanal, 23) = 159: lup(kanal, 24) = 159: lup(kanal, 25) = 159: lup(kanal, 26) = 159: lup(kanal, 27) = 159: lup(kanal, 28) = 159: lup(kanal, 29) = 159: lup(kanal, 30) = 159: lup(kanal, 31) = 159
lup(kanal, 32) = 159: lup(kanal, 33) = 159: lup(kanal, 34) = 159: lup(kanal, 35) = 159: lup(kanal, 36) = 159: lup(kanal, 37) = 159: lup(kanal, 38) = 159: lup(kanal, 39) = 159: lup(kanal, 40) = 159: lup(kanal, 41) = 159: lup(kanal, 42) = 159: lup(kanal, 43) = 159: lup(kanal, 44) = 159: lup(kanal, 45) = 159: lup(kanal, 46) = 159: lup(kanal, 47) = 159
lup(kanal, 48) = 159: lup(kanal, 49) = 159: lup(kanal, 50) = 159: lup(kanal, 51) = 159: lup(kanal, 52) = 159: lup(kanal, 53) = 159: lup(kanal, 54) = 159: lup(kanal, 55) = 159: lup(kanal, 56) = 159: lup(kanal, 57) = 159: lup(kanal, 58) = 159: lup(kanal, 59) = 159: lup(kanal, 60) = 159: lup(kanal, 61) = 159: lup(kanal, 62) = 159: lup(kanal, 63) = 159
lup(kanal, 64) = 159: lup(kanal, 65) = 223: lup(kanal, 66) = 223: lup(kanal, 67) = 255: lup(kanal, 68) = 158: lup(kanal, 69) = 158: lup(kanal, 70) = 222: lup(kanal, 71) = 222: lup(kanal, 72) = 222: lup(kanal, 73) = 157: lup(kanal, 74) = 157: lup(kanal, 75) = 221: lup(kanal, 76) = 221: lup(kanal, 77) = 221: lup(kanal, 78) = 156: lup(kanal, 79) = 156
lup(kanal, 80) = 220: lup(kanal, 81) = 220: lup(kanal, 82) = 220: lup(kanal, 83) = 155: lup(kanal, 84) = 155: lup(kanal, 85) = 155: lup(kanal, 86) = 219: lup(kanal, 87) = 219: lup(kanal, 88) = 154: lup(kanal, 89) = 154: lup(kanal, 90) = 154: lup(kanal, 91) = 218: lup(kanal, 92) = 218: lup(kanal, 93) = 218: lup(kanal, 94) = 153: lup(kanal, 95) = 153
lup(kanal, 96) = 217: lup(kanal, 97) = 217: lup(kanal, 98) = 217: lup(kanal, 99) = 152: lup(kanal, 100) = 152: lup(kanal, 101) = 152: lup(kanal, 102) = 216: lup(kanal, 103) = 216: lup(kanal, 104) = 63: lup(kanal, 105) = 63: lup(kanal, 106) = 63: lup(kanal, 107) = 151: lup(kanal, 108) = 215: lup(kanal, 109) = 62: lup(kanal, 110) = 126: lup(kanal, 111) = 61
lup(kanal, 112) = 125: lup(kanal, 113) = 125: lup(kanal, 114) = 60: lup(kanal, 115) = 124: lup(kanal, 116) = 59: lup(kanal, 117) = 59: lup(kanal, 118) = 123: lup(kanal, 119) = 58: lup(kanal, 120) = 122: lup(kanal, 121) = 57: lup(kanal, 122) = 57: lup(kanal, 123) = 121: lup(kanal, 124) = 24: lup(kanal, 125) = 88: lup(kanal, 126) = 120: lup(kanal, 127) = 23
lup(kanal, 128) = 87: lup(kanal, 129) = 119: lup(kanal, 130) = 22: lup(kanal, 131) = 86: lup(kanal, 132) = 21: lup(kanal, 133) = 21: lup(kanal, 134) = 85: lup(kanal, 135) = 20: lup(kanal, 136) = 84: lup(kanal, 137) = 84: lup(kanal, 138) = 19: lup(kanal, 139) = 83: lup(kanal, 140) = 18: lup(kanal, 141) = 18: lup(kanal, 142) = 82: lup(kanal, 143) = 17
lup(kanal, 144) = 81: lup(kanal, 145) = 81: lup(kanal, 146) = 144: lup(kanal, 147) = 128: lup(kanal, 148) = 1: lup(kanal, 149) = 1: lup(kanal, 150) = 65: lup(kanal, 151) = 2: lup(kanal, 152) = 2: lup(kanal, 153) = 66: lup(kanal, 154) = 3: lup(kanal, 155) = 3: lup(kanal, 156) = 67: lup(kanal, 157) = 4: lup(kanal, 158) = 4: lup(kanal, 159) = 68
lup(kanal, 160) = 5: lup(kanal, 161) = 5: lup(kanal, 162) = 69: lup(kanal, 163) = 6: lup(kanal, 164) = 6: lup(kanal, 165) = 70: lup(kanal, 166) = 7: lup(kanal, 167) = 7: lup(kanal, 168) = 71: lup(kanal, 169) = 40: lup(kanal, 170) = 8: lup(kanal, 171) = 72: lup(kanal, 172) = 72: lup(kanal, 173) = 9: lup(kanal, 174) = 73: lup(kanal, 175) = 73
lup(kanal, 176) = 10: lup(kanal, 177) = 74: lup(kanal, 178) = 74: lup(kanal, 179) = 11: lup(kanal, 180) = 75: lup(kanal, 181) = 44: lup(kanal, 182) = 12: lup(kanal, 183) = 76: lup(kanal, 184) = 76: lup(kanal, 185) = 13: lup(kanal, 186) = 77: lup(kanal, 187) = 77: lup(kanal, 188) = 14: lup(kanal, 189) = 78: lup(kanal, 190) = 47: lup(kanal, 191) = 15
lup(kanal, 192) = 79: lup(kanal, 193) = 79: lup(kanal, 194) = 79: lup(kanal, 195) = 79: lup(kanal, 196) = 79: lup(kanal, 197) = 79: lup(kanal, 198) = 79: lup(kanal, 199) = 79: lup(kanal, 200) = 79: lup(kanal, 201) = 79: lup(kanal, 202) = 79: lup(kanal, 203) = 79: lup(kanal, 204) = 79: lup(kanal, 205) = 79: lup(kanal, 206) = 79: lup(kanal, 207) = 79
lup(kanal, 208) = 79: lup(kanal, 209) = 79: lup(kanal, 210) = 79: lup(kanal, 211) = 79: lup(kanal, 212) = 79: lup(kanal, 213) = 79: lup(kanal, 214) = 79: lup(kanal, 215) = 79: lup(kanal, 216) = 79: lup(kanal, 217) = 79: lup(kanal, 218) = 79: lup(kanal, 219) = 79: lup(kanal, 220) = 79: lup(kanal, 221) = 79: lup(kanal, 222) = 79: lup(kanal, 223) = 79
lup(kanal, 224) = 79: lup(kanal, 225) = 79: lup(kanal, 226) = 79: lup(kanal, 227) = 79: lup(kanal, 228) = 79: lup(kanal, 229) = 79: lup(kanal, 230) = 79: lup(kanal, 231) = 79: lup(kanal, 232) = 79: lup(kanal, 233) = 79: lup(kanal, 234) = 79: lup(kanal, 235) = 79: lup(kanal, 236) = 79: lup(kanal, 237) = 79: lup(kanal, 238) = 79: lup(kanal, 239) = 79
lup(kanal, 240) = 79: lup(kanal, 241) = 79: lup(kanal, 242) = 79: lup(kanal, 243) = 79: lup(kanal, 244) = 79: lup(kanal, 245) = 79: lup(kanal, 246) = 79: lup(kanal, 247) = 79: lup(kanal, 248) = 79: lup(kanal, 249) = 79: lup(kanal, 250) = 79: lup(kanal, 251) = 79: lup(kanal, 252) = 79: lup(kanal, 253) = 79: lup(kanal, 254) = 79: lup(kanal, 255) = 79
RETURN

lookup_m_8580_256:
lup(kanal, 0) = 159: lup(kanal, 1) = 159: lup(kanal, 2) = 223: lup(kanal, 3) = 223: lup(kanal, 4) = 223: lup(kanal, 5) = 223: lup(kanal, 6) = 223: lup(kanal, 7) = 158: lup(kanal, 8) = 158: lup(kanal, 9) = 158: lup(kanal, 10) = 158: lup(kanal, 11) = 158: lup(kanal, 12) = 222: lup(kanal, 13) = 222: lup(kanal, 14) = 222: lup(kanal, 15) = 222
lup(kanal, 16) = 222: lup(kanal, 17) = 157: lup(kanal, 18) = 157: lup(kanal, 19) = 157: lup(kanal, 20) = 157: lup(kanal, 21) = 157: lup(kanal, 22) = 157: lup(kanal, 23) = 221: lup(kanal, 24) = 221: lup(kanal, 25) = 221: lup(kanal, 26) = 221: lup(kanal, 27) = 221: lup(kanal, 28) = 156: lup(kanal, 29) = 156: lup(kanal, 30) = 156: lup(kanal, 31) = 156
lup(kanal, 32) = 156: lup(kanal, 33) = 220: lup(kanal, 34) = 220: lup(kanal, 35) = 220: lup(kanal, 36) = 220: lup(kanal, 37) = 220: lup(kanal, 38) = 155: lup(kanal, 39) = 155: lup(kanal, 40) = 155: lup(kanal, 41) = 155: lup(kanal, 42) = 155: lup(kanal, 43) = 155: lup(kanal, 44) = 219: lup(kanal, 45) = 219: lup(kanal, 46) = 219: lup(kanal, 47) = 219
lup(kanal, 48) = 219: lup(kanal, 49) = 154: lup(kanal, 50) = 154: lup(kanal, 51) = 154: lup(kanal, 52) = 154: lup(kanal, 53) = 154: lup(kanal, 54) = 218: lup(kanal, 55) = 218: lup(kanal, 56) = 218: lup(kanal, 57) = 218: lup(kanal, 58) = 218: lup(kanal, 59) = 153: lup(kanal, 60) = 153: lup(kanal, 61) = 153: lup(kanal, 62) = 153: lup(kanal, 63) = 153
lup(kanal, 64) = 153: lup(kanal, 65) = 217: lup(kanal, 66) = 217: lup(kanal, 67) = 217: lup(kanal, 68) = 217: lup(kanal, 69) = 217: lup(kanal, 70) = 152: lup(kanal, 71) = 152: lup(kanal, 72) = 152: lup(kanal, 73) = 152: lup(kanal, 74) = 152: lup(kanal, 75) = 216: lup(kanal, 76) = 216: lup(kanal, 77) = 216: lup(kanal, 78) = 216: lup(kanal, 79) = 216
lup(kanal, 80) = 216: lup(kanal, 81) = 63: lup(kanal, 82) = 63: lup(kanal, 83) = 63: lup(kanal, 84) = 63: lup(kanal, 85) = 151: lup(kanal, 86) = 151: lup(kanal, 87) = 151: lup(kanal, 88) = 215: lup(kanal, 89) = 215: lup(kanal, 90) = 62: lup(kanal, 91) = 62: lup(kanal, 92) = 126: lup(kanal, 93) = 126: lup(kanal, 94) = 126: lup(kanal, 95) = 61
lup(kanal, 96) = 61: lup(kanal, 97) = 125: lup(kanal, 98) = 125: lup(kanal, 99) = 125: lup(kanal, 100) = 60: lup(kanal, 101) = 60: lup(kanal, 102) = 124: lup(kanal, 103) = 124: lup(kanal, 104) = 124: lup(kanal, 105) = 59: lup(kanal, 106) = 59: lup(kanal, 107) = 123: lup(kanal, 108) = 123: lup(kanal, 109) = 123: lup(kanal, 110) = 58: lup(kanal, 111) = 58
lup(kanal, 112) = 122: lup(kanal, 113) = 122: lup(kanal, 114) = 122: lup(kanal, 115) = 57: lup(kanal, 116) = 57: lup(kanal, 117) = 57: lup(kanal, 118) = 121: lup(kanal, 119) = 121: lup(kanal, 120) = 24: lup(kanal, 121) = 24: lup(kanal, 122) = 88: lup(kanal, 123) = 88: lup(kanal, 124) = 88: lup(kanal, 125) = 120: lup(kanal, 126) = 23: lup(kanal, 127) = 23
lup(kanal, 128) = 55: lup(kanal, 129) = 87: lup(kanal, 130) = 119: lup(kanal, 131) = 22: lup(kanal, 132) = 22: lup(kanal, 133) = 22: lup(kanal, 134) = 86: lup(kanal, 135) = 86: lup(kanal, 136) = 86: lup(kanal, 137) = 21: lup(kanal, 138) = 21: lup(kanal, 139) = 85: lup(kanal, 140) = 85: lup(kanal, 141) = 85: lup(kanal, 142) = 20: lup(kanal, 143) = 20
lup(kanal, 144) = 20: lup(kanal, 145) = 84: lup(kanal, 146) = 84: lup(kanal, 147) = 19: lup(kanal, 148) = 19: lup(kanal, 149) = 19: lup(kanal, 150) = 83: lup(kanal, 151) = 83: lup(kanal, 152) = 83: lup(kanal, 153) = 18: lup(kanal, 154) = 18: lup(kanal, 155) = 18: lup(kanal, 156) = 82: lup(kanal, 157) = 82: lup(kanal, 158) = 17: lup(kanal, 159) = 17
lup(kanal, 160) = 17: lup(kanal, 161) = 81: lup(kanal, 162) = 81: lup(kanal, 163) = 240: lup(kanal, 164) = 144: lup(kanal, 165) = 128: lup(kanal, 166) = 128: lup(kanal, 167) = 128: lup(kanal, 168) = 128: lup(kanal, 169) = 1: lup(kanal, 170) = 1: lup(kanal, 171) = 1: lup(kanal, 172) = 65: lup(kanal, 173) = 65: lup(kanal, 174) = 65: lup(kanal, 175) = 2
lup(kanal, 176) = 2: lup(kanal, 177) = 66: lup(kanal, 178) = 66: lup(kanal, 179) = 66: lup(kanal, 180) = 3: lup(kanal, 181) = 3: lup(kanal, 182) = 3: lup(kanal, 183) = 3: lup(kanal, 184) = 67: lup(kanal, 185) = 67: lup(kanal, 186) = 4: lup(kanal, 187) = 4: lup(kanal, 188) = 4: lup(kanal, 189) = 4: lup(kanal, 190) = 68: lup(kanal, 191) = 68
lup(kanal, 192) = 68: lup(kanal, 193) = 5: lup(kanal, 194) = 5: lup(kanal, 195) = 5: lup(kanal, 196) = 69: lup(kanal, 197) = 69: lup(kanal, 198) = 6: lup(kanal, 199) = 6: lup(kanal, 200) = 6: lup(kanal, 201) = 6: lup(kanal, 202) = 70: lup(kanal, 203) = 70: lup(kanal, 204) = 7: lup(kanal, 205) = 7: lup(kanal, 206) = 7: lup(kanal, 207) = 7
lup(kanal, 208) = 71: lup(kanal, 209) = 71: lup(kanal, 210) = 71: lup(kanal, 211) = 40: lup(kanal, 212) = 8: lup(kanal, 213) = 8: lup(kanal, 214) = 8: lup(kanal, 215) = 72: lup(kanal, 216) = 72: lup(kanal, 217) = 41: lup(kanal, 218) = 9: lup(kanal, 219) = 9: lup(kanal, 220) = 9: lup(kanal, 221) = 73: lup(kanal, 222) = 73: lup(kanal, 223) = 10
lup(kanal, 224) = 10: lup(kanal, 225) = 10: lup(kanal, 226) = 10: lup(kanal, 227) = 74: lup(kanal, 228) = 74: lup(kanal, 229) = 11: lup(kanal, 230) = 11: lup(kanal, 231) = 11: lup(kanal, 232) = 75: lup(kanal, 233) = 75: lup(kanal, 234) = 75: lup(kanal, 235) = 44: lup(kanal, 236) = 12: lup(kanal, 237) = 12: lup(kanal, 238) = 12: lup(kanal, 239) = 76
lup(kanal, 240) = 76: lup(kanal, 241) = 45: lup(kanal, 242) = 13: lup(kanal, 243) = 13: lup(kanal, 244) = 77: lup(kanal, 245) = 77: lup(kanal, 246) = 77: lup(kanal, 247) = 46: lup(kanal, 248) = 14: lup(kanal, 249) = 14: lup(kanal, 250) = 78: lup(kanal, 251) = 78: lup(kanal, 252) = 78: lup(kanal, 253) = 47: lup(kanal, 254) = 15: lup(kanal, 255) = 15
RETURN

lookup_fpgasid:
FOR i = 0 TO 127: lup(kanal, i) = 128 + i: NEXT
FOR i = 128 TO 255: lup(kanal, i) = i - 128: NEXT
RETURN

lookup_4_bit:
FOR i = 0 TO 255: lup(kanal, i) = INT(i / 16): NEXT
RETURN




FUNCTION ascii2screencode$ (a$, anzzeichen) 'grossklein
    ascii2screencode$ = ""
    FOR i = 1 TO anzzeichen
        z$ = CHR$(32)
        IF MID$(a$, i, 1) <> "" THEN a = ASC(MID$(a$, i, 1)) ELSE a = 32
        IF a = 92 THEN a = 44 'wandelt Backslash in Komma um (fuer Infobar, bei der das Komma nicht nativ funktioniert)
        IF a >= 33 AND a <= 63 THEN z$ = CHR$(a) '!"#$%&'()*+,-./0123456789:;<=>? '!"#$%&
        IF a = 64 THEN z$ = CHR$(0) '@
        IF a >= 65 AND a <= 90 THEN z$ = CHR$(a) 'A-Z
        IF a = 91 THEN z$ = CHR$(27) '[
        IF a = 93 THEN z$ = CHR$(29) ']
        IF a = 94 THEN z$ = CHR$(30) '/\
        IF a = 95 THEN z$ = CHR$(100) '_
        IF a >= 97 AND a <= 122 THEN z$ = CHR$(a - 96) 'a-z
        ascii2screencode$ = ascii2screencode$ + z$
    NEXT
END FUNCTION

FUNCTION ascii2screencode_gross$ (a$, anzzeichen)
    ascii2screencode_gross$ = ""
    FOR i = 1 TO anzzeichen
        z$ = CHR$(32)
        IF MID$(a$, i, 1) <> "" THEN a = ASC(MID$(a$, i, 1)) ELSE a = 32
        IF a >= 64 AND a <= 91 THEN z$ = CHR$(a - 64) '@, A-Z und [
        IF a >= 97 AND a <= 122 THEN z$ = CHR$(a - 96) 'a-z -> wird zu A-Z
        IF a = 93 THEN z$ = CHR$(29)
        IF a = 94 THEN z$ = CHR$(30)
        IF a >= 33 AND a <= 63 THEN z$ = CHR$(a) '!"#$%&'()*+,-./0123456789:;<=>? '!"#$%&
        ascii2screencode_gross$ = ascii2screencode_gross$ + z$
    NEXT
END FUNCTION

