;Breadampv05_FPGASID_recorder.asm
;--------------------------------
;
;This file is required to be able to compile the main file "BREADAMPv05.asm". It cannot be compiled on its own.
;
;Diese Datei ist nötig, um die Hauptdatei "BREADAMPv05.asm" kompilieren zu können. Sie kann nicht eigenständig kompiliert werden.

;FPGASID-Recorder
   lda #%00000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;deaktivieren

   lda maxtrack              ;Funktion abbrechen, wenn bereits 14 Tracks vorhanden
   cmp #14
   bne rec_weniger_14_tracks
   jmp Fehler_Rekorder_kein_Speicher
   rec_weniger_14_tracks
   
   ;pruefe, ob Dateiversion v02, wenn ja: Fehlermeldung
   lda header+8
   cmp #$30
   bne rec_version_ok
   lda header+9
   cmp #$32
   bne rec_version_ok
   jmp Fehler_rec_version_datei_falsch
   rec_version_ok
   
   ;Konstanten initialisieren
   ldx maxtrack
   lda #8                    ;8 Bit
   sta track_bits,x
   lda #0                    ;Mono + TV-Norm des C64
   sta track_stereo,x 
   sta rec_titeled
   lda tvnorm_c64
   sta track_tvnorm,x
   lda #3                    ;FPGASID   
   sta track_sidtyp,x
   sta track_format,x   

   lda #0                    ;samplerate initialisieren
   sta rec_srate   
   lda maxtrack              ;wenn schon 14 Tracks in der Datei sind, wird der Recorder sofort wieder verlassen und der Player neu gestartet
   cmp #14
   bne rec_weniger_als_14_tracks
   jmp player_anzeigen
   rec_weniger_als_14_tracks
   lda #15
   sta te_blinkzeit
   lda #1
   sta te_timer
   
   lda #$00
   sta REU_BytesHi
   lda #$01
   sta REU_BytesLo
   
   ;Screencodes fuer Sampleraten (gueltig fuer PAL und NTSC)
   lda #$31          ;15 kHz
   sta lup_sr_zehner 
   lda #$35
   sta lup_sr_einer
   lda #$31          ;11 kHz
   sta lup_sr_zehner+1 
   lda #$31
   sta lup_sr_einer+1
   lda #$20          ;7 kHz
   sta lup_sr_zehner+2
   lda #$37
   sta lup_sr_einer+2
   lda #$20          ;5 kHz
   sta lup_sr_zehner+3
   lda #$35
   sta lup_sr_einer+3
   
   ;Geschwindigkeit Pegelanzeigen
   lda #8
   sta rec_pegel_speed+1
   
   ;SID initialisieren
   lda #%00111111            ;Ext-In aktiv
   sta $D41F
   lda #%00000000            ;Identify auf Rev+Digi, Mono-Mode
   sta $D41E
    lda #0                       ;FPGASID Register Reset (nötig, damit er nicht verstummt beim Schalten von Stereo auf Mono)
    sta $D404                    
    sta $D40B
    sta $D412
    lda #73
    sta $D404
    sta $D40B
    sta $D412
   lda #15                   ;Lautstaerke Max
   sta $D418  

   ;Bildschirm bereinigen
   lda maxtrack              ;Playpfeil entfernen
   sta track_wahl
   sta track                 ;Tracknummer auf maxtrack setzen
   beq rec_leere_datei
   jsr playpfeil
   
   lda infobar               ;Infoleiste aus
   beq rec_keine_infoleiste
   jsr infoleiste_aus
   rec_keine_infoleiste
   rec_leere_datei
   lda #$38                  ;8 Bit anzeigen
   sta posbitanzeige
   lda #77                   ;Anzeige "Mono"
   sta posmonostereo
   lda #15
   sta posmonostereo+1
   sta posmonostereo+3
   lda #14
   sta posmonostereo+2 
   
   lda #186                  ;Statusanzeige auf "FPGA, Lin., TV-Norm des C64
   sta posstatusanzeige
   lda #187
   sta posstatusanzeige+1
   lda #198
   sta posstatusanzeige+40
   lda #199
   sta posstatusanzeige+41
   lda tvnorm_c64
   bne rec_init_NTSC
   lda #236
   sta posstatusanzeige+80
   lda #237
   sta posstatusanzeige+81
   jmp rec_init_PAL
   rec_init_NTSC
   lda #238
   sta posstatusanzeige+80
   lda #239
   sta posstatusanzeige+81
   rec_init_PAL
   
   ;Startadresse fuer die Aufnahme suchen
   lda #0
   sta rec_start_h
   sta rec_start_m
   sta rec_start_l
   lda maxtrack
   bne rec_keine_neue_datei
   lda #$02                     ;wenn neue Datei, dann Aufnahmebeginn in der REU auf $0002C0 setzen
   sta rec_start_m
   lda #$C0
   sta rec_start_l
   jmp rec_leere_datei_1
   
   rec_keine_neue_datei
   ldx #0
   rec_suche_start_loop
   lda trackstart_h,x
   cmp rec_start_h
   bcc rec_suche_start_naechste
   bne rec_suche_start_neuer_wert
   lda trackstart_m,x
   cmp rec_start_m
   bcc rec_suche_start_naechste
   bne rec_suche_start_neuer_wert
   lda trackstart_l,x
   cmp rec_start_l
   bcc rec_suche_start_naechste

   rec_suche_start_neuer_wert
   lda trackstart_h,x       ;hoechste Startadresse der Tracks wird in rec_start_h/m/l gespeichert (temporaer zwecks weiteren Vergleich)
   sta rec_start_h
   lda trackstart_m,x
   sta rec_start_m
   lda trackstart_l,x
   sta rec_start_l
   stx temp                 ;Nummer des Tracks, dessen Adresse den hoechsten Wert hat in temp speichern

   rec_suche_start_naechste
   inx
   cpx maxtrack
   bne rec_suche_start_loop
   
   ldx temp                 ;Laenge des Track mit der hoechsten Startadresse zur Aufnahmestartadresse addieren
   clc
   lda trackstart_l,x
   adc tracklaenge_l,x 
   sta rec_start_l
   lda trackstart_m,x
   adc tracklaenge_m,x 
   sta rec_start_m
   lda trackstart_h,x
   adc tracklaenge_h,x 
   sta rec_start_h
   rec_leere_datei_1

   lda rec_start_h          ;pruefen, ob die Datei voll (wenn errechneter Start = $000000), wenn ja: Rekorder verlassen und Player neustarten
   bne rec_start_ok
   lda rec_start_m
   bne rec_start_ok
   lda rec_start_l
   bne rec_start_ok
   jmp Fehler_Rekorder_kein_Speicher
   rec_start_ok
   
   ;Hilfetext am unteren Bildschirmrand anzeigen
   ldx #0
   loop_rec_text_vor_aufnahme
   lda text_rec_vor_aufnahme,x
   sta 1986,x
   inx
   cpx #36
   bne loop_rec_text_vor_aufnahme
   
   ;Zeile fuer neuen Track anlegen
   ldx maxtrack              ;Tracknummer in Variablen
   cpx #9
   bpl rec_tracknr_zweistellig
   lda #0
   sta tracknr_z,x
   clc
   lda maxtrack
   adc #1
   sta tracknr_e,x
   jmp rec_tracknr_ende
   rec_tracknr_zweistellig
   lda #1
   sta tracknr_z,x
   sec
   lda maxtrack
   sbc #9
   sta tracknr_e,x
   rec_tracknr_ende

   clc
   lda lookup_posplaylist_l,x              
   sta rec_pos_playlist_neuer_track_1+1
   adc #1
   sta rec_pos_playlist_neuer_track_2+1
   adc #1
   sta rec_pos_playlist_neuer_track_3+1
   lda lookup_posplaylist_h,x
   sta rec_pos_playlist_neuer_track_1+2
   sta rec_pos_playlist_neuer_track_2+2
   sta rec_pos_playlist_neuer_track_3+2
   clc
   lda tracknr_z,x
   adc #$30
   rec_pos_playlist_neuer_track_1 sta $0000
   lda tracknr_e,x
   adc #$30
   rec_pos_playlist_neuer_track_2 sta $0000
   lda #240                                      ;Pausezeichen
   rec_pos_playlist_neuer_track_3 sta $0000

   jsr tracknranzeige_sub
 
   ;Restzeitanzeige
   restzeitanzeige
   ldx track
   ldy rec_srate             ;y hier benutzen, vor Aufnahmebeginn auf 252 setzen (fuer Aufnahme C64 -> REU)
   lda #0
   sta track_sr_h,x
   lda lup_sr_m,y            ;Samplerate in Variablen des Tracks schreiben
   sta track_sr_m,x
   lda lup_sr_l,y
   sta track_sr_l,x
   lda lup_srate,y 
   sta track_srate,x

   lda lup_takte,y           ;Takte zwischen den Samples
   sta track_takte,x
   lda lup_sr_zehner,y       ;kHz-Anzeige aktualisieren
   sta poskhzanzeige
   lda lup_sr_einer,y
   sta poskhzanzeige+1

   ;freie Bytes in REU berechnen und maximale Aufnahmezeit anzeigen
   lda #00
   sta temp2
   sta temp 
   sec
   lda temp                
   sbc rec_start_m
   sta dividend+1
   lda temp2 
   sbc rec_start_h
   sta dividend+2
   lda #0
   sta dividend 
   jsr spielzeit_sub1 
   jsr spielzeit_sub2   
 ;vorhoeren und Pegeltest
 vorhoeren
 jsr pegelanzeige


 ;Tastaturabfrage
 lda #%01111111 ;Spalte 7
 sta $DC00
 lda $DC01
 cmp #%11101111 ;Leertaste - Clippinganzeige resetten
 bne rec_check_runstop
 beq rec_clippingreset
 rec_check_runstop
  cmp #%01111111 ;RUN/STOP - Player stoppen
  bne rec_check_spalte_1
  jmp player_stop
 
 rec_check_spalte_1
 lda #%11111101 ;Spalte 1
 sta $DC00
 lda $DC01
 cmp #%11011111 ;Taste S - Samplerate wechseln
 beq rec_samplerate
 
 lda #%11111110 ;Spalte 0
 sta $DC00
 lda $DC01
 cmp #%11101111 ;Taste F1 - Aufnahme beginnen
 beq rec_aufnahme_beginnen

 lda #%11111110 ;Spalte 0
 sta $DC00
 lda $DC01
 cmp #%11110111 ;F7 - Recorder beenden
 beq rec_aufnahme_abbrechen
 
 lda #0
 sta taste
 
 jmp vorhoeren
 
 rec_aufnahme_abbrechen
 lda #1
 sta taste
 jmp player_anzeigen
 
 rec_clippingreset
   lda #77                ;Anzeige "Mono"
   sta posmonostereo
   lda #15
   sta posmonostereo+1
   sta posmonostereo+3
   lda #14
   sta posmonostereo+2 
  jmp vorhoeren
   
 rec_samplerate
 lda taste               ;Wiederholsperre, solange Taste gedrueckt bleibt
 bne rec_samplerate_skip
 lda #1
 sta taste
 ldx rec_srate
 inx
 lda tvnorm_c64          ;wenn TV-Norm des C64 = PAL, dann die "ungeraden" Sampleraten ueberspringen
 beq rec_samplerate_PAL
 inx
 rec_samplerate_PAL
 stx rec_srate
 cpx #4
 beq rec_samplerate_0
 jmp restzeitanzeige
 rec_samplerate_0
 ldx #0
 stx rec_srate
 rec_samplerate_skip
 jmp restzeitanzeige  

 rec_aufnahme_beginnen 
   lda #1
   sta rec_aufnahme
   ldx maxtrack
   clc
   lda lookup_posplaylist_l,x              
   adc #2
   sta rec_pos_playlist_neuer_track_4+1
   lda lookup_posplaylist_h,x
   sta rec_pos_playlist_neuer_track_4+2
   lda #127                                      ;ausgefuellter Kreis = Aufnahme
   rec_pos_playlist_neuer_track_4 sta $0000
   
   lda rec_start_h                               ;REU initialisieren
   sta REU_Bank1
   sta REU_Bank
   lda rec_start_m
   sta REU_Hi
   lda rec_start_l
   sta REU_Lo
   lda #$D4                    ;Adresse des Digifix-Registers des FPGASID als REU-Transfer-Ziel
   sta REU_C64Hi
   lda #$1D
   sta REU_C64Lo  
   
   ldy #252                   ;reserviertes Register y = 252 (Kommando fuer die REU zum Aufnehmen)
   
   jsr player_samplerate_wechseln 
   lda #<recorder            ;Adresse des NMI
   sta $FFFA
   lda #>recorder
   sta $FFFB
   lda #%10000001           ;IRQ fuer Timer-A 
   sta $dd0d                ;aktivieren (Recorder starten)
   
   ;Hilfetext am unteren Bildschirmrand anzeigen
   ldx #0
   loop_rec_text_bei_aufnahme
   lda text_rec_bei_aufnahme,x
   sta 1986,x
   inx
   cpx #36
   bne loop_rec_text_bei_aufnahme
   
   ;Pegelanzeige beschleunigen
   lda #4
   sta rec_pegel_speed+1
 
  recorder_hauptschleife
   lda eingabemodus         ;Cursor blinken lassen, wenn Titelnameneditor aktiv
   beq rec_em0
   jsr te_cursorblinken
   rec_em0
   inc wechsel              ;Schalter, der Anzeige auf 3 Durchlaeufe aufteilt, um die Reaktionszeit der Tastatur zu verbessern
   lda wechsel
   cmp #1
   beq rec_anzeige_aufgenommene_zeit
   cmp #2
   beq rec_anzeige_pegel
   ;freie Bytes in REU berechnen und verbleibende Aufnahmezeit anzeigen
   lda #0                   ;Wechselschalter auf 0 setzen, wenn er auf 3 ist
   sta wechsel
   ldx track
   lda REU_Bank1
   sta temp2
   lda REU_Hi
   sta temp 
   bne sub5              ;wenn REU_Hi 0 ist, lade REU_Bank1 nochmal, denn es koennte zwischenzeitlich eine Erhoehung um 1 passiert sein
   lda REU_Bank1
   sta temp2
   sub5  

   sec
   lda #0                
   sbc temp
   sta dividend+1
   lda #0 
   sbc temp2
   sta dividend+2
   lda #0
   sta dividend 
   jsr spielzeit_sub1 
   jsr spielzeit_sub2 
   jmp rec_pruefe_aufnahmeende
   
   rec_anzeige_pegel
   jsr pegelanzeige
   jmp rec_pruefe_aufnahmeende

   ;aufgenommene Zeit in der Playlistzeile
   rec_anzeige_aufgenommene_zeit
   ldx track
   lda REU_Bank1
   sta temp2
   lda REU_Hi
   sta temp 
   bne sub6              ;wenn REU_Hi 0 ist, lade REU_Bank1 nochmal, denn es koennte zwischenzeitlich eine Erhoehung um 1 passiert sein
   lda REU_Bank1
   sta temp2
   sub6  

   sec
   lda temp                
   sbc rec_start_m 
   sta dividend+1
   lda temp2
   sbc rec_start_h
   sta dividend+2
   lda #0
   sta dividend 
   sta divisor+2
   lda track_sr_m,x          ;Samplerate in den Divisor
   sta divisor+1
   lda track_sr_l,x 
   sta divisor
   jsr div24                 ;Ergebnis ist die abgelaufene Zeit in Sekunden
   
     ;Minuten und Sekunden durch Division durch 60 berechnen (die Sekunden stehen noch im Dividend)
   lda #60       
   sta divisor
   lda #0
   sta divisor+1
   jsr div16
   
   ldx track_wahl
   lda lookup_posplaylist_h,x ;Zeilenbeginn im Bildschirmspeicher ermitteln und an die Stellen im Programm schreiben, 
   sta rec_aufg_zeit_m_z+2
   sta rec_aufg_zeit_m_e+2
   sta rec_aufg_zeit_dp+2
   sta rec_aufg_zeit_s_z+2
   sta rec_aufg_zeit_s_e+2
   lda lookup_posplaylist_l,x
   sta rec_aufg_zeit_m_z+1
   sta rec_aufg_zeit_m_e+1
   sta rec_aufg_zeit_dp+1
   sta rec_aufg_zeit_s_z+1
   sta rec_aufg_zeit_s_e+1
   
   ldx dividend         ;Minuten im Dividend (=Ergebnis)
   lda lookup_hex2bcd,x ;10er
   lsr
   lsr
   lsr
   lsr
   clc
   adc #$30
   ldx #33
   rec_aufg_zeit_m_z sta $0000,x

   ldx dividend
   lda lookup_hex2bcd,x ;1er
   and #%00001111
   clc
   adc #$30
   ldx #34
   rec_aufg_zeit_m_e sta $0000,x 
   
   lda #$3A             ;Doppelpunkt
   ldx #35
   rec_aufg_zeit_dp sta $0000,x   
   
   ldx divrest          ;Sekunden im Rest
   lda lookup_hex2bcd,x ;10er  
   lsr
   lsr
   lsr
   lsr
   clc
   adc #$30
   ldx #36
   rec_aufg_zeit_s_z sta $0000,x

   ldx divrest
   lda lookup_hex2bcd,x ;1er
   and #%00001111
   clc
   adc #$30
   ldx #37
   rec_aufg_zeit_s_e sta $0000,x 
     
   
   
   
  ;wenn Ueberlaufflag gesetzt oder F7 gedrueckt: Aufnahme beenden
  rec_pruefe_aufnahmeende
  lda rec_ueberlauf          
  bne rec_aufnahme_beenden
  
  lda eingabemodus
  beq rec_taste_leer
  lda #%00000000          ;alle Spalten durchschalten, um zu pruefen, ob irgendeine Taste gedrueckt ist
  sta $DC00
  lda $DC01
  cmp #$FF
  bne rec_em1
  lda #$F0                ;setze Wert fuer Ignorieren, wenn keine Taste gedrueckt ist, da nach Loslassen und
  sta te_taste            ;erneutem Druecken die Taste wieder ausgewertet wird
  rec_em1 
  jsr eingabemodus_titelnameneditor
  jmp recorder_hauptschleife
  
  rec_taste_leer
  lda #%01111111 ;Spalte 7
  sta $DC00
  lda $DC01
  cmp #%11101111 ;Leertaste - Clippinganzeige resetten
  bne rec_taste_n
   lda #77                ;Anzeige "Mono"
   sta posmonostereo
   lda #15
   sta posmonostereo+1
   sta posmonostereo+3
   lda #14
   sta posmonostereo+2 
  jmp recorder_hauptschleife 

  rec_taste_n
  lda #%11101111 ;Spalte 4
  sta $DC00
  lda $DC01
  cmp #%01111111 ;N - Titelnameneditor
  bne rec_taste_del
  lda #1
  sta eingabemodus
  sta rec_titeled
  jsr titelnameneditor
  jmp recorder_hauptschleife  
  
  rec_taste_del
  lda #%11111110 ;Spalte 0
  sta $DC00
  lda $DC01
  cmp #%11111110 ;DEL - Aufnahme verwerfen
  bne rec_taste_F7
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren
  jmp player_anzeigen
  
  rec_taste_F7
  cmp #%11110111 ;F7 - Aufnahme beenden
  beq rec_aufnahme_beenden
  jmp recorder_hauptschleife
 
  rec_aufnahme_beenden
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren
  lda eingabemodus
  beq rec_aufnahme_beenden_ohne_te
  jsr te_taste_return_jmp   ;wenn Titelnameneditor aktiv war, simuliere Druck auf Return-Taste, um ihn zu beenden
  rec_aufnahme_beenden_ohne_te
  
  ;Laenge des Tracks berechnen
  ldx maxtrack
  sec
  lda REU_Lo
  sbc rec_start_l
  sta tracklaenge_l,x
  sta tempmem+$F
  lda REU_Hi
  sbc rec_start_m
  sta tracklaenge_m,x
  sta tempmem+$E
  lda REU_Bank1
  sbc rec_start_h
  sta tracklaenge_h,x
  sta tempmem+$D
  
  ;Metadateneintrag anlegen
  lda #$54                ;Text "TRACK xx  "
  sta tempmem
  lda #$52
  sta tempmem+$1
  lda #$41
  sta tempmem+$2
  lda #$43
  sta tempmem+$3
  lda #$4B
  sta tempmem+$4
  lda #$20
  sta tempmem+$5
  sta tempmem+$8
  sta tempmem+$9
  clc
  lda tracknr_z,x 
  adc #$30
  sta tempmem+$6
  lda tracknr_e,x 
  adc #$30
  sta tempmem+$7
  lda rec_start_h
  sta tempmem+$A
  lda rec_start_m
  sta tempmem+$B
  lda rec_start_l
  sta tempmem+$C

  clc                     ;sendet 16 Bytes mit REU-FS-Eintrag von tempmem im C64 an die berechnete REU-Adresse                     
  lda #<tempmem
  sta REU_C64Lo
  lda #0
  sta REU_Hi
  sta REU_Bank
  ldx #$FF
  rec_loop_reu_meta_1
  adc #$10                ;bei maxtrack = 0 ist REU-Adresse $000010, bei maxtrack = 1 $000020 etc
  inx
  cpx maxtrack
  bne rec_loop_reu_meta_1
  sta REU_Lo
  lda #$10
  sta REU_BytesLo
  lda #>tempmem
  sta REU_C64Hi
  lda #252
  sta REU_CMD
  
  lda rec_titeled
  bne rec_titeled_genutzt
  
  ldx #0              ;wenn Titeleditor nicht genutzt, Titelname "recorded by Breadamp"
  rec_loop_reu_meta_2
  lda text_rec_by_breadamp,x 
  sta tempmem,x 
  inx
  cpx #29
  bne rec_loop_reu_meta_2
  jmp rec_titeled_nicht_genutzt
  
  rec_titeled_genutzt
  ldx maxtrack
  lda lookup_posplaylist_h,x
  sta rec_titeled_genutzt_adr+2
  lda lookup_posplaylist_l,x
  clc
  adc #3
  sta rec_titeled_genutzt_adr+1
  ldx #0
  rec_loop_reu_meta_2a
  rec_titeled_genutzt_adr lda $0000,x ;$0000 ist Platzhalter, Adresse wird oben berechnet
  sta tempmem,x
  inx
  cpx #29
  bne rec_loop_reu_meta_2a
  
  rec_titeled_nicht_genutzt  
  lda #%00001111      ;PAL, Mono, FPGASID 
  ldx tvnorm_c64
  beq rec_meta_PAL
  lda #%10001111      ;wenn C64 NTSC, dann umschalten auf NTSC, Mono, FPGASID 
  rec_meta_PAL
  sta tempmem+29
  
  lda #8              ;8 Bits pro Sample 
  sta tempmem+30
  
  ldx maxtrack
  stx starttrack
  lda track_srate,x
  sta tempmem+31
  
  lda #0              ;REU-Adresse berechnen
  sta temp2
  ldx #$FF
  lda #$E0
  sta temp
  rec_loop_reu_meta_3
  clc
  lda temp
  adc #$20                ;bei maxtrack = 0 ist REU-Adresse $000100, bei maxtrack = 1 $000120 etc
  sta temp
  lda temp2
  adc #0
  sta temp2
  inx
  cpx maxtrack
  bne rec_loop_reu_meta_3
  lda temp
  sta REU_Lo
  lda temp2
  sta REU_Hi
  lda #$20
  sta REU_BytesLo
  lda #252
  sta REU_CMD  

  lda #1
  sta taste
  
  jmp player_anzeigen
 
 
;Aufnahmeengine
recorder    ;Recorder Mono, 8 Bit
         sty REU_CMD               ;REU-Stash (Y hier immer 252 - ausschließlich fuer REU-Stash reserviert !)
         inc REU_Lo
         bne exit_rec
         inc REU_Hi
         bne exit_rec
         inc REU_Bank1
         ldy REU_Bank1
         bne rec_bank_ok           ;pruefe auf REU-Bank-Ueberlauf - wenn ja: Rekorder sofort beenden
          ldy #1
          sty rec_ueberlauf
          lda #%00000001            ;IRQ fuer Timer-A 
          sta $dd0d                 ;deaktivieren
         rec_bank_ok
         sty REU_Bank
         ldy #252                  ;geliehenes Y-Register wieder auf 253 setzen !
         exit_rec 
 bit $dd0d                         ;IRQs bestaetigen
rti                                ;und zurueck 

;Pegelanzeige
pegelanzeige
   lda #0
   sta rec_maxpegel          ;Variable max. Pegel
   sta temp4                 ;Verzoegerungsvariable
   ldx #0
   check_dfx_reg_1
   lda $D41D                 ;Digifix-Register: gibt beim Lesen den aktuellen Samplewert des Audio-IN
   sta temp
   bpl digiwert_positiv
   sec                       ;"Hochklappen" der negativen Werte, allerdings so, dass das resultierende
   lda #$FF                  ;Maximum 127 statt 128 ist Wert um 1 verringert (durch startwert #$FF statt $00)
   sbc temp
   digiwert_positiv
   cmp rec_maxpegel
   bmi kein_neues_maximum
   sta rec_maxpegel
   kein_neues_maximum
   
   inx
   bne check_dfx_reg_1
   inc temp4
   lda temp4
   rec_pegel_speed cmp #8
   bne check_dfx_reg_1
   
   lda rec_maxpegel
   cmp #127
   bne nicht_geclippt
   ldx #67      ;C 
   stx posmonostereo
   ldx #76      ;L
   stx posmonostereo+1
   ldx #73      ;I   
   stx posmonostereo+2
   ldx #80      ;P 
   stx posmonostereo+3
   nicht_geclippt
   lsr
   lsr
   lsr
   sta temp2        ;Spalte, in der der Balken beginnt (0-15)
   lda temp
   and #%00000111
   sta temp3        ;Pixelverschub des Balkens (0-7)
 
   ;Punkte vor dem Balken
   lda temp2
   beq balken_spalte_0_rec
   tax
   dex
   balken_spalte_rec
    lda #216       ;Zeichen Punkte oben
    sta posbalken,x
    lda #233       ;Zeichen Punkte unten
    sta posbalken+40,x
    dex
    cpx #$ff       
    bne balken_spalte_rec
   balken_spalte_0_rec

   ;Balken
   ldx temp2
   lda temp3
   clc
   adc #200        ;Zeichen fuer Pixelverschub 0, oben links
   sta posbalken,x
   lda temp3
   adc #217        ;Zeichen fuer Pixelverschub 0, unten links
   sta posbalken+40,x
   lda temp3
   adc #208        ;Zeichen fuer Pixelverschub 0, oben rechts
   sta posbalken+1,x
   lda temp3
   adc #225        ;Zeichen fuer Pixelverschub 0, unten rechts
   sta posbalken+41,x

   ;Punkte hinter dem Balken
   ldx temp2
   cpx #15
   beq balken_spalte_15_rec
   balken_spalte_y_rec
    lda #216       ;Zeichen Punkte oben
    sta posbalken+2,x
    lda #233       ;Zeichen Punkte unten
    sta posbalken+42,x 
    inx
    cpx #15
    bne balken_spalte_y_rec
   balken_spalte_15_rec 
   rts 