;Breadampv05_Tastaturfunktionen.asm
;----------------------------------
;
;This file is required to be able to compile the main file "BREADAMPv05.asm". It cannot be compiled on its own.
;
;Diese Datei ist nötig, um die Hauptdatei "BREADAMPv05.asm" kompilieren zu können. Sie kann nicht eigenständig kompiliert werden.


;Tastatur- und Joystickabfrage (Port 2) ueber Tastaturmatrix/CIA1 und angeforderte Aktionen durchfuehren
tastaturabfrage
 lda eingabemodus         ;Cursor blinken lassen, wenn Titelnameneditor aktiv
 beq em0
 jsr te_cursorblinken
 em0
 lda #%00000000          ;alle Spalten durchschalten, um zu pruefen, ob irgendeine Taste gedrueckt ist
 sta $DC00
 lda $DC01
 cmp #$FF
 bne Schalter_Eingabemodus
 lda #%01111111          ;stellt CIA1 Port A so ein, wie er es auch unter Basic ist (zwecks Vergleichbarkeit der Ausgabewerte)
 sta $DC00
 lda $DC00               ;pruefe, ob eine Betaetigung, des Joysticks statt fand
 cmp #127
 bne joystick_port2
 ldx #0                  ;wenn gar keine Taste gedrueckt wurde und auch der Joystick nicht betaetigt wurde, dann kuerze ab
 stx taste               ;und vermerke, dass keine Taste gedrueckt ist (wegen Wiederholsperre)
 
 lda eingabemodus
 beq em0a
 lda #$F0                ;setze Wert fuer Ignorieren, wenn keine Taste gedrueckt ist, da nach Loslassen und
 sta te_taste            ;erneutem Druecken die Taste wieder ausgewertet wird
 em0a jmp trackendeueberwachung

;Schalter fuer Eingabemodus (0 = Player, 1 = Titelnameneditor)
Schalter_Eingabemodus
lda eingabemodus
beq eingabemodus_player
jsr eingabemodus_titelnameneditor  ;Durchlauf Titelnameneditor (Unterprogramm)
jmp trackendeueberwachung          ;anschließend zur Trackendeueberwachung (neuer Player-Frontend-Durchlauf)
 
eingabemodus_player
 ;pruefen, ob die Commodore-Taste gedrückt ist
 lda #0
 sta commodore
 lda #%01111111          ;Commodore-Taste
 sta $DC00
 lda $DC01
 ora #%11011111
 cmp #%11011111
 bne shift_links
 lda #1
 sta commodore
 
 ;pruefen, ob eine Shifttaste gedrueckt ist
 shift_links
 lda steuerung           ;bei Steuerungsmodus 1 nicht die Tastatur, sondern den Joystick Port 1 ueberwachen
 beq shift_links_1
 jmp joystick_port_1
 shift_links_1
 lda #0
 sta shift
 lda #%11111101          ;linke Shifttaste
 sta $DC00
 lda $DC01
 ora #%01111111
 cmp #%01111111
 bne shift_rechts 
 lda #1
 sta shift  ;linke shifttaste gedrueckt
 jmp tastatur_spalte_0
 shift_rechts
 lda #%10111111          ;rechte Shifttaste
 sta $DC00
 lda $DC01
 ora #%11101111
 cmp #%11101111
 bne tastatur_spalte_0
 lda #2
 sta shift  ;rechte shifttaste gedrueckt
 jmp tastatur_spalte_0
 
 joystick_port2          ;CIA2-Wert noch im Akku
 cmp #119                ;Rechts
 beq joy_2_rechts
 cmp #123                ;Links
 beq joy_2_links
 cmp #126                ;Hoch
 beq joy_2_hoch
 cmp #125                ;Runter
 beq joy_2_runter
 cmp #111                ;Feuer
 beq joy_2_feuer
 jmp trackendeueberwachung ;wenn keine gueltige Joystickbewegung (z.B. diagonal oder Richtung+Feuer), dann neue Programmschleife
  joy_2_rechts
  jmp vorspulen_joystick
  joy_2_links
  jmp zurueckspulen_joystick
  joy_2_hoch
  ldx #1                 ;Joystick hoch wirkt wie crsr hoch/runter+shift
  stx shift
  jmp trackwechsel_joystick
  joy_2_runter
  ldx #0                 ;Joystick runter wirkt wie crsr hoch/runter ohne shift
  stx shift
  jmp trackwechsel_joystick
  joy_2_feuer
  jmp pause_joystick

 tastatur_spalte_0
 lda #%11111110 ;Spalte 0
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_1   ;keine Taste in Spalte 0 gedrueckt

  cmp #%11111011         ;### Cursor rechts/links = Vor- und Zurueckspulen 
  bne check_taste_F7         
  lda shift
  bne sp_zurueck
  jmp vorspulen_cursortaste
  sp_zurueck 
  jmp zurueckspulen_cursortaste
   
  check_taste_F7
  cmp #%11110111         ;### Discomodus an/aus
  bne check_taste_F1
  jmp discomodus_an_aus
  
  check_taste_F1         ;### Rahmenfarbe
  cmp #%11101111
  bne check_taste_F3
  jmp rahmenfarbe_aendern
  
  check_taste_F3         ;### Hintergrundfarbe
  cmp #%11011111
  bne check_taste_F5
  jmp hintergrundfarbe_aendern

  check_taste_F5         ;### Textfarbe
  cmp #%10111111
  bne check_taste_crsr_hr
  jmp textfarbe_aendern
  
  check_taste_crsr_hr 
  cmp #%01111111         ;### Cursor hoch/runter = Trackwechsel vor und zurueck
  bne tastatur_spalte_1
  jmp trackwechsel_vor_zurueck
  
  
 tastatur_spalte_1
 lda #%11111101 ;Spalte 1
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_2   ;keine Taste in Spalte 1 gedrueckt
 
  cmp #%11111110         ;### Taste 3 = Track 3
  bne check_taste_A
  jmp track_3  
  
  check_taste_A
  cmp #%11111011         ;### Taste A = Track 11
  bne check_taste_4
  jmp track_11
  
  check_taste_4
  cmp #%11110111         ;### Taste 4 = Track 4
  bne check_taste_S
  jmp track_4
  
  check_taste_S
  cmp #%11011111         ;### Taste S = SID-Einstellung fuer Musikdateien v02
  bne tastatur_spalte_2
  jmp sound_einstellung
  
  
 tastatur_spalte_2
 lda #%11111011 
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_3  ;keine Taste in Spalte 2 gedrueckt

  cmp #%11111110         ;### Taste 5 = Track 5
  bne check_taste_R
  jmp track_5
  
  check_taste_R
  cmp #%11111101         ;### Taste R = Trackrepeat, C=+R = FPGASID-Recorder
  bne check_taste_D
  lda commodore
  bne check_taste_R_rec
  jmp track_repeat
  check_taste_R_rec
  lda tvnorm_falsch
  beq tvnorm_richtig
  jmp trackendeueberwachung
  tvnorm_richtig
  jmp fpgasid_recorder
  
  check_taste_D
  cmp #%11111011         ;### Taste D = Track 14
  bne check_taste_6
  jmp track_14
  
  check_taste_6
  cmp #%11110111         ;### Taste 6 = Track 6
  bne check_taste_C
  jmp track_6
  
  check_taste_C
  cmp #%11101111         ;### Taste C = Track 13, C=+Shift+C = REU leeren
  bne check_taste_F
  lda commodore
  bne taste_C_REU_leeren
  jmp track_13
  taste_C_REU_leeren 
  lda shift
  beq taste_C_REU_leeren_1
  jmp REU_leeren
  taste_C_REU_leeren_1
  jmp trackendeueberwachung
  
  check_taste_F
  cmp #%11011111         ;### Taste F = Einstellung fuer Formatanzeige (%00 = aus, %01 = kurz anzeigen (standard), %10 = immer anzeigen), C=+Shift+F = REU formatieren
  bne tastatur_spalte_3
  lda commodore
  bne taste_F_REU_formatieren
  jmp formatanzeige
  taste_F_REU_formatieren
  lda shift
  beq REU_formatieren_1
  jmp REU_formatieren
  REU_formatieren_1
  jmp trackendeueberwachung
  

 tastatur_spalte_3
 lda #%11110111 
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_4   ;keine Taste in Spalte 3 gedrueckt
 
  cmp #%11111110         ;### Taste 7 = Track 7
  bne check_taste_8
  jmp track_7
  
  check_taste_8
  cmp #%11110111         ;### Taste 8 = Track 8
  bne check_taste_B
  jmp track_8
  
  check_taste_B
  cmp #%11101111         ;### Taste B = Track 12
  bne tastatur_spalte_4
  jmp track_12
  
 tastatur_spalte_4
 lda #%11101111 
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_5   ;keine Taste in Spalte 4 gedrueckt

  cmp #%11111110         ;### Taste 9 = Track 9
  bne check_taste_I
  jmp track_9
  
  check_taste_I 
  cmp #%11111101         ;### Taste I = Infoleiste ein/aus
  bne check_taste_0
  jmp infoleiste_ein_aus
  
  check_taste_0
  cmp #%11110111         ;### Taste 0 = Track 10
  bne check_taste_N
  jmp track_10
  
  check_taste_N
  cmp #%01111111         ;### Taste N = Titelnameneditor (wenn C=-Taste gedrückt)
  bne tastatur_spalte_5
  lda commodore
  beq tastatur_spalte_5
  jsr titelnameneditor
  jmp trackendeueberwachung
  
 tastatur_spalte_5
 lda #%11011111 
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_6   ;keine Taste in Spalte 5 gedrueckt

  cmp #%11111110         ;### Taste + = Geschwindigkeit der Infoleiste erhoehen
  bne check_taste_P
  jmp geschwindigkeit_infoleiste_erhoehen
  
  check_taste_P
  cmp #%11111101         ;### Taste P = Pause
  bne check_taste_minus
  jmp wiedergabe_pause
  
  check_taste_minus
  cmp #%11110111         ;### Taste - = Geschwindigkeit der Infoleiste verringern
  bne check_taste_Punkt
  jmp geschwindigkeit_infoleiste_verringern 
  
  check_taste_Punkt
  cmp #%11101111         ;### Taste . / > = Vorspulen
  bne check_taste_at
  jmp vorspulen
  
  check_taste_at
  cmp #%10111111         ;### Taste @ = Trackcursor hoch
  bne check_taste_Komma
  jmp trackcursor_hoch
   
  check_taste_Komma
  cmp #%01111111         ;### Taste , / < = Zurueckspulen
  bne tastatur_spalte_6
  jmp zurueckspulen
  

 tastatur_spalte_6
 lda #%10111111 
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_spalte_7   ;keine Taste in Spalte 6 gedrueckt
 
  cmp #%11111101         ;### Taste * = Track eine Zeile nach oben
  bne check_taste_Semikolon
  jmp track_eine_zeile_nach_oben

  check_taste_Semikolon
  cmp #%11111011         ;### Taste ; = Trackcursor runter
  bne check_taste_Gleichheitszeichen
  jmp trackcursor_runter

  check_taste_Gleichheitszeichen 
  cmp #%11011111         ;### Taste Gleichheitszeichen = Track eine Zeile nach unten
  bne check_taste_Schraegstrich
  jmp track_eine_zeile_nach_unten
  
  check_taste_Schraegstrich
  cmp #%01111111         ;### / = Umschaltung Tastatur + Joystick Port 2 oder Joytick Port 1 + Port 2, hier: Tastatur deaktivieren 
  bne tastatur_spalte_7
  jmp steuerung_aendern
 
  
tastatur_spalte_7
 lda #%01111111 
 sta $DC00
 lda $DC01
 cmp #$FF
 beq tastatur_keine_Taste ;keine Taste in Spalte 7 gedrueckt
 
  cmp #%11111110         ;### Taste 1 = Track 1
  bne check_taste_2
  jmp track_1
  
  check_taste_2
  cmp #%11110111         ;### Taste 2 = Track 2
  bne check_taste_runstop
  jmp track_2
  
  check_taste_runstop
  cmp #%01111111         ;### Taste Run/Stop = Player-Stop zwecks REU-File wechseln
  bne tastatur_keine_Taste
  jmp player_stop
  

tastatur_keine_Taste
 ldx #0
 stx taste
jmp trackendeueberwachung



joystick_port_1
 lda #%10111111 ;Spalte 6
 sta $DC00
 lda $DC01
  cmp #%01111111         ;### / = Umschaltung Tastatur + Joystick Port 2 oder Joytick Port 1 + Port 2, hier: Tastatur aktivieren 
  bne ende_Schraegstrich_taste          
  lda taste              ;wenn bereits eine Taste gedrueckt ist, mache keinen Steuerungsmoduswechsel (Wiederholsperre)
  bne ende_Schraegstrich_taste  
  lda #1
  sta taste              ;Flag taste setzen
  lda #0
  sta steuerung          ;Tastatur wieder aktivieren
  ende_Schraegstrich_taste
 
 lda $DC01
 cmp #239
 beq joy_1_pruefen_2
 ldx #0
 stx feuer1serie

 joy_1_pruefen_2
 cmp #254
 beq joy_1_hoch
 cmp #253
 beq joy_1_runter
 cmp #251
 beq joy_1_links
 cmp #247
 beq joy_1_rechts
 cmp #239
 beq joy_1_feuer
 cmp #238
 beq joy_1_feuer_hoch
 cmp #237
 beq joy_1_feuer_runter
 cmp #235
 beq joy_1_feuer_links
 cmp #231
 beq joy_1_feuer_rechts
jmp trackendeueberwachung
 joy_1_hoch
 jmp trackcursor_hoch 
 joy_1_runter
 jmp trackcursor_runter 
 joy_1_links
 jmp rahmenfarbe_plus
 joy_1_rechts
 jmp hintergrundfarbe_plus
 joy_1_feuer
  lda joy1feuer             ;die Nutzung der Variable joy1feuer ermoeglicht es, direkt von Feuer auf Feuer+Richtung zu gehen (wuerde die Tastenwiederholsperre sonst verhindern)
  bne joy_1_feuer_1
  sta taste  
  joy_1_feuer_1
  lda taste                 ;Wiederholsperre
  bne joy_1_feuer_skip
  lda #1                    ;Flag taste setzen 
  sta joy1feuer
  sta taste
  lda feuer1serie
  cmp #2
  bne nicht_dritte_mal_feuer
  ldx #0                    ;Initialisierung des Textfarbenwechsels
  jmp textfarbe_plus_start
  nicht_dritte_mal_feuer
  clc
  adc #1
  sta feuer1serie
 joy_1_feuer_skip
 jmp trackendeueberwachung  ;hier noch die Feuerbehandlung einfuegen
 joy_1_feuer_hoch
  lda joy1feuer             ;die Nutzung der Variable joy1feuer ermoeglicht es, direkt von Feuer auf Feuer+Richtung zu gehen (wuerde die Tastenwiederholsperre sonst verhindern)
  beq joy_1_feuer_hoch_1
  lda #0
  sta taste 
  sta joy1feuer
  joy_1_feuer_hoch_1
 jmp track_eine_zeile_nach_oben 
 joy_1_feuer_runter
  lda joy1feuer             ;die Nutzung der Variable joy1feuer ermoeglicht es, direkt von Feuer auf Feuer+Richtung zu gehen (wuerde die Tastenwiederholsperre sonst verhindern)
  beq joy_1_feuer_runter_1
  lda #0
  sta taste 
  sta joy1feuer
  joy_1_feuer_runter_1
 jmp track_eine_zeile_nach_unten
 joy_1_feuer_links
  lda joy1feuer             ;die Nutzung der Variable joy1feuer ermoeglicht es, direkt von Feuer auf Feuer+Richtung zu gehen (wuerde die Tastenwiederholsperre sonst verhindern)
  beq joy_1_feuer_links_1
  lda #0
  sta taste 
  sta joy1feuer
  joy_1_feuer_links_1
 jmp discomodus_rahmen 
 joy_1_feuer_rechts
  lda joy1feuer             ;die Nutzung der Variable joy1feuer ermoeglicht es, direkt von Feuer auf Feuer+Richtung zu gehen (wuerde die Tastenwiederholsperre sonst verhindern)
  beq joy_1_feuer_rechts_1
  lda #0
  sta taste 
  sta joy1feuer
  joy_1_feuer_rechts_1
 jmp discomodus_hintergrund

 
track_1
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_1_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen  
  lda #0                
  jmp trackwechsel 
  taste_1_noch_gedrueckt 
  jmp trackendeueberwachung

track_2
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_2_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen  
  lda #1                
  jmp trackwechsel 
  taste_2_noch_gedrueckt 
  jmp trackendeueberwachung

track_3
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_3_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen  
  lda #2                
  jmp trackwechsel 
  taste_3_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_4
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_4_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #3                
  jmp trackwechsel 
  taste_4_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_5  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_5_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen 
  lda #4                
  jmp trackwechsel 
  taste_5_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_6  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_6_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen 
  lda #5                
  jmp trackwechsel 
  taste_6_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_7  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_7_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #6                
  jmp trackwechsel 
  taste_7_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_8  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_8_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #7                
  jmp trackwechsel 
  taste_8_noch_gedrueckt 
  jmp trackendeueberwachung

track_9  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_9_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen               
  lda #8                
  jmp trackwechsel
  taste_9_noch_gedrueckt 
  jmp trackendeueberwachung
 
track_10  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_0_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #9                
  jmp trackwechsel 
  taste_0_noch_gedrueckt 
  jmp trackendeueberwachung

track_11
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_A_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #10                
  jmp trackwechsel 
  taste_A_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_12
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_B_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #11                
  jmp trackwechsel 
  taste_B_noch_gedrueckt 
  jmp trackendeueberwachung

track_13  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_C_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen   
  lda #12                
  jmp trackwechsel 
  taste_C_noch_gedrueckt 
  jmp trackendeueberwachung
  
track_14  
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_D_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen 
  lda #13                
  jmp trackwechsel 
  taste_D_noch_gedrueckt 
  jmp trackendeueberwachung
  
  
trackwechsel_vor_zurueck  
  trackwechsel_joystick
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne cursortaste_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen
  ldx track_wahl
  lda shift
  bne trackwechsel_zurueck
  inx
  cpx maxtrack
  bne track_plus1
  ldx #0                    ;wenn x = maxtrack, dann x = 0 (gehe zum ersten Track)
  track_plus1
  txa
  jmp trackwechsel
  trackwechsel_zurueck 
  dex
  cpx #$FF                  ;ist der Player bei Track 1, springt er jetzt auf den letzten Track
  bne skip3
  ldx maxtrack         
  dex
  skip3
  txa
  jmp trackwechsel
  cursortaste_noch_gedrueckt
  jmp trackendeueberwachung


wiedergabe_pause 
   pause_joystick
   lda taste                 ;wenn Taste noch gedrueckt, wird eine erneute Ausfuehrung des Pausebefehls verhindert
   bne pause_taste_noch_gedrueckt
   lda #1
   sta taste                 ;Flag taste setzen
   lda pause
   bne play
   lda #1
   sta pause
   lda #%00000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;deaktivieren
   lda #0
   sta UA+$00                ;Ultimate Audio stoppen (wirkungslos, wenn kein UA aktiv)
   sta UA+$20
   jmp tracknranzeige 
   play
   ldx track
   lda #0
   sta pause
    lda track_sidtyp,x
    cmp #7
    beq restart_ua_jmp
   lda #%10000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;aktivieren
   pause_taste_noch_gedrueckt
   jmp tracknranzeige
   restart_ua_jmp
   jmp restart_ua
   
zurueckspulen  
  zurueckspulen_cursortaste
  zurueckspulen_joystick
  ldx track                  ;berechnen, ob noch genug Reserve bis zum Trackende ist, um vorwaerts zu spulen
  lda REU_Bank1
  sta temp2   
  lda REU_Hi
  sta temp 
  bne sub4                   ;wenn REU_Hi 0 ist, lade REU_Bank1 nochmal, denn es koennte zwischenzeitlich eine Erhoehung um 1 passiert sein
  lda REU_Bank1
  sta temp2
  sub4
  sec
  lda temp
  sbc trackstart_m,x
  sta temp3
  lda temp2
  sbc trackstart_h,x 
  ;pruefe, ob Ergebnis der Subtraktion $0009 oder kleiner ist
  bne spule_zurueck         ;ungleich Null = Spulen
  lda temp3
  cmp ua_spulen_f1,x        ;carry, wenn y <= Zielreserve - 1
  bcs spule_zurueck         ;Spulen, wenn noch genug Abstand zum Trackende ist
  lda track_wahl
  jmp trackwechsel          ;sonst mit Track von vorn beginnen
  
  spule_zurueck
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren
  sec
  lda REU_Hi
  sbc ua_spulen_f2,x
  sta REU_Hi
  lda REU_Bank1
  sbc #0
  sta REU_Bank1
  sta REU_Bank
  lda pause
  bne zurueck_pause
   lda track_sidtyp,x
   cmp #7
   beq restart_ua
  lda #%10000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;aktivieren
  zurueck_pause
  jmp trackendeueberwachung

vorspulen  
   vorspulen_cursortaste
   vorspulen_joystick
   ldx track                ;berechnen, ob noch genug Reserve bis zum Trackende ist, um vorwaerts zu spulen
   lda REU_Bank1
   sta temp2
   lda REU_Hi
   sta temp 
   bne sub3                 ;wenn REU_Hi 0 ist, lade REU_Bank1 nochmal, denn es koennte zwischenzeitlich eine Erhoehung um 1 passiert sein
   lda REU_Bank1
   sta temp2
   sub3
   sec
   lda trackende_m,x
   sbc temp
   sta temp3
   lda trackende_h,x 
   sbc temp2
   ;pruefe, ob Ergebnis der Subtraktion $0009 oder kleiner ist
   bne spule_vor             ;ungleich Null = Spulen
   lda temp3
   cmp ua_spulen_f1,x        ;carry, wenn y <= Zielreserve - 1
   bcs spule_vor             ;Spulen, wenn noch genug Abstand zum Trackende ist  
   jmp trackendeueberwachung ;sonst Spulen verweigern (zurueck zur Trackendeueberwachung)
   
   spule_vor
   lda #%00000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;deaktivieren
   clc
   lda REU_Hi
   adc ua_spulen_f2,x
   sta REU_Hi
   lda REU_Bank1
   adc #0
   sta REU_Bank1
   sta REU_Bank
   lda pause
   bne vor_pause              ;verhindert, dass der Player beim Spulen weiterspielt, wenn er auf Pause steht
    lda track_sidtyp,x
    cmp #7
    beq restart_ua
   lda #%10000001             ;IRQ fuer Timer-A 
   sta $dd0d                  ;aktivieren
   vor_pause
   jmp trackendeueberwachung  
   
restart_ua          ;bei jedem Spulen und Play nach Pause muss ultimate Audio neu eingerichtet werden
   lda #0
   sta UA+$00  ;Ultimate Audio stoppen
   sta UA+$20

   lda REU_Bank1   ;neue Startadresse = aktuelle REU-Position
   sta UA+$05
   sta UA+$25
   lda REU_Hi
   sta UA+$06
   sta UA+$26
   lda REU_Lo  ;Adresse auf 4 Byte - Raster abrunden, damit sich beim Fortsetzen von Stereo-/16 Bit-Tracks die Startadresse nicht aus dem "Raster verschiebt"
   and #%11111100
   sta REU_Lo
   sta UA+$07
   clc
   adc ua_versatz_st
   sta UA+$27
   
   sec             ;neue Abspiellänge (Trackende - REU-Position)
   lda trackende_l,x
   sbc REU_Lo
   sta UA+$0B
   sta UA+$2B
   lda trackende_m,x
   sbc REU_Hi
   sta UA+$0A
   sta UA+$2A
   lda trackende_h,x
   sbc REU_Bank1
   sta UA+$09
   sta UA+$29
   
   lda track_stereo,x
   bne vorspulen_ua_stereo
   lda track_bits,x
   cmp #16
   beq vorspulen_ua_16bit
   lda #%00000101   ;Ultimate Audio starten
   sta UA+$00    
   lda #%10000001             ;IRQ fuer Timer-A 
   sta $dd0d                  ;aktivieren
   jmp trackendeueberwachung  
   vorspulen_ua_16bit
   lda #%00010101   ;Ultimate Audio starten
   sta UA+$00    
   lda #%10000001             ;IRQ fuer Timer-A 
   sta $dd0d                  ;aktivieren
   jmp trackendeueberwachung  
 

   vorspulen_ua_stereo
    lda track_bits,x
    cmp #16
    beq vorspulen_ua_stereo_16bit
    lda #%01000101   ;Ultimate Audio starten
    sta UA+$00  
    sta UA+$20  
    lda #%10000001             ;IRQ fuer Timer-A 
    sta $dd0d                  ;aktivieren
    jmp trackendeueberwachung  
   vorspulen_ua_stereo_16bit 
    lda #%01010101   ;Ultimate Audio starten
    sta UA+$00  
    sta UA+$20  
    lda #%10000001             ;IRQ fuer Timer-A 
    sta $dd0d                  ;aktivieren
    jmp trackendeueberwachung  
 
   
trackcursor_hoch
  lda taste              ;wenn bereits eine Taste gedrueckt ist, mache keine Trackcursorbewegung (Wiederholsperre)
  bne taste_at_noch_gedrueckt 
  lda #1
  sta taste              ;Flag taste setzen  
  dec cursor_pos
  lda cursor_pos
  cmp #$FF               ;wenn -1 dann auf letzten Track setzten
  bne cursor_pos_ok_1
  ldx maxtrack
  dex
  stx cursor_pos
  cursor_pos_ok_1
  jsr trackcursor_ein
  taste_at_noch_gedrueckt
  jmp trackendeueberwachung
  
trackcursor_runter  
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keine Trackcursorbewegung (Wiederholsperre)
  bne taste_Semikolon_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen  
  inc cursor_pos
  lda cursor_pos
  cmp maxtrack               ;wenn maxtrack erreicht, dann zurueck auf Track 0
  bne cursor_pos_ok_2
  ldx #0
  stx cursor_pos
  cursor_pos_ok_2
  jsr trackcursor_ein
  taste_Semikolon_noch_gedrueckt
  jmp trackendeueberwachung 

track_eine_zeile_nach_oben  
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keine Trackverschiebung (Wiederholsperre)
  bne taste_Stern_unwirksam 
  lda #1
  sta taste                  ;Flag taste setzen  
  ldx cursor_pos
  cpx #0
  beq taste_Stern_unwirksam  ;wenn der Trackcursor schon ganz oben ist, kann man nichts mehr hochschieben
  jsr track_eine_zeile_hoch
  jsr trackcursor_ein
  taste_Stern_unwirksam
  jmp trackendeueberwachung

track_eine_zeile_nach_unten
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keine Trackverschiebung (Wiederholsperre)
  bne taste_Gleichheitszeichen_unwirksam 
  lda #1
  sta taste                  ;Flag taste setzen  
  ldx cursor_pos
  inx
  cpx maxtrack
  beq taste_Gleichheitszeichen_unwirksam  ;wenn der Trackcursor schon ganz unten ist, kann man nichts mehr herunterschieben
  jsr track_eine_zeile_runter
  jsr trackcursor_ein
  taste_Gleichheitszeichen_unwirksam
  jmp trackendeueberwachung

  
infoleiste_ein_aus 
lda tracknr_e+2
   lda taste                 ;wenn Taste noch gedrueckt, wird eine erneute Ausfuehrung des Befehls verhindert
   bne I_abbruch
   lda #1
   sta taste                 ;Flag taste setzen
   lda infobar 
   beq I_infobar_ein
    jsr infoleiste_aus       ;wenn Infoleiste an war: schalte sie aus 
    jmp trackendeueberwachung
   I_infobar_ein
    lda maxtrack             ;wenn Infoleiste aus war: pruefe, ob Einschalten erlaubt ist 
    cmp #13
    bcs I_abbruch            ;wenn mehr als 12 Tracks vorhanden: Einschalten der Infoleiste verweigern
    jsr infoleiste_ein       
  I_abbruch
    jmp trackendeueberwachung

geschwindigkeit_infoleiste_verringern  
   lda taste                 ;wenn Taste noch gedrueckt, wird eine erneute Ausfuehrung des Befehls verhindert
   bne minus_taste_noch_gedrueckt
   lda #1
   sta taste
   lda infospeed
   cmp #$40
   beq infospeed_schon_40
    inc infospeed
    lda infospeed
    sta $dc06                ;neue Geschwindigkeit setzen 
   infospeed_schon_40
   minus_taste_noch_gedrueckt
   jmp trackendeueberwachung   
 
geschwindigkeit_infoleiste_erhoehen  
   lda infospeed
   beq infospeed_schon_0
   lda taste                 ;wenn Taste noch gedrueckt, wird eine erneute Ausfuehrung des Befehls verhindert
   bne plus_taste_noch_gedrueckt
   lda #1
   sta taste
    dec infospeed
    lda infospeed
    sta $dc06                ;neue Geschwindigkeit setzen 
   infospeed_schon_0
   plus_taste_noch_gedrueckt
   jmp trackendeueberwachung 

   
formatanzeige  
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, ueberspringe (Wiederholsperre)
  bne taste_F_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen   
  clc
  lda statusanzeige
  adc #1
  sta statusanzeige
  cmp #1
  beq statusanz_an
  cmp #2
  beq statusanz_an
  lda #0
  sta statusanzeige
  jsr statusanzeige_aus
  jmp taste_F_ende
  statusanz_an
  jsr statusanzeigen
  taste_F_noch_gedrueckt 
  taste_F_ende
  jmp trackendeueberwachung
  
  
rahmenfarbe_aendern
  lda shift
  bne rahmenfarbe_minus
  rahmenfarbe_plus
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F1_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  inc $D020
  jmp trackendeueberwachung
  rahmenfarbe_minus
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F1_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  dec $D020
  F1_taste_noch_gedrueckt
  jmp trackendeueberwachung
  
hintergrundfarbe_aendern  
  lda shift
  bne hintergrundfarbe_minus
  hintergrundfarbe_plus
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F3_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  lda hintergfarbe
  clc
  adc #1
  and #$0F
  sta hintergfarbe
  cmp textfarbe              ;verhindern, dass Textfarbe = Hintergrundfarbe den Player verschwinden laesst
  beq hintergrundfarbe_plus
  sta $D021
  jmp trackendeueberwachung
  hintergrundfarbe_minus
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F3_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  lda hintergfarbe
  sec
  sbc #1
  and #$0F
  sta hintergfarbe
  cmp textfarbe              ;verhindern, dass Textfarbe = Hintergrundfarbe den Player verschwinden laesst
  beq hintergrundfarbe_minus
  sta $D021  
  F3_taste_noch_gedrueckt
  jmp trackendeueberwachung

textfarbe_aendern
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F5_taste_noch_gedrueckt
  ldx #0 
  lda shift
  bne textfarbe_minus_start
  textfarbe_plus_start
  lda textfarbe
  clc
  adc #1
  and #$0F
  sta textfarbe
  cmp hintergfarbe           ;verhindern, dass Textfarbe = Hintergrundfarbe den Player verschwinden laesst
  beq textfarbe_plus_start
  textfarbe_plus
  sta $D800,x 
  sta $D900,x 
  sta $DA00,x 
  sta $DB00,x 
  inx
  bne textfarbe_plus
  lda #1
  sta taste                  ;Flag taste setzen
  jmp trackendeueberwachung
  textfarbe_minus_start
  lda textfarbe
  sec
  sbc #1
  and #$0F
  sta textfarbe
  cmp hintergfarbe           ;verhindern, dass Textfarbe = Hintergrundfarbe den Player verschwinden laesst
  beq textfarbe_minus_start
  textfarbe_minus
  sta $D800,x 
  sta $D900,x 
  sta $DA00,x 
  sta $DB00,x 
  inx
  bne textfarbe_minus
  lda #1
  sta taste                  ;Flag taste setzen
  F5_taste_noch_gedrueckt
  jmp trackendeueberwachung
  
discomodus_an_aus
  lda shift
  bne discomodus_hintergrund
  discomodus_rahmen
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F7_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  lda disco_rahmen
  eor #%00000001
  sta disco_rahmen
  jmp trackendeueberwachung
  discomodus_hintergrund
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne F7_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  lda disco_hinterg
  eor #%00000001
  sta disco_hinterg
  F7_taste_noch_gedrueckt 
  jmp trackendeueberwachung
  
sound_einstellung  
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  beq taste_S_wirksam 
  jmp taste_S_unwirksam
  taste_S_wirksam 
  lda #1
  sta taste                  ;Flag taste setzen
  ldx track
  lda track_sidtyp,x
  cmp #4
  bne sound_einstellung_pruefe_ua_fpga
  lda #%00000001             ;IRQ fuer Timer-A 
  sta $dd0d                  ;deaktivieren (Player stoppen, um "Datensalat" zu vermeiden)  
  lda digimax_adr_h
  cmp #$DD
  bne sid_einstellung_digimax_DD
  lda #$DE                   ;DigiMax umschalten auf Cartridge
  sta digimax_adr_h
  sta REU_C64Hi
  lda #$00
  sta digimax_adr_l
  sta REU_C64Lo
  jmp sound_einstellung_digimax_fertig
  sid_einstellung_digimax_DD
  lda #$DD                   ;DigiMax umschalten auf Userport
  sta digimax_adr_h
  sta REU_C64Hi
  lda #$01
  sta digimax_adr_l
  sta REU_C64Lo
  sound_einstellung_digimax_fertig
  lda #%10000001             ;IRQ fuer Timer-A 
  sta $dd0d                  ;aktivieren
  jmp trackendeueberwachung  
  
  sound_einstellung_ua_fpga_ende ;dieser Teil ist noetig wegen der begrenzten Sprungweite fuer die kommenden bne/beq 
  jmp trackendeueberwachung
  sound_einstellung_keine_ua_fpga_umstellung_jmp
  jmp sound_einstellung_keine_ua_fpga_umstellung
  
  sound_einstellung_pruefe_ua_fpga
  lda ua_hq
  bne sound_einstellung_ua_fpga_ende
  lda track_sidtyp,x
  cmp #3
  beq sound_einstellung_ua_fpga
  cmp #7
  bne sound_einstellung_keine_ua_fpga_umstellung_jmp
  sound_einstellung_ua_fpga
  lda ua_vorh
  beq sound_einstellung_ua_fpga_ende
  lda fpgasid_vorh
  beq sound_einstellung_ua_fpga_ende
  lda track_sidtyp,x
  cmp #3
  bne sound_einstellung_ua_zu_fpga
   ;Initialisierung fpga_zu_ua
  ldx #0
  stx temp4                 ;in temp4 speichern, ob der gerade abgespielte Track umgeschaltet wird (ungleich Null, wenn ja)
  sound_einstellung_fpga_zu_ua
   lda track_sidtyp,x
   cmp #3
   bne sound_einstellung_fpga_zu_ua_skip
   lda #7
   sta track_sidtyp,x
   cpx track
   bne sound_einstellung_fpga_zu_ua_skip
   sta temp4
   sound_einstellung_fpga_zu_ua_skip
   inx
   cpx maxtrack
   bne sound_einstellung_fpga_zu_ua
  jsr statusanzeigen
  lda #1
  sta ua_reparse
  jsr metadaten_neu_parsen
  lda temp4
  beq sound_einstellung_fpga_zu_ua_kein_playerwechsel
   lda #%00000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;deaktivieren (Player anhalten)
   ldx track
   lda track_player_l,x      ;Adresse des NMI aktualisieren
   sta $FFFA
   lda track_player_h,x
   sta $FFFB
   lda ua_track_mult,x 
   sta ua_multi
   lda track_stereo,x
   bne sound_einstellung_start_ua_stereo
   jsr player_samplerate_wechseln
   jsr init_ultimate_audio_mono 
    jmp restart_ua
    sound_einstellung_start_ua_stereo
    jsr player_samplerate_wechseln
    jsr init_ultimate_audio_stereo 
    jmp restart_ua
    sound_einstellung_fpga_zu_ua_kein_playerwechsel
    jmp trackendeueberwachung     
    
  sound_einstellung_ua_zu_fpga
  ldx #0
  stx temp4                  ;in temp4 speichern, ob der gerade abgespielte Track umgeschaltet wird (ungleich Null, wenn ja)
  sound_einstellung_ua_zu_fpga_1
   lda track_sidtyp,x
   cmp #7
   bne sound_einstellung_ua_zu_fpga_1_skip
   lda track_tvnorm,x
   cmp tvnorm_c64             ;nicht von UA auf FPGASID umschalten, wenn TV-Norm nicht passt
   bne sound_einstellung_ua_zu_fpga_1_skip
   lda #3
   sta track_sidtyp,x
   cpx track
   bne sound_einstellung_ua_zu_fpga_1_skip
   sta temp4 
   sound_einstellung_ua_zu_fpga_1_skip
   inx
   cpx maxtrack
   bne sound_einstellung_ua_zu_fpga_1
  jsr statusanzeigen
  lda #1
  sta ua_reparse
  jsr metadaten_neu_parsen
  lda temp4
  beq sound_einstellung_ua_zu_fpga_kein_playerwechsel
   lda #%00000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;deaktivieren
   lda #0
   sta UA+$00                ;Ultimate Audio stoppen
   sta UA+$20
   ldx track
   lda track_player_l,x      ;Adresse des NMI aktualisieren
   sta $FFFA
   lda track_player_h,x
   sta $FFFB
   lda track_stereo,x
   bne sound_einstellung_start_fpga_stereo
   jsr init_fpgasid_mono 
   jsr player_samplerate_wechseln
   lda #%10000001            ;IRQ fuer Timer-A 
   sta $dd0d                 ;aktivieren (Player starten)
   jmp trackendeueberwachung 
    sound_einstellung_start_fpga_stereo
    jsr init_fpgasid_stereo 
    jsr player_samplerate_wechseln
    lda #%10000001            ;IRQ fuer Timer-A 
    sta $dd0d                 ;aktivieren (Player starten)
    sound_einstellung_ua_zu_fpga_kein_playerwechsel
    jmp trackendeueberwachung 
    
  sound_einstellung_keine_ua_fpga_umstellung
  ;Umstellung des emulierten SID-Typs beim FPGASID bei unbekanntem Format (V02)
  bne taste_S_unwirksam      ;Taste S soll nur bei unbekanntem SID in den Metadaten wirken
  lda track_format,x
  cmp #2
  beq taste_S_unwirksam      ;Taste S soll nicht bei 4bit-Tracks wirken
  lda sidmanuell
  eor #1
  sta sidmanuell
  beq sidmanuell_auf_6581
    lda #%00111111           ;FPGASID-Einstellung fuer 8580
    sta $D41F   
    jsr statusanzeigen 
    jmp trackendeueberwachung
  sidmanuell_auf_6581
    lda #%00000000           ;FPGASID-Einstellung fuer 6581
    sta $D41F   
    jsr statusanzeigen 
  taste_S_unwirksam
  jmp trackendeueberwachung 

  
steuerung_aendern  
  lda taste                  ;wenn bereits eine Taste gedrueckt ist, mache keinen Steuerungsmoduswechsel (Wiederholsperre)
  bne Schraegstrich_taste_noch_gedrueckt 
  lda #1
  sta taste                  ;Flag taste setzen
  sta steuerung
  Schraegstrich_taste_noch_gedrueckt 
  jmp trackendeueberwachung
  
player_stop
  lda taste
  bne taste_stop_noch_gedrueckt
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren (Player stoppen, um "Datensalat" zu vermeiden)  
  lda #0
  sta UA+$00                ;Ultimate Audio stoppen (wirkungslos, wenn kein UA aktiv)
  sta UA+$20
  sta $DD01                 ;CIA 2 Port B / Digimax in Grundstellung bringen (sicherheitshalber)  
  sta $DD03  
  sta tvnorm_falsch         ;Flag resetten, damit die Fehlermeldung erneut gezeigt wird, wenn sie bei der letzten reu-Datei schon kam
  jmp anzeige_player_stop
  taste_stop_noch_gedrueckt
  jmp trackendeueberwachung  
  
track_repeat
  lda taste                 ;wenn bereits eine Taste gedrueckt ist, mache keinen Trackwechsel (Wiederholsperre)
  bne taste_r_noch_gedrueckt 
  lda #1
  sta taste                 ;Flag taste setzen  
  lda trackrepeat
  eor #1
  sta trackrepeat
  jmp tracknranzeige
  ;jsr playpfeil
  taste_r_noch_gedrueckt  
  jmp trackendeueberwachung

REU_leeren
  lda fpgasid_vorh          ;Funktion nicht ausfuehren, wenn kein FPGASID vorhanden
  bne REU_leeren_fpgasid_vorh
  jmp trackendeueberwachung
  REU_leeren_fpgasid_vorh
  jsr anzeige_REU_loeschen   
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren (Player stoppen, um "Datensalat" zu vermeiden)  
  lda #0
  sta REU_Lo                
  sta REU_Hi
  sta REU_BytesLo           ;$0000 Bytes interpretiert die REU als $10000 Bytes, also komplette Bank
  sta REU_BytesHi
  lda #>leerbytes
  sta REU_C64Hi
  lda #<leerbytes
  sta REU_C64Lo
  ldx #0
  REU_loeschen_loop
   stx REU_Bank
   lda #%10000000           ;Adress Control Register der REU -> C64-Adresse nicht hochzaehlen
   sta REU_Adr_Ctrl
   lda #252
   sta REU_CMD
   inx
   cpx #0
   bne REU_loeschen_loop
   lda #0                   ;Adress Control Register der REU -> C64-Adresse wieder hochzaehlen
   sta REU_Adr_Ctrl
  
REU_formatieren
  lda fpgasid_vorh          ;Funktion nicht ausfuehren, wenn kein FPGASID vorhanden
  bne REU_formatieren_fpgasid_vorh
  jmp trackendeueberwachung
  REU_formatieren_fpgasid_vorh
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren (Player stoppen, um "Datensalat" zu vermeiden)  
  lda #0
  sta REU_Lo                ;REU Header
  sta REU_Hi
  sta REU_Bank
  sta REU_BytesHi
  sta temp
  lda #16
  sta REU_BytesLo
  lda #>text_REU_header_formatieren_1 
  sta REU_C64Hi
  lda #<text_REU_header_formatieren_1 
  sta REU_C64Lo
  lda #252
  sta REU_CMD
  
  lda #>text_reserved_entry  ;REU-Eintraege "reserved entry"
  sta REU_C64Hi
  lda #<text_reserved_entry
  sta REU_C64Lo
  ldx #0
  REU_formatieren_reserved_entry_loop
   lda temp
   clc
   adc #16
   sta temp
   sta REU_Lo
   lda #252
   sta REU_CMD
   inx
   cpx #14
   bne REU_formatieren_reserved_entry_loop
  
  lda #$F0                   ;REU-Eintrag "TRACKINFOS"
  sta REU_Lo
  lda #>text_REU_header_formatieren_2
  sta REU_C64Hi
  lda #<text_REU_header_formatieren_2
  sta REU_C64Lo
  lda #252
  sta REU_CMD

  lda #>leerbytes            ;Titelnamen loeschen
  sta REU_C64Hi
  lda #<leerbytes  
  sta REU_C64Lo
  lda #1
  sta REU_Hi
  ldx #0
  lda #240
  sta temp
  REU_formatieren_titelnamen_loeschen_loop_1
   lda temp
   clc
   adc #16
   sta temp
   sta REU_Lo
   lda #252
   sta REU_CMD
   inx
   cpx #16
   bne REU_formatieren_titelnamen_loeschen_loop_1
  ldx #0
  lda #2
  sta REU_Hi
  REU_formatieren_titelnamen_loeschen_loop_2
   lda temp
   clc
   adc #16
   sta temp
   sta REU_Lo
   lda #252
   sta REU_CMD
   inx
   cpx #12
   bne REU_formatieren_titelnamen_loeschen_loop_2
  lda #0
  sta tvnorm_falsch 
  jmp player_anzeigen 
   
fpgasid_recorder
  lda tvnorm_falsch
  bne rec_verweigern
  lda fpgasid_vorh          ;Funktion nicht ausfuehren, wenn kein FPGASID vorhanden
  bne fpgasid_recorder_fpgasid_vorh
  rec_verweigern
  jmp trackendeueberwachung
  fpgasid_recorder_fpgasid_vorh
  
  jsr trackcursor_aus
!source "Breadampv05_fpgasid_recorder.asm"



 
 
 
 
 
 
 
 
 
 
 
 
 
 