;Breadampv05_Unterroutinen_und_Daten.asm
;---------------------------------------
;
;This file is required to be able to compile the main file "BREADAMPv05.asm". It cannot be compiled on its own.
;
;Diese Datei ist nötig, um die Hauptdatei "BREADAMPv05.asm" kompilieren zu können. Sie kann nicht eigenständig kompiliert werden.


; ------------- Unterprogramme außerhalb des Hauptprogramms ---------------

*=$4400    ;Ueberspringen des Speicherbereichs, in dem Charset und Screen liegen
   
;24Bit-Division - Code von Verz aus Codebase64, angepasst, Ergebnis im dividend und divrest  
div24
lda #0          ;preset remainder to 0
sta divrest
sta divrest+1
sta divrest+2
ldx #24         ;repeat for each bit: ...
divloop
asl dividend  ;dividend lb & hb*2, msb -> Carry
rol dividend+1  
rol dividend+2
rol divrest ;remainder lb & hb * 2 + msb from carry
rol divrest+1
rol divrest+2
lda divrest
sec
sbc divisor ;substract divisor to see if it fits in
sta temp    ;lb result -> temp, for we may need it later
lda divrest+1
sbc divisor+1
sta pztemp
lda divrest+2
sbc divisor+2
bcc skip  ;if carry=0 then divisor didn't fit in yet

sta divrest+2 ;else save substraction result as new remainder,
lda pztemp
sta divrest+1
lda temp
sta divrest 
inc dividend  ;and INCrement result cause divisor fit in 1 times
   
skip  dex
bne divloop
rts

;16Bit Division aus der Codebase64, angepasst, Ergebnis in dividend
div16
  lda #0          ;preset remainder to 0
  sta divrest
  sta divrest+1
  ldx #16         ;repeat for each bit: ...
divloop2 
  asl dividend  ;dividend lb & hb*2, msb -> Carry
  rol dividend+1  
  rol divrest ;remainder lb & hb * 2 + msb from carry
  rol divrest+1
  lda divrest
  sec
  sbc divisor ;substract divisor to see if it fits in
  sta temp4     ;lb result -> temp4, for we may need it later
  lda divrest+1
  sbc divisor+1
  bcc skip2  ;if carry=0 then divisor didn't fit in yet

  sta divrest+1 ;else save substraction result as new remainder,
  lda temp4
  sta divrest 
  inc dividend  ;and INCrement result cause divisor fit in 1 times

skip2  dex
  bne divloop2 
  rts
  
;Hexwert in Screencodes wandeln Y=Hunderter, X=Zehner, A=Einer, Code aus Codebase64
hex2scr
  clc 
  ldy #$2f
  ldx #$3a
  sec
- iny
  sbc #100
  bcs -
- dex
  adc #10
  bmi -
  adc #$2f
 rts
 
;Infoleiste einschalten
infoleiste_ein
 lda #1
 sta infobar
 lda #107        ;T-Strich links 
 sta posinfoleiste-41
 lda #115        ;T-Strich rechts
 sta posinfoleiste-2
 lda #64         ;waagerechter Strich
 ldx #38
 info_ein
 dex
 sta posinfoleiste-40,x
 bne info_ein
 rts
 
;Infoleiste ausschalten  
infoleiste_aus
 lda #0
 sta infobar
 lda #93         ;senkrechter Strich 
 sta posinfoleiste-41
 sta posinfoleiste-2
 lda #32         ;Leerzeichen
 ldx #38
 info_aus
 dex
 sta posinfoleiste-40,x
 sta posinfoleiste,x
 bne info_aus
 rts
 
;Statusanzeige ausschalten
statusanzeige_aus
 lda #32
 sta posstatusanzeige
 sta posstatusanzeige+1
 sta posstatusanzeige+40
 sta posstatusanzeige+41
 sta posstatusanzeige+80
 sta posstatusanzeige+81
 rts

;Trackcursor ein-/umschalten
trackcursor_ein
 lda #10
 sta cursor_zeit
 ldx #0
 stx temp              ;temp wird hier als Zaehler fuer die Schleife loop_trackcursor genutzt
 lda #>postrackcursor
  sta adr1_h
  lda #<postrackcursor
  sta adr1_l
  loop_trackcursor
  lda temp 
  cmp cursor_pos
  beq zeige_trackcursor
  lda #93              ;normaler Rahmen, wenn Tracklistzeile ungleich Trackcursorposition
  sta (adr1_l,x)
  jmp trackcursorzeigen_fertig
  zeige_trackcursor
   lda #196            ;Trackcursor
   sta (adr1_l,x)
  trackcursorzeigen_fertig
  inc temp
  lda temp
  cmp maxtrack
  beq ende_trackcursor
   ;neue Bildschirmspeicheradresse berechnen    
   lda adr1_l
   clc
   adc #40  ;+1 Zeile
   sta adr1_l
   bcc kein_Uebertrag_4
   inc adr1_h
   kein_Uebertrag_4
  jmp loop_trackcursor
  ende_trackcursor
 rts
 
;Trackcursor ausschalten (stupider Code, ist aber meist kuerzer und schneller als Pruefschleifen)
trackcursor_aus
 ldx cursor_pos                 ;Bildschirmadresse ermitteln
 lda lookup_posplaylist_l,x
 sec
 sbc #1
 sta trackcursor_aus_inject+1
 lda lookup_posplaylist_h,x
 sta trackcursor_aus_inject+2
 lda #93       ;normaler Rahmen
 trackcursor_aus_inject sta $0000 
 rts 

;Track an Trackcursorposition 1 Zeile nach oben oder unten schieben
track_eine_zeile_hoch
 ldx cursor_pos     ;Quellposition (untere Zeile)
 stx temp2          ;Zielposition (obere Zeile)
 dec temp2
 jmp track_eine_zeile_verschieben
track_eine_zeile_runter
 ldx cursor_pos     ;Quellposition (obere Zeile)
 stx temp2          ;Zielposition (untere Zeile)
 inc temp2
track_eine_zeile_verschieben
 lda temp2
 sta cursor_pos
 ;Bildschirmspeicheradressen einfuegen
 lda lookup_posplaylist_h,x
 sta tezh1+2
 sta tezh3+2
 lda lookup_posplaylist_l,x
 sta tezh1+1
 sta tezh3+1
 stx temp           ;Backup x
 ldx temp2
 lda lookup_posplaylist_h,x
 sta tezh2+2
 sta tezh4+2
 lda lookup_posplaylist_l,x
 sta tezh2+1
 sta tezh4+1
 ldx temp           ;x wiederherstellen
 ;Alternativplaylist anpassen 
 lda altern_playlist,x
 sta temp3
 ldx temp2
 lda altern_playlist,x
 ldx temp
 sta altern_playlist,x
 lda temp3
 ldx temp2
 sta altern_playlist,x
 ldx temp
 ;wenn aktuell gespielter Track verschoben wird Tracknummer korrigieren
 stx temp 
 lda track_wahl       ;wenn Track = Quelle, dann Track = Ziel
 cmp temp
 bne tracktausch_1
 lda temp2
 sta track_wahl
 jmp tracktausch_bildschirmspeicher
 tracktausch_1
 cmp temp2            ;wenn Track = Ziel, dann Track = Quelle
 bne tracktausch_bildschirmspeicher
 stx track_wahl
 ;Bildschirmspeicher bearbeiten
 tracktausch_bildschirmspeicher
 ldx #0
 loop_track_eine_zeile_hoch
 tezh1 lda $0000,x    ;$0000 ist Platzhalter, wird von obiger Routine befuellt
 sta temp4            ;Daten untere Zeile in temp4
 tezh2 lda $0000,x    ;Daten obere Zeile in a
 tezh3 sta $0000,x    ;Daten aus a in untere Zeile
 lda temp4
 tezh4 sta $0000,x    ;Daten aus temp4 in obere Zeile
 inx
 cpx #38
 bne loop_track_eine_zeile_hoch
 ;naechst_track korrigieren
 ldx track_wahl
 inx                   ;+1, da maxtrack 1 hoeher ist als der hoechste logische Track
 cpx maxtrack
 bne naechst_track_korr
 ldx #0
 naechst_track_korr
 stx naechst_track  
 rts

;Tracknummeranzeige auf dem 7-Segment-Display
  tracknranzeige_sub
  ldx track

  ;Zehnerstelle
  lda tracknr_z,x
  tax
  lda lookup_7seg_ol,x
  sta postrackanzeige
  lda lookup_7seg_or,x
  sta postrackanzeige+1
  lda lookup_7seg_ml,x
  sta postrackanzeige+40
  lda lookup_7seg_mr,x
  sta postrackanzeige+41
  lda lookup_7seg_ul,x
  sta postrackanzeige+80
  lda lookup_7seg_ur,x
  sta postrackanzeige+81
  
  ;Einerstelle
  ldx track
  lda tracknr_e,x 
  tax
  lda lookup_7seg_ol,x
  sta postrackanzeige+2
  lda lookup_7seg_or,x
  sta postrackanzeige+3
  lda lookup_7seg_ml,x
  sta postrackanzeige+42
  lda lookup_7seg_mr,x
  sta postrackanzeige+43
  lda lookup_7seg_ul,x
  sta postrackanzeige+82
  lda lookup_7seg_ur,x
  sta postrackanzeige+83 
  rts
 
;Spielzeit auf dem 7-Segment-Display    
spielzeit_sub1
  lda track_sr_h,x
  sta divisor+2
  lda track_sr_m,x          ;Samplerate in den Divisor
  sta divisor+1
  lda track_sr_l,x 
  sta divisor
  jsr div24                 ;Ergebnis ist die abgelaufene Zeit in Sekunden
  
   ;Minuten und Sekunden durch Division durch 60 berechnen (die Sekunden stehen noch im Dividend)
   lda #60       
   sta divisor
   lda #0
   sta divisor+1
   jsr div16

   ldx dividend     ;Minuten im Dividend (=Ergebnis)
   lda lookup_hex2bcd,x ;10er
   lsr
   lsr
   lsr
   lsr
   tax
   lda lookup_7seg_ol,x
   sta postrackanzeige+6
   lda lookup_7seg_or,x
   sta postrackanzeige+7
   lda lookup_7seg_ml,x
   sta postrackanzeige+46
   lda lookup_7seg_mr,x
   sta postrackanzeige+47
   lda lookup_7seg_ul,x
   sta postrackanzeige+86
   lda lookup_7seg_ur,x
   sta postrackanzeige+87
    
   ldx dividend
   lda lookup_hex2bcd,x ;1er
   and #%00001111
   tax
   lda lookup_7seg_ol,x
   sta postrackanzeige+8
   lda lookup_7seg_or,x
   sta postrackanzeige+9
   lda lookup_7seg_ml,x
   sta postrackanzeige+48
   lda lookup_7seg_mr,x
   sta postrackanzeige+49
   lda lookup_7seg_ul,x
   sta postrackanzeige+88
   lda lookup_7seg_ur,x
   sta postrackanzeige+89
   
   ldx divrest      ;Sekunden im Rest
   rts
   
spielzeit_sub2
   lda lookup_hex2bcd,x ;10er
   lsr
   lsr
   lsr
   lsr
   tax
   lda lookup_7seg_ol,x
   sta postrackanzeige+11
   lda lookup_7seg_or,x
   sta postrackanzeige+12
   lda lookup_7seg_ml,x
   sta postrackanzeige+51
   lda lookup_7seg_mr,x
   sta postrackanzeige+52
   lda lookup_7seg_ul,x
   sta postrackanzeige+91
   lda lookup_7seg_ur,x
   sta postrackanzeige+92
    
   ldx divrest
   lda lookup_hex2bcd,x ;1er
   and #%00001111
   tax
   lda lookup_7seg_ol,x
   sta postrackanzeige+13
   lda lookup_7seg_or,x
   sta postrackanzeige+14
   lda lookup_7seg_ml,x
   sta postrackanzeige+53
   lda lookup_7seg_mr,x
   sta postrackanzeige+54
   lda lookup_7seg_ul,x
   sta postrackanzeige+93
   lda lookup_7seg_ur,x
   sta postrackanzeige+94  
rts

;Playpfeil
  playpfeil
  ldx #0
  stx temp             ;temp dient hier als Zaehlvariable fuer die Zeile, in der gerade die Anzeige des Playpfeils geprueft wird
  lda #>posplaypfeil      
  sta adr1_h
  lda #<posplaypfeil
  sta adr1_l
  
  loop_pfeil
  lda temp
  cmp track_wahl 
  beq zeige_pfeil
  lda #32              ;Leerzeichen, wenn Tracklistzeile ungleich aktuelle Tracknummer
  sta (adr1_l,x)
  jmp zeigen_fertig
  zeige_pfeil
   lda pause
   bne zeige_pause
   lda trackrepeat
   bne zeige_repeat
   lda #241               ;Pfeil (Play)
   sta (adr1_l,x)
   jmp zeigen_fertig
    zeige_repeat
     lda #126             ;Repeat
     sta (adr1_l,x)
     jmp zeigen_fertig
    zeige_pause
     lda #240             ;Pause
     sta (adr1_l,x)
  zeigen_fertig
  inc temp
  lda temp
  cmp maxtrack
  beq ende_pfeil
   ;neue Bildschirmspeicheradresse berechnen    
   lda adr1_l
   clc
   adc #40  ;+1 Zeile
   sta adr1_l
   bcc kein_Uebertrag_3
   inc adr1_h
   kein_Uebertrag_3
  jmp loop_pfeil
  ende_pfeil
  rts
 
;Fehlerbehandlung 

Fehler_kein_breadamp_file
 jsr error_anzeige
 ldx #$00
 loop_f1 
  lda text_Fehler_kein_breadamp_file_1,x
  sta posfehlermeldung,x
  lda text_Fehler_kein_breadamp_file_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_kein_breadamp_file_3,x
  sta posfehlermeldung+120,x
  lda text_Fehler_kein_breadamp_file_4,x
  sta posfehlermeldung+160,x
  lda text_Fehler_kein_breadamp_file_5,x
  sta posfehlermeldung+200,x
  lda text_Fehler_kein_breadamp_file_6,x
  sta posfehlermeldung+320,x
  lda text_Fehler_kein_breadamp_file_7,x
  sta posfehlermeldung+360,x
  lda text_Fehler_kein_breadamp_file_8,x
  sta posfehlermeldung+440,x
  lda text_Fehler_kein_breadamp_file_9,x
  sta posfehlermeldung+480,x
  lda text_Fehler_kein_breadamp_file_0,x
  sta posfehlermeldung+520,x
  inx
  cpx #38
 bne loop_f1
 jsr warte_auf_taste
 jmp player_anzeigen 

Fehler_falsche_Version
 jsr error_anzeige
 ldx #$00
 loop_f2 
  lda text_Fehler_falsche_version_1,x
  sta posfehlermeldung,x
  lda text_Fehler_falsche_version_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_falsche_version_3,x
  sta posfehlermeldung+120,x
  lda text_Fehler_falsche_version_4,x
  sta posfehlermeldung+160,x
  lda text_Fehler_falsche_version_5,x
  sta posfehlermeldung+320,x
  lda text_Fehler_falsche_version_6,x
  sta posfehlermeldung+360,x
  lda text_Fehler_falsche_version_7,x
  sta posfehlermeldung+440,x
  lda text_Fehler_falsche_version_8,x
  sta posfehlermeldung+480,x
  inx
  cpx #38
 bne loop_f2
 jsr warte_auf_taste
 jmp player_anzeigen 

Fehler_in_der_Datei
 jsr error_anzeige
 ldx #$00
 loop_f3 
  lda text_Fehler_in_der_datei_1,x
  sta posfehlermeldung,x
  lda text_Fehler_in_der_datei_2,x
  sta posfehlermeldung+80,x
  lda text_Fehler_in_der_datei_3,x
  sta posfehlermeldung+120,x
  lda text_Fehler_in_der_datei_4,x
  sta posfehlermeldung+240,x
  lda text_Fehler_in_der_datei_5,x
  sta posfehlermeldung+320,x
  lda text_Fehler_in_der_datei_6,x
  sta posfehlermeldung+360,x
  lda leerzeile,x
  sta posfehlermeldung+40,x
  sta posfehlermeldung+160,x
  sta posfehlermeldung+200,x
  sta posfehlermeldung+280,x
  sta posfehlermeldung+400,x
  sta posfehlermeldung+440,x
  sta posfehlermeldung+480,x
  sta posfehlermeldung+520,x
  inx
  cpx #38
 bne loop_f3
 jsr warte_auf_taste
 jmp player_anzeigen 

Fehler_kein_FPGASID
 jsr error_anzeige
 ldx #$00
 loop_f4 
  lda text_Fehler_kein_FPGASID_1,x
  sta posfehlermeldung,x
  lda text_Fehler_kein_FPGASID_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_kein_FPGASID_3,x
  sta posfehlermeldung+80,x
  lda text_Fehler_kein_FPGASID_4,x
  sta posfehlermeldung+120,x
  lda text_Fehler_kein_FPGASID_5,x
  sta posfehlermeldung+160,x
  lda text_Fehler_kein_FPGASID_6,x
  sta posfehlermeldung+280,x
  lda text_Fehler_kein_FPGASID_7,x
  sta posfehlermeldung+320,x
  lda text_Fehler_kein_FPGASID_8,x
  sta posfehlermeldung+360,x
  lda text_Fehler_kein_FPGASID_9,x
  sta posfehlermeldung+400,x
  lda text_Fehler_kein_FPGASID_0,x
  sta posfehlermeldung+440,x
  lda leerzeile,x
  sta posfehlermeldung+200,x
  sta posfehlermeldung+240,x
  sta posfehlermeldung+480,x
  sta posfehlermeldung+520,x
  inx
  cpx #38
 bne loop_f4
 jsr warte_auf_taste
 jmp player_anzeigen 

Fehler_TVnorm_falsch 
 jsr error_anzeige
 ldx #$00
 loop_f5 
  lda text_Fehler_TVnorm_falsch_1,x
  sta posfehlermeldung,x
  lda text_Fehler_TVnorm_falsch_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_TVnorm_falsch_3,x
  sta posfehlermeldung+80,x
  lda text_Fehler_TVnorm_falsch_4,x
  sta posfehlermeldung+120,x
  lda text_Fehler_TVnorm_falsch_5,x
  sta posfehlermeldung+200,x
  lda text_Fehler_TVnorm_falsch_6,x
  sta posfehlermeldung+280,x
  lda text_Fehler_TVnorm_falsch_7,x
  sta posfehlermeldung+320,x
  lda text_Fehler_TVnorm_falsch_8,x
  sta posfehlermeldung+360,x
  lda text_Fehler_TVnorm_falsch_9,x
  sta posfehlermeldung+400,x
  lda text_Fehler_TVnorm_falsch_0,x
  sta posfehlermeldung+480,x
  lda leerzeile,x
  sta posfehlermeldung+160,x
  sta posfehlermeldung+240,x
  sta posfehlermeldung+440,x
  sta posfehlermeldung+520,x
  inx
  cpx #38
 bne loop_f5
 jsr warte_auf_taste
 jmp player_anzeigen

Fehler_Rekorder_kein_Speicher
 jsr error_anzeige  
 jsr playlist_leeren
 ldx #$00
 loop_f6 
  lda text_Fehler_REU_voll_1,x
  sta posfehlermeldung,x
  lda text_Fehler_REU_voll_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_REU_voll_3,x
  sta posfehlermeldung+280,x
  lda text_Fehler_REU_voll_4,x
  sta posfehlermeldung+320,x
  inx
  cpx #38
 bne loop_f6
 jsr warte_auf_taste
 jmp player_anzeigen
 
Fehler_rec_version_datei_falsch
 jsr error_anzeige  
 jsr playlist_leeren
 ldx #$00
 loop_f7 
  lda text_Fehler_rec_Version_falsch_1,x
  sta posfehlermeldung,x
  lda text_Fehler_rec_Version_falsch_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_rec_Version_falsch_3,x
  sta posfehlermeldung+80,x
  lda text_Fehler_rec_Version_falsch_4,x
  sta posfehlermeldung+120,x
  lda text_Fehler_rec_Version_falsch_5,x
  sta posfehlermeldung+280,x
  lda text_Fehler_rec_Version_falsch_6,x
  sta posfehlermeldung+320,x
  lda text_Fehler_rec_Version_falsch_7,x
  sta posfehlermeldung+360,x
  lda text_Fehler_rec_Version_falsch_8,x
  sta posfehlermeldung+400,x
  lda text_Fehler_rec_Version_falsch_9,x
  sta posfehlermeldung+440,x
  inx
  cpx #38
 bne loop_f7
 jsr warte_auf_taste
 jmp player_anzeigen
 
Fehler_leere_Breadamp_Datei_kein_FPGASID
 jsr error_anzeige  
 jsr playlist_leeren
 ldx #$00
 loop_f8 
  lda text_Fehler_leere_Breadamp_Datei_kein_FPGASID_1,x
  sta posfehlermeldung,x
  lda text_Fehler_leere_Breadamp_Datei_kein_FPGASID_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_leere_Breadamp_Datei_kein_FPGASID_3,x
  sta posfehlermeldung+80,x
  lda text_Fehler_leere_Breadamp_Datei_kein_FPGASID_4,x
  sta posfehlermeldung+280,x
  lda text_Fehler_leere_Breadamp_Datei_kein_FPGASID_5,x
  sta posfehlermeldung+320,x
  lda text_Fehler_leere_Breadamp_Datei_kein_FPGASID_6,x
  sta posfehlermeldung+360,x
  inx
  cpx #38
 bne loop_f8
 jsr warte_auf_taste
 jmp player_anzeigen
  
Fehler_UA_nicht_vorh
 jsr error_anzeige
 ldx #$00
 loop_f9 
  lda text_Fehler_kein_UA_1,x
  sta posfehlermeldung,x
  lda text_Fehler_kein_UA_2,x
  sta posfehlermeldung+40,x
  lda text_Fehler_kein_UA_3,x
  sta posfehlermeldung+80,x
  lda text_Fehler_kein_UA_4,x
  sta posfehlermeldung+120,x
  lda text_Fehler_kein_UA_5,x
  sta posfehlermeldung+280,x
  lda text_Fehler_kein_UA_6,x
  sta posfehlermeldung+320,x
  lda text_Fehler_kein_UA_7,x
  sta posfehlermeldung+360,x
  lda text_Fehler_kein_UA_8,x
  sta posfehlermeldung+400,x
  lda text_Fehler_kein_UA_9,x
  sta posfehlermeldung+440,x
  inx
  cpx #38
 bne loop_f9
 jsr warte_auf_taste
 jmp player_anzeigen 
 
 
anzeige_player_stop
 jsr stopped_anzeige
 jsr playlist_leeren
 ldx #$00
 loop_aps 
  lda text_Playerstop_1,x
  sta posfehlermeldung,x
  lda text_Playerstop_2,x
  sta posfehlermeldung+40,x
  lda text_Playerstop_3,x
  sta posfehlermeldung+80,x
  lda text_Playerstop_4,x
  sta posfehlermeldung+280,x
  lda text_Playerstop_5,x
  sta posfehlermeldung+320,x
  lda text_Playerstop_6,x
  sta posfehlermeldung+360,x
  inx
  cpx #38
 bne loop_aps
 lda #0                ;nach Neuladen der REU erneut angezeigen, wenn kein FPGASID vorhanden ist, aber FPGASID-Tracks in der Datei sind
 sta fpgasid_fehlt 
 lda #%11011111 
 sta $DC00
 Anzeige_player_stop_warte_auf_Taste_P
 lda $DC01
 cmp #%11111101
 bne Anzeige_player_stop_warte_auf_Taste_P
 lda #1
 sta taste     ;Tastenwiederholsperre, damit der Player beim Start nicht gleich wieder auf Pause geht
 jmp player_anzeigen
 
anzeige_REU_loeschen 
 jsr playlist_leeren
 ldx #$00
 loop_arl 
  lda text_REU_loeschen_1,x
  sta posfehlermeldung,x
  lda text_REU_loeschen_2,x
  sta posfehlermeldung+80,x
  inx
  cpx #38
 bne loop_arl
 rts

playlist_leeren    ;fuer Fehlermeldungen
 ldx #0
 loop_playlist_leeren
  lda #$20         ;Leerzeichen
  sta posfehlermeldung,x
  sta posfehlermeldung+40,x
  sta posfehlermeldung+80,x
  sta posfehlermeldung+120,x
  sta posfehlermeldung+160,x
  sta posfehlermeldung+200,x
  sta posfehlermeldung+240,x
  sta posfehlermeldung+280,x
  sta posfehlermeldung+320,x
  sta posfehlermeldung+360,x
  sta posfehlermeldung+400,x
  sta posfehlermeldung+440,x
  sta posfehlermeldung+480,x
  sta posfehlermeldung+520,x
  inx
  cpx #38
 bne loop_playlist_leeren
 lda #93          ;senkrechte Striche zwecks Entfernung der Bildschirmteilung durch die Infoleiste
 sta posfehlermeldung+479
 sta posfehlermeldung+518 
 rts
  
;Error-Anzeige im Display
error_1 !byte 32,32,146,147,32,32,32,32,32,32,32,32,32,32,32
error_2 !byte 32,32,166,168,165,168,165,168,165,172,165,168,32,32,32
error_3 !byte 32,32,152,154,150,32,150,32,152,155,150,32,32,32,32
error_anzeige
ldx #0
loop_error
 lda error_1,x 
 sta 1187,x
 lda error_2,x
 sta 1227,x
 lda error_3,x
 sta 1267,x
 inx
 cpx #15
bne loop_error
rts

;Stopped-Anzeige im Display
stopped_1 !byte 146,147,145, 32,146,149,146,149,146,149,146,147, 32,148,32
stopped_2 !byte 162,172,166,168,164,171,166,169,166,169,166,168,165,173,32
stopped_3 !byte 151,155,152,154,152,155,150, 32,150, 32,152,154,152,155,32
stopped_anzeige
ldx #0
loop_stopped
 lda stopped_1,x 
 sta 1187,x
 lda stopped_2,x
 sta 1227,x
 lda stopped_3,x
 sta 1267,x
 inx
 cpx #15
bne loop_stopped
rts

;auf Tastendruck warten
warte_auf_taste
lda #%00000000          ;alle Spalten durchschalten, um zu pruefen, ob irgendeine Taste gedrueckt ist
sta $DC00               ;erstmal warten, bis Taste losgelassen ist und dann erneut pruefen (Wiederholsperre)
lda $DC01
cmp #$FF
bne warte_auf_taste
warte_auf_taste_1
lda #%00000000          ;jetzt warten, bis wieder eine Taste gedrueckt wurde
sta $DC00
lda $DC01
cmp #$FF
beq warte_auf_taste_1
rts

;TV-Norm (PAL oder NTSC) entsprechend Dateimetadaten initialisieren
tvnorm_init_track   ;Parameter, die von der TV-Norm der Datei abhaengen (in x muss die Tracknummer stehen)
  lda track_tvnorm,x 
  cmp #0
  bne tvnorm_init_datei_NTSC_1
  jmp tvnorm_init_datei_PAL  ;Workaround wegen Sprungweitenlimit von bne
  tvnorm_init_datei_NTSC_1
  jmp tvnorm_init_datei_NTSC
  tvnorm_init_datei_PAL
  
  ;PAL
  ;Sampleraten im "BCD-kHz-x100Hz-Format"
  lda #$F6          ;15,6 kHz
  sta lup_srate
  lda #$B7          ;11,7 kHz
  sta lup_srate+1
  lda #$78          ; 7,8 kHz
  sta lup_srate+2
  lda #$58          ; 5,8 kHz
  sta lup_srate+3
  
  ;Lookuptabelle fuer Spielzeitberechnung
  lda #$3D          ;15638 Hz Mono
  sta lup_sr_m
  lda #$16
  sta lup_sr_l
  lda #$2D          ;11728 Hz Mono
  sta lup_sr_m+1
  lda #$D0
  sta lup_sr_l+1
  lda #$1E          ;7819 Hz Mono
  sta lup_sr_m+2
  lda #$8B
  sta lup_sr_l+2
  lda #$16          ;5864 Hz Mono
  sta lup_sr_m+3
  lda #$E8
  sta lup_sr_l+3
  
  lda #$7A          ;15638 Hz Stereo (nur Ultimate Audio)
  sta lup_sr_st_m
  lda #$2C
  sta lup_sr_st_l
  lda #$5B          ;11728 Hz Stereo
  sta lup_sr_st_m+1
  lda #$A0
  sta lup_sr_st_l+1
  lda #$3D          ;7819 Hz Stereo
  sta lup_sr_st_m+2
  lda #$16
  sta lup_sr_st_l+2
  lda #$2D          ;5864 Hz Stereo
  sta lup_sr_st_m+3
  lda #$D0
  sta lup_sr_st_l+3
  lda #$0F          ;7819 Hz 4bit
  sta lup_sr_4b_h+2
  lda #$46
  sta lup_sr_4b_l+2
  lda #$0B          ;5864 Hz 4bit
  sta lup_sr_4b_h+3
  lda #$74
  sta lup_sr_4b_l+3
  rts

tvnorm_init_datei_NTSC
  ;NTSC
  ;Sampleraten im "BCD-kHz-x100Hz-Format"
  lda #$F7          ;15,7 kHz
  sta lup_srate
  lda #$B7          ;11,8 kHz - nicht unterstuetzte Samplerate, s.o.
  sta lup_srate+1
  lda #$78          ; 7,8 kHz
  sta lup_srate+2
  lda #$58          ; 5,9 kHz - nicht unterstuetzte Samplerate, s.o.
  sta lup_srate+3
  ;Lookuptabelle fuer Spielzeitberechnung
  lda #$3D          ;15734 Hz Mono
  sta lup_sr_m
  lda #$76
  sta lup_sr_l
  lda #$2E          ;11800 Hz Mono - nicht unterstuetzte Samplerate, s.o.
  sta lup_sr_m+1
  lda #$18
  sta lup_sr_l+1
  lda #$1E          ;7867 Hz Mono
  sta lup_sr_m+2
  lda #$BB
  sta lup_sr_l+2
  lda #$17          ;5900 Hz Mono - nicht unterstuetzte Samplerate, s.o.
  sta lup_sr_m+3
  lda #$0C
  sta lup_sr_l+3
  
  lda #$7A          ;15734 Hz Stereo (nur Ultimate Audio)
  sta lup_sr_st_m
  lda #$EC
  sta lup_sr_st_l
  lda #$5C          ;11800 Hz Stereo - nicht unterstuetzte Samplerate, s.o.
  sta lup_sr_st_m+1
  lda #$30
  sta lup_sr_st_l+1
  lda #$3D          ;7867 Hz Stereo
  sta lup_sr_st_m+2
  lda #$76
  sta lup_sr_st_l+2
  lda #$2E          ;5900 Hz Stereo - nicht unterstuetzte Samplerate, s.o.
  sta lup_sr_st_m+3
  lda #$18
  sta lup_sr_st_l+3
  lda #$0F          ;7867 Hz 4bit
  sta lup_sr_4b_h+2
  lda #$5D
  sta lup_sr_4b_l+2
  lda #$0B          ;5900 Hz 4bit - nicht unterstuetzte Samplerate, s.o.
  sta lup_sr_4b_h+3
  lda #$86
  sta lup_sr_4b_l+3
  rts
  
tvnorm_init_c64   ;Parameter, die von der TV-Norm des C64 abhängen
  lda tvnorm_c64 
  cmp #0
  bne tvnorm_init_c64_NTSC
  
  ;PAL 
  ;Takte zwischen den Samples
  lda #62           ;fuer 15638 Hz, immer eins weniger als die berechnete Taktanzahl (z.B. bei 63 wird der Wert 62 angegeben)
  sta lup_takte 
  lda #83           ;fuer 11728 Hz
  sta lup_takte+1
  lda #125          ;fuer 7819 Hz
  sta lup_takte+2
  lda #167          ;fuer 5864 Hz
  sta lup_takte+3
  rts 

  ;NTSC
  tvnorm_init_c64_NTSC
  ;Takte zwischen den Samples
  lda #64           ;fuer 15734 Hz, immer eins weniger als die berechnete Taktanzahl (z.B. bei 63 wird der Wert 62 angegeben)
  sta lup_takte 
  lda #86           ;fuer 11800 Hz - nicht unterstuetzte Samplerate, wird dennoch genutzt, um PAL-Dateien "mehr oder weniger" unter NTSC abspielen zu koennen
  sta lup_takte+1
  lda #129          ;fuer 7867 Hz
  sta lup_takte+2
  lda #172          ;fuer 5900 Hz - nicht unterstuetzte Samplerate, s.o.
  sta lup_takte+3
  rts

te_cursorblinken
  dec te_timer
  bne te_cursorblinken_ende
  lda te_blinkzeit          ;Cursor blinken lassen
  sta te_timer
  ldx te_crsrpos
  lda te_cursor
  bne te_cursor_1
 
  lda #$40
  te_adr_2 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  lda #1
  sta te_cursor
  jmp te_cursorblinken_ende
 
  te_cursor_1
  lda te_char
  te_adr_3 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  lda #0
  sta te_cursor 
  te_cursorblinken_ende
  rts

 ;Formatanzeigen
    statusanzeigen 
    lda pause 
    bne status_abbruch
    lda statusanzeige
    bne statusanzeige_start
    status_abbruch
    jmp status_ende
    
    statusanzeige_start
    lda #3                      ;Status 3 Sekunden anzeigen (wenn statusanzeige = 1)
    sta status_zeit
    
    ldx track
    lda track_sidtyp,x 
    beq status_sid_manuell 
    cmp #1
    beq status_sid_6581
    cmp #2
    beq status_sid_8580
    cmp #3
    beq status_sid_FPGA
    cmp #4
    beq status_digimax
    cmp #5
    beq status_sid_6_8
    cmp #7
    beq status_ultimate_audio
    
   
     lda #190                   ;8580+6581 im Stereomode "8+6"
     sta posstatusanzeige
     lda #191
     sta posstatusanzeige+1
     jmp status_auto_manuell
    
     status_sid_manuell
     lda fpgasid_vorh
     bne status_sid_manuell_1
     lda #32                    ;leer wenn keine SID-Angabe in Metadaten und kein FPGASID vorhanden 
     sta posstatusanzeige
     sta posstatusanzeige+1
     jmp status_auto_manuell  
     status_sid_manuell_1
     lda sidmanuell
     beq status_sid_6581
    
     status_sid_8580
     lda #184 ;"8580"
     sta posstatusanzeige
     lda #185
     sta posstatusanzeige+1
     jmp status_auto_manuell    
    
     status_sid_6581
     lda #182 ;"6581"
     sta posstatusanzeige
     lda #183
     sta posstatusanzeige+1
     jmp status_auto_manuell 

     status_digimax
     lda #68 ;"DM"
     sta posstatusanzeige
     lda #77
     sta posstatusanzeige+1
     jmp status_auto_manuell
     
     status_sid_FPGA
     lda #186 ;"FPGA"
     sta posstatusanzeige
     lda #187
     sta posstatusanzeige+1
     jmp status_auto_manuell   
   
     status_sid_6_8            ;6581+8580 im Stereomode  
     lda #188 ;"6+8"
     sta posstatusanzeige
     lda #189
     sta posstatusanzeige+1
     jmp status_auto_manuell
     
     status_ultimate_audio
     lda #85 ;"UA"
     sta posstatusanzeige
     lda #65
     sta posstatusanzeige+1
     

    status_auto_manuell     
    lda fpgasid_vorh
    bne status_auto_manuell_1
     ;status_format - wird ausgewertet, wenn kein FPGASID vorhanden
     lda track_format,x
     cmp #1
     beq status_format_mahoney
     cmp #3
     beq status_format_linear
     
     lda track_sidtyp,x       ;bei Digimax auch "Lin." anzeigen
     cmp #4
     beq status_format_linear
     
     lda #32                  ;leer bei Classic 4bit
     sta posstatusanzeige+40
     sta posstatusanzeige+41
     jmp status_tvnorm
    
     status_format_mahoney
     lda #194 ;"Mah."               
     sta posstatusanzeige+40
     lda #197                  
     sta posstatusanzeige+41    
     jmp status_tvnorm

     status_format_linear
     lda #198 ;"Lin."                   
     sta posstatusanzeige+40
     lda #199                  
     sta posstatusanzeige+41    
     jmp status_tvnorm
    
     status_auto_manuell_1
     lda track_format,x
     cmp #2
     bne status_auto_manuell_1a 
     lda #32                  ;leer bei Classic 4bit
     sta posstatusanzeige+40
     sta posstatusanzeige+41
     jmp status_tvnorm
     
     status_auto_manuell_1a
     lda track_format,x       ;bei Format "Linear" dieses anstelle Auto oder Man. anzeigen
     cmp #3
     beq status_auto_manuell_1a1
     cmp #4
     beq status_auto_manuell_1a1
     jmp status_auto_manuell_1b
     status_auto_manuell_1a1
     lda #198 ;"Lin."                  
     sta posstatusanzeige+40
     lda #199                  
     sta posstatusanzeige+41    
     jmp status_tvnorm     
     status_auto_manuell_1b
     lda track_sidtyp,x
     beq status_manuell
     lda #192 ;"Auto"
     sta posstatusanzeige+40
     lda #193
     sta posstatusanzeige+41
     jmp status_tvnorm
    
     status_manuell
     lda #194 ;"Man."
     sta posstatusanzeige+40
     lda #195
     sta posstatusanzeige+41

   status_tvnorm
     lda track_sidtyp,x 
     cmp #7
     bne status_tvnorm_pal
     lda #32  ;leer bei Ultimate Audio, da UA beide TV-Normen bei allen Formaten beherrscht
     sta posstatusanzeige+80
     sta posstatusanzeige+81
     jmp status_ende
     status_tvnorm_pal
     lda track_tvnorm,x
     bne status_tvnorm_ntsc
     lda #236 ;"PAL"
     sta posstatusanzeige+80
     lda #237
     sta posstatusanzeige+81  
     jmp status_ende   
     status_tvnorm_ntsc
     lda #238 ;"NTSC"
     sta posstatusanzeige+80
     lda #239
     sta posstatusanzeige+81  
   status_ende
   rts 
  
 ;Titelnameneditor
titelnameneditor
  lda #1                     ;nur Initialisierung, der eigentliche Editor wird in der Tastaturabfrageschleife ausgefuehrt
  sta eingabemodus
  lda #0
  sta te_crsrpos
  sta te_cursor
  lda #$0E
  sta te_taste
  lda #50
  sta te_timer
  ldx track_wahl
  stx te_zeile
  lda lookup_posplaylist_h,x ;Zeilenbeginn im Bildschirmspeicher ermitteln und an die Stellen im Programm schreiben, 
  sta te_adr_0+2             ;an denen der Wert benoetigt wurde
  sta te_adr_1+2            
  sta te_adr_2+2
  sta te_adr_3+2
  sta te_adr_4+2
  sta te_adr_5+2
  sta te_adr_6+2
  sta te_adr_7+2
  sta te_adr_8+2
  sta te_adr_9+2
  sta te_adr_10+2
  sta te_adr_11+2
  sta te_adr_12+2
  sta te_adr_13+2
  sta te_adr_14+2
  sta te_adr_15+2
  sta te_adr_16+2
  sta te_adr_17+2
  sta te_adr_18+2
  sta te_adr_19+2
  sta te_zstart_h
  lda lookup_posplaylist_l,x
  clc
  adc #3                     ;eigentlichen Beginn der Zeile errechnen, kein Uebertrag noetig
  sta te_adr_0+1
  sta te_adr_1+1
  sta te_adr_2+1
  sta te_adr_3+1
  sta te_adr_4+1
  sta te_adr_5+1
  sta te_adr_6+1
  sta te_adr_7+1
  sta te_adr_8+1
  sta te_adr_9+1
  sta te_adr_10+1
  sta te_adr_11+1
  sta te_adr_12+1
  sta te_adr_13+1
  sta te_adr_14+1
  sta te_adr_15+1
  sta te_adr_16+1
  sta te_adr_17+1
  sta te_adr_18+1
  sta te_adr_19+1
  sta te_zstart_l
  ldx #0
  te_adr_0 lda $0000,x       ;ersten Char aus dem Bildschirmspeicher holen
  sta te_char
  te_init_backup             ;Backup des Titelnamens anlegen (wird bei Abbruch wiederhergestellt)
  sta te_backup,x
  inx
  te_adr_1 lda $0000,x       ;weitere Chars zum Sichern laden
  cpx #29
  bne te_init_backup
  rts
 
 eingabemodus_titelnameneditor
  ;pruefen, ob eine Shifttaste gedrueckt ist
 lda #0
 sta shift
 lda #%11111101          ;linke Shifttaste
 sta $DC00
 lda $DC01
 ora #%01111111
 cmp #%01111111
 bne te_shift_rechts 
 lda #1
 sta shift  ;linke shifttaste gedrueckt
 jmp te_tastaturmatrix
 te_shift_rechts
 lda #%10111111          ;rechte Shifttaste
 sta $DC00
 lda $DC01
 ora #%11101111
 cmp #%11101111
 bne te_tastaturmatrix
 lda #2
 sta shift  ;rechte shifttaste gedrueckt
 
 ;Tastaturmatrixencoding 0Sssszzz S = Shift, s = Spalte, z = Zeile
 te_tastaturmatrix
 ldx #%11111110 ;Spalte 0 - es müssen alle Spalten auf eine gedrückte Taste untersucht werden
 stx $DC00
 lda $DC01
 cmp #$FF
 bne titelnameneditor_zeile   ;wenn in dieser Spalte eine Taste gedrückt, dann gehe zur Zeilenprüfung
 ldx #%11111101 ;Spalte 1
 stx $DC00
 lda $DC01
 cmp #$FF
 beq titelnameneditor_spalte_2 ;Shift links-Filter, wenn nichts gedrueckt ist, suche in Spalte 2 weiter
 eor #%01111111
 beq titelnameneditor_spalte_2 ;wenn nur Shift links in Spalte 1 gedrueckt ist, suche in Spalte 2 weiter
 lda $DC01
 jmp titelnameneditor_zeile    ;ansonsten durchsuche die Zeilen
 titelnameneditor_spalte_2 
 ldx #%11111011 ;Spalte 2
 stx $DC00
 lda $DC01
 cmp #$FF
 bne titelnameneditor_zeile 
 ldx #%11110111 ;Spalte 3
 stx $DC00
 lda $DC01
 cmp #$FF
 bne titelnameneditor_zeile 
 ldx #%11101111 ;Spalte 4
 stx $DC00
 lda $DC01
 cmp #$FF
 bne titelnameneditor_zeile 
 ldx #%11011111 ;Spalte 5
 stx $DC00
 lda $DC01
 cmp #$FF
 bne titelnameneditor_zeile 
 ldx #%10111111 ;Spalte 6
 stx $DC00
 lda $DC01
 cmp #$FF
 beq titelnameneditor_spalte_7 ;Shift rechts-Filter, wenn nichts gedrueckt ist, suche in Spalte 7 weiter
 eor #%11101111
 beq titelnameneditor_spalte_7 ;wenn nur Shift rechts in Spalte 1 gedrueckt ist, suche in Spalte 7 weiter
 lda $DC01
 jmp titelnameneditor_zeile    ;ansonsten durchsuche die Zeilen
 titelnameneditor_spalte_7  
 ldx #%01111111 ;Spalte 7
 stx $DC00
 lda $DC01
 cmp #$FF
 bne titelnameneditor_zeile 
 lda shift
 beq titelnameneditor_keine_taste
 lda #0                        ;nur Shift wird wie kein Tastendruck gewertet -> Flag Taste zuruecksetzen
 sta te_taste
 titelnameneditor_keine_taste
 rts                           ;wenn keine Taste mehr gedrueckt ist
 
 titelnameneditor_zeile  ;Spalte in x, Zeile in a
 ;Korrektur bei gedrueckter Shift-Taste
 sta temp 
 lda shift
  cmp #1
  bne te_zeile_shift_pruefung_2
  lda temp
  cpx #%11111101
  bne te_zeile_1
  ora #%10000000
  jmp te_zeile_1
 te_zeile_shift_pruefung_2
  lda shift
  cmp #2
  bne te_zeile_shift_pruefung_ende
  lda temp
  cpx #%10111111 
  bne te_zeile_1 
  ora #%00010000
  jmp te_zeile_1
 te_zeile_shift_pruefung_ende
  lda temp

 te_zeile_1
 cmp #%11111110 ;Zeile 0
 bne te_tastenpruefung_zeile_1
 lda #%000
 jmp te_tastenpruefung_zeile_ende
 te_tastenpruefung_zeile_1
 cmp #%11111101 ;Zeile 1
 bne te_tastenpruefung_zeile_2
 lda #%001
 jmp te_tastenpruefung_zeile_ende 
 te_tastenpruefung_zeile_2
 cmp #%11111011 ;Zeile 2
 bne te_tastenpruefung_zeile_3
 lda #%010
 jmp te_tastenpruefung_zeile_ende 
 te_tastenpruefung_zeile_3
 cmp #%11110111 ;Zeile 3
 bne te_tastenpruefung_zeile_4
 lda #%011
 jmp te_tastenpruefung_zeile_ende 
 te_tastenpruefung_zeile_4
 cmp #%11101111 ;Zeile 4
 bne te_tastenpruefung_zeile_5
 lda #%100
 jmp te_tastenpruefung_zeile_ende
 te_tastenpruefung_zeile_5
 cmp #%11011111 ;Zeile 5
 bne te_tastenpruefung_zeile_6
 lda #%101
 jmp te_tastenpruefung_zeile_ende 
 te_tastenpruefung_zeile_6
 cmp #%10111111 ;Zeile 6
 bne te_tastenpruefung_zeile_7
 lda #%110
 jmp te_tastenpruefung_zeile_ende 
 te_tastenpruefung_zeile_7
 cmp #%01111111 ;Zeile 7
 bne te_tastenpruefung_zeile_keine
 lda #%111
 jmp te_tastenpruefung_zeile_ende
 te_tastenpruefung_zeile_keine
 rts
 
 te_tastenpruefung_zeile_ende  ;in a ist jetzt die Zeile codiert (00000zzz)
 cpx #%11111110 ;Spalte 0
 bne te_tastenpruefung_spalte_1 
 clc
 adc #%000000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_1  
 cpx #%11111101 ;Spalte 1
 bne te_tastenpruefung_spalte_2 
 clc
 adc #%001000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_2  
 cpx #%11111011 ;Spalte 2
 bne te_tastenpruefung_spalte_3 
 clc
 adc #%010000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_3  
 cpx #%11110111 ;Spalte 3
 bne te_tastenpruefung_spalte_4 
 clc
 adc #%011000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_4  
 cpx #%11101111 ;Spalte 4
 bne te_tastenpruefung_spalte_5 
 clc
 adc #%100000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_5  
 cpx #%11011111 ;Spalte 5
 bne te_tastenpruefung_spalte_6 
 clc
 adc #%101000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_6  
 cpx #%10111111 ;Spalte 6
 bne te_tastenpruefung_spalte_7 
 clc
 adc #%110000
 jmp te_tastenpruefung_spalte_ende
 te_tastenpruefung_spalte_7  
 clc
 cpx #%01111111 ;Spalte 7
 bne te_tastenpruefung_spalte_7 
 clc
 adc #%111000
 
 te_tastenpruefung_spalte_ende
 ldx shift
 beq te_tastenpruefung_fertig 
 clc
 adc #%1000000
 
 te_tastenpruefung_fertig  
 sta gedr_taste
 ldx gedr_taste
 lda lookup_tastatur,x
 cmp te_taste              ;Tastenwiederholsperre
 bne te_tastaturauswertung
 rts
 
 te_tastaturauswertung
 sta te_taste
 cmp #$F0
 beq te_taste_ignorieren
 cmp #$F1
 beq te_taste_crsr_links
 cmp #$F2
 beq te_taste_crsr_rechts
 cmp #$F3
 beq te_taste_home
 cmp #$F4
 beq te_taste_shift_home
 cmp #$FA
 beq te_taste_stop
 cmp #$FD
 beq te_taste_del
 cmp #$FE
 beq te_taste_inst
 cmp #$FF
 beq te_taste_return
 jmp te_taste_schreiben
 te_taste_ignorieren
 rts
 
 te_taste_crsr_links
  ldx te_crsrpos
  beq te_taste_ignorieren
  lda te_char
  te_adr_4 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  dec te_crsrpos
  dex
  te_adr_5 lda $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  sta te_char
  rts
  
 te_taste_crsr_rechts
  ldx te_crsrpos
  cpx #28
  beq te_taste_ignorieren 
  lda te_char
  te_adr_6 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  inc te_crsrpos
  inx
  te_adr_7 lda $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  sta te_char
  rts
  
 te_taste_home             ;Cursor an Zeilenanfang setzen
  ldx te_crsrpos
  lda te_char
  te_adr_10 sta $0000,x     ;Adresse wurde bei der Initialisierung festgelegt  
  ldx #0
  stx te_crsrpos
  te_adr_11 lda $0000,x     ;Adresse wurde bei der Initialisierung festgelegt
  sta te_char 
  rts 
  
 te_taste_shift_home       ;Zeile loeschen
  ldx #0
  stx te_crsrpos
  te_taste_shift_home_1
  lda #$20                  ;Leerzeichen
  te_adr_12 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt  
  inx
  cpx #29
  bne te_taste_shift_home_1
  sta te_char
  rts 
 
 te_taste_stop              ;ab hier Verzweigung mittels jmps, da beq nur max. 127 Bytes nach vorn springen kann
  jmp te_taste_stop_jmp 
 te_taste_del
  jmp te_taste_del_jmp
 te_taste_inst
  jmp te_taste_inst_jmp
 te_taste_return
  jmp te_taste_return_jmp

 te_taste_stop_jmp         ;stellt urspruengliche Zeile wieder her und beendet Eingabe
  ldx #0
  te_taste_abbruch_1
  lda te_backup,x
  te_adr_13 sta $0000,x     ;Adresse wurde bei der Initialisierung festgelegt 
  inx
  cpx #29
  bne te_taste_abbruch_1
  lda #0  
  sta eingabemodus
  lda #1                    ;verhindert, dass der Player beim Abbruch des Titelnameneditors gestoppt wird
  sta taste                 
  rts
  
 te_taste_del_jmp           ;ein Zeichen loeschen, folgende Zeichen nach links verschieben
  ldx te_crsrpos
  bne te_taste_del_weiter    ;wenn Cursor an Position 0, dann Del ignorieren
  rts
  te_taste_del_weiter
  dec te_crsrpos
  lda te_char
  te_taste_del_loop
  dex
  te_adr_14 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  inx
  inx
  te_adr_15 lda $0000,x      ;Adresse wurde bei der Initialisierung festgelegt  
  cpx #30
  bne te_taste_del_loop
  rts
   
 te_taste_inst_jmp           ;Leerzeichen einfuegen, folgende Zeichen nach rechts verschieben
  ldx te_crsrpos
  cpx #28
  beq te_taste_inst_pos28    ;wenn Cursor an Position 28, dann Inst ignorieren
  lda te_char
  te_adr_16 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  ldx #28
  te_taste_inst_loop
  dex  
  te_adr_17 lda $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  inx
  te_adr_18 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  dex
  cpx te_crsrpos
  bne te_taste_inst_loop
  te_taste_inst_pos28
  lda #$20
  sta te_char
  te_adr_19 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt  
  rts
   
 te_taste_return_jmp        ;Eingabe beenden
  ldx te_crsrpos
  lda te_char
  te_adr_8 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  lda #0
  sta eingabemodus
  lda rec_aufnahme          ;wenn eine Aufnahme laeuft, wird nicht in die REU gespeichert, das erledigt der Recorder nach der Aufnahme
  beq te_speichern
  rts
  ;Eintrag in REU speichern
  te_speichern
  lda #%00000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;deaktivieren (Player stoppen, um "Datensalat" zu vermeiden)
  
  ldx #0
  te_taste_return_reu_bu    ;Parameter der REU sichern
  lda REU_C64Lo,x
  sta te_backup,x
  inx
  cpx #7
  bne te_taste_return_reu_bu
  
  lda trackinfos_h
  sta REU_Hi
  lda trackinfos_l
  sta REU_Lo
  ldx te_zeile
  lda altern_playlist,x     ;tatsaechlich editierten Track suchen (weicht von Zeilennummer ab, wenn Trackreihenfolge geaendert)
  tax
  te_taste_return_reu_adresse
  beq te_taste_return_reu_adresse_ende
  clc 
  lda REU_Lo
  adc #$20
  sta REU_Lo
  lda REU_Hi
  adc #0
  sta REU_Hi
  dex
  jmp te_taste_return_reu_adresse
  te_taste_return_reu_adresse_ende
  
  lda #0
  sta REU_Bank
  sta REU_BytesHi
  lda #29
  sta REU_BytesLo
  ldx te_zeile
  lda lookup_posplaylist_h,x
  sta REU_C64Hi
  lda lookup_posplaylist_l,x
  clc
  adc #3
  sta REU_C64Lo
  lda #252
  sta REU_CMD
  
  ldx #0
  te_taste_return_reu_restore    ;Parameter der REU wiederherstellen
  lda te_backup,x
  sta REU_C64Lo,x
  inx
  cpx #7
  bne te_taste_return_reu_restore
  lda REU_Bank1
  sta REU_Bank
  
  lda pause
  bne taste_return_pause
  lda #%10000001            ;IRQ fuer Timer-A 
  sta $dd0d                 ;aktivieren (Wiedergabe fortsetzen, wenn Player nicht in Pause ist)
  taste_return_pause
  rts
  
 te_taste_schreiben
  ldx te_crsrpos
  te_adr_9 sta $0000,x      ;Adresse wurde bei der Initialisierung festgelegt
  sta te_char 
  jmp te_taste_crsr_rechts

 
 
  
  
;------------------ Texte ------------------------
text_breadamp
!text "BREADAMP"
text_track
!text "TRACK "
text_reserved_entry
!text "reserved entry  "
text_REU_header_formatieren_1                     ;Standardwerte fuer REU-Datei ohne Tracks
!text "BREADAMP03REUFS" 
!byte $0F
text_REU_header_formatieren_2
!text "TRACKINFOS"
!byte $00,$01,$00,$00,$01,$C0
       
text_Fehler_kein_breadamp_file_1
!scr "No BREADAMP file loaded in the REU    "
text_Fehler_kein_breadamp_file_2
!scr "or REU not enabled !                  "
text_Fehler_kein_breadamp_file_3
!scr "Enable the REU, disable other cart-   " 
text_Fehler_kein_breadamp_file_4
!scr "ridges, load a BREADAMP file into the "
text_Fehler_kein_breadamp_file_5
!scr "REU and press any key to continue.    "
text_Fehler_kein_breadamp_file_6
!scr "Keine BREADAMP-Datei in der REU       "
text_Fehler_kein_breadamp_file_7
!scr "oder REU nicht aktiviert !            "
text_Fehler_kein_breadamp_file_8
!scr "Aktiviere die REU, deaktiviere andere "
text_Fehler_kein_breadamp_file_9
!scr "Module, lade eine BREADAMP-Datei in   "
text_Fehler_kein_breadamp_file_0
!scr "die REU und druecke eine Taste.       "

text_Fehler_falsche_version_1
!scr "This BREADAMP file is made for version"
text_Fehler_falsche_version_2
!scr "?? of BREADAMP !                      "
text_Fehler_falsche_version_3
!scr "Please load that version of BREADAMP  "
text_Fehler_falsche_version_4
!scr "to be able to play the file.          "
text_Fehler_falsche_version_5
!scr "Diese BREADAMP-Datei ist fuer Version "
text_Fehler_falsche_version_6
!scr "?? von BREADAMP !                     "
text_Fehler_falsche_version_7
!scr "Bitte lade diese Version von BREADAMP,"
text_Fehler_falsche_version_8
!scr "um die Datei abspielen zu koennen.    "

text_Fehler_in_der_datei_1
!scr "Error in the loaded BREADAMP file !   "
text_Fehler_in_der_datei_2
!scr "Please load another file into the REU "
text_Fehler_in_der_datei_3
!scr "and press any key to continue.        "
text_Fehler_in_der_datei_4
!scr "Fehler in geladener BREADAMP-Datei !  "
text_Fehler_in_der_datei_5
!scr "Bitte lade eine andere in die REU und "
text_Fehler_in_der_datei_6
!scr "druecke eine Taste zum Fortfahren.    "

text_Fehler_kein_FPGASID_1
!scr "File contains track(s) for FPGASID    "
text_Fehler_kein_FPGASID_2
!scr "only, but no FPGASID was found ! Those"
text_Fehler_kein_FPGASID_3
!scr "tracks will play silent. Load another "
text_Fehler_kein_FPGASID_4
!scr "file into the REU and/or press any key"
text_Fehler_kein_FPGASID_5
!scr "to continue.                          "
text_Fehler_kein_FPGASID_6
!scr "Datei enthaelt Track(s), die nur mit  "
text_Fehler_kein_FPGASID_7
!scr "FPGASID Ton ausgeben, aber es wurde   "
text_Fehler_kein_FPGASID_8
!scr "kein FPGASID gefunden ! Lade eine an- "
text_Fehler_kein_FPGASID_9
!scr "dere Datei in die REU und/oder druecke"
text_Fehler_kein_FPGASID_0
!scr "eine beliebige Taste zum Fortfahren.  "

text_Fehler_TVnorm_falsch_1
!scr "TV system mismatch ! File is for xxxx,"
text_Fehler_TVnorm_falsch_2
!scr "but your C64 is yyyy.  BREADAMP will  "
text_Fehler_TVnorm_falsch_3
!scr "play the file anyway, but distortions "
text_Fehler_TVnorm_falsch_4
!scr "of the sound may occur.               "
text_Fehler_TVnorm_falsch_5
!scr "Press any key to continue.            "
text_Fehler_TVnorm_falsch_6
!scr "Falsche TV-Norm ! Datei ist fuer xxxx,"
text_Fehler_TVnorm_falsch_7
!scr "aber dein C64 ist yyyy.  BREADAMP wird"
text_Fehler_TVnorm_falsch_8
!scr "die Datei trotzdem abspielen, aber es "
text_Fehler_TVnorm_falsch_9
!scr "kann zu Tonstoerungen kommen.         "
text_Fehler_TVnorm_falsch_0
!scr "Druecke eine Taste zum Fortfahren.    "

text_Fehler_REU_voll_1
!scr "REU full. Recording not possible.     "
text_Fehler_REU_voll_2
!scr "Press any key to restart the player.  " 
text_Fehler_REU_voll_3
!scr "REU voll. Aufnahme nicht moeglich.    "
text_Fehler_REU_voll_4
!scr "Druecke eine Taste fuer Playerstart.  "

text_Fehler_rec_Version_falsch_1
!scr "Recording not possible in files for   "
text_Fehler_rec_Version_falsch_2
!scr "v02. Press any key for player restart."
text_Fehler_rec_Version_falsch_3
!scr "Then you can press C=+Shift+F to      "
text_Fehler_rec_Version_falsch_4
!scr "format the file and record into it.   "
text_Fehler_rec_Version_falsch_5
!scr "Aufnahmen in Dateien fuer v02 nicht   "
text_Fehler_rec_Version_falsch_6
!scr "moeglich. Druecke eine Taste zum Neu- "
text_Fehler_rec_Version_falsch_7
!scr "starten des Players. Danach kannst du "
text_Fehler_rec_Version_falsch_8
!scr "mit C=+Shift+F die Datei formatieren  "
text_Fehler_rec_Version_falsch_9
!scr "und fuer die Aufnahme nutzen.         "

text_Fehler_leere_Breadamp_Datei_kein_FPGASID_1
!scr "REU file is empty and no FPGASID for  "
text_Fehler_leere_Breadamp_Datei_kein_FPGASID_2
!scr "recording found. Load a different REU "
text_Fehler_leere_Breadamp_Datei_kein_FPGASID_3
!scr "file and press any key to continue.   "
text_Fehler_leere_Breadamp_Datei_kein_FPGASID_4
!scr "REU-Datei leer und kein FPGASID zum   "
text_Fehler_leere_Breadamp_Datei_kein_FPGASID_5
!scr "Aufnehmen gefunden. Lade eine andere  "
text_Fehler_leere_Breadamp_Datei_kein_FPGASID_6
!scr "REU-Datei und druecke eine Taste.     "

text_Fehler_kein_UA_1
!scr "File contains track(s) for Ultimate   "
text_Fehler_kein_UA_2
!scr "Audio which is not activated. Please  "
text_Fehler_kein_UA_3
!scr "activate Ultimate Audio or load       "
text_Fehler_kein_UA_4
!scr "another REU file and press any key.   "
text_Fehler_kein_UA_5
!scr "Datei enthaelt Track(s) fuer Ultimate "
text_Fehler_kein_UA_6
!scr "Audio. Dieses ist nicht aktiviert.    "
text_Fehler_kein_UA_7
!scr "Bitte aktiviere Ultimate Audio oder   "
text_Fehler_kein_UA_8
!scr "lade eine andere REU-Datei und druecke"
text_Fehler_kein_UA_9
!scr "eine beliebige Taste zum Fortfahren.  "


text_Playerstop_1
!scr "Player stopped. You can now safely    "
text_Playerstop_2
!scr "change the reu file and then press P  "
text_Playerstop_3
!scr "to start the player.                  "
text_Playerstop_4
!scr "Player angehalten. Du kannst nun die  "
text_Playerstop_5
!scr "reu-Datei wechseln und dann P         "
text_Playerstop_6
!scr "druecken, um den Player zu starten.   "

text_REU_loeschen_1
!scr "Clearing REU. This takes 17 seconds.  "
text_REU_loeschen_2
!scr "REU wird geleert (dauert 17 Sekunden)."

leerzeile
!scr "                                      "
leerbytes 
!byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

text_PAL
!scr "PAL "
text_NTSC
!scr "NTSC"

text_rec_by_breadamp
!scr "recorded by Breadamp         "

text_rec_vor_aufnahme
!scr "F1 start rec, F7 abort, S samplerate" 
text_rec_bei_aufnahme
!scr "F7 save rec, DEL abort, N name edit." 

infotext
!scr "                                      BREADAMP - a sample music player for the Commodore 64, created 2019-2020 by daddlerTL" 
!scr "  *  Controls: 1-0: selects entry 1-10 in the tracklist, A-D: selects entry 11-14 in the tracklist, "
!scr "Cursor down/up: skips to the next/previous track, Cursor left/right or <>: rewinds/fast forwards, RUN/STOP: stops player and allows change of the .reu file without having to reload the player, "
!scr "@/;: moves cursor up/down, */=: moves track selected by cursor up/down, F: changes how the format info is displayed, "
!scr "F1/F2: changes border color, F3/F4: changes background color, F5/F6: changes text color, F7/F8: enables/disables 'disco mode' for border/background, "
!scr "P: pauses and resumes the playback, I: disables and reenables this infobar, +/-: increases/decreases the scroll "
!scr "speed of this infobar, S: changes sound output settings (see readme.txt for details), "
!scr "/: toggles control mode (keyboard + joy 2 or joy 1 + joy 2), R: enables/disables track repeat, N: enters track name editor, C=+R: starts FPGASID recorder * check readme.txt for further information                                      "
!scr "BREADAMP - ein Samplemusikplayer fuer den Commodore 64, programmiert 2019-2020 von daddlerTL" 
!scr "  *  Steuerung: 1-0: waehlt Eintrag 1-10 in der Trackliste, A-D: waehlt Eintrag 11-14 in der Trackliste, "
!scr "Cursor runter/hoch: springt zum naechsten/vorhergehenden Track, Cursor links/rechts bzw. <>: spult zurueck/vor, RUN/STOP: stoppt den Player und erlaubt den Wechsel der .reu-Datei ohne den Player neu laden zu muessen, "
!scr "@/;: bewegt Cursor hoch/runter, */=: verschiebt mit Cursor gewaehlten Track hoch/runter, F: wechselt den Anzeigemodus der Formatinfos, "
!scr "F1/F2: wechselt die Rahmenfarbe, F3/F4: wechselt die Hintergrundfarbe, F5/F6: wechselt die Textfarbe, F7/F8: (de)aktiviert 'Diskomodus' fuer Rahmen/Hintergrund, "
!scr "P: pausiert die Wiedergabe und setzt sie fort, I: deaktiviert und reaktiviert diese Infoleiste, +/-: erhoeht/verringert die "
!scr "Scrollgeschwindigkeit dieser Infoleiste, S: aendert Tonausgabeeinstellungen (siehe liesmich.txt fuer Details), "
!scr "/: schaltet Steuerungsmodus um (Tastatur + Joystick 2 oder Joystick 1 + Joystick 2), R: (de)aktiviert Titelwiederholung (Repeat), N: aktiviert Titelnameneditor, " 
!scr "C=+R: startet FPGASID-Rekorder * Weitere Informationen siehe liesmich.txt                                      "

;Lookuptabelle fuer Darstellung des 7-Segment-Displays (Anordnung: zol=Zeichen oben links fuer Ziffern 0-9, zor oben rechts usw.)
 lookup_7seg_ol  !byte 146, 32,144,144,145,146,146,144,146,146
 lookup_7seg_or  !byte 149,148,149,149,148,147,147,149,149,149
 lookup_7seg_ml  !byte 164, 32,165,161,162,162,166, 32,166,162
 lookup_7seg_mr  !byte 171,171,169,173,173,172,172,171,173,173
 lookup_7seg_ul  !byte 152, 32,152,151, 32,151,152, 32,152,151
 lookup_7seg_ur  !byte 155,153,154,155,153,155,155,153,155,155
 
;Lookuptabelle zur schnelle Hex-nach-BCD-Konvertierung (Zahlen 00 bis 99)
 lookup_hex2bcd  !byte $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19
                 !byte $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$30,$31,$32,$33,$34,$35,$36,$37,$38,$39
                 !byte $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$50,$51,$52,$53,$54,$55,$56,$57,$58,$59
                 !byte $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79
                 !byte $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$90,$91,$92,$93,$94,$95,$96,$97,$98,$99

;Lookuptabelle fuer Bildschirmspeicheradressen der Playlistzeilen                 
 lookup_posplaylist_h !byte $05,$05,$05,$06,$06,$06,$06,$06,$06,$06,$07,$07,$07,$07
 lookup_posplaylist_l !byte $91,$B9,$E1,$09,$31,$59,$81,$A9,$D1,$F9,$21,$49,$71,$99
 
;Lookuptabelle fuer Tastatureingaben im Titelnameneditor 
;($F0 = ungültig -> wird ignoriert, $F1 = Cursor links, $F2 = Cursor rechts, $F3 = Home/erstes Zeichen, $F4 = Shift+Home/Zeile löschen, $FA = Abbruch, $FD = Zeichen löschen, $FE = einfügen, $FF = Return/fertig)
 lookup_tastatur !byte $FD,$FF,$F2,$F0,$F0,$F0,$F0,$F0, $33,$17,$01,$34,$1A,$13,$05,$F0, $35,$12,$04,$36,$03,$06,$14,$18, $37,$19,$07,$38,$02,$08,$15,$16  ;Spalten 0-3 ohne Shift
                 !byte $39,$09,$0A,$30,$0D,$0B,$0F,$0E, $2B,$10,$0C,$2D,$2E,$3A,$00,$2C, $1C,$2A,$3B,$F3,$F0,$3D,$1E,$2F, $31,$1F,$F0,$32,$20,$F0,$11,$FA  ;Spalten 4-7 ohne Shift
                 !byte $FE,$F0,$F1,$F0,$F0,$F0,$F0,$F0, $23,$57,$41,$24,$5A,$53,$45,$F0, $25,$52,$44,$26,$43,$46,$54,$58, $27,$59,$47,$28,$42,$48,$55,$56  ;Spalten 0-3 mit Shift
                 !byte $29,$49,$4A,$F0,$4D,$4B,$4F,$4E, $F0,$50,$4C,$F0,$3E,$1B,$F0,$3C, $F0,$F0,$1D,$F4,$F0,$F0,$F0,$3F, $21,$F0,$F0,$22,$20,$F0,$51,$F0  ;Spalten 4-7 mit Shift
                 
 
 